# Release version 4.0.20172.271 - Jun-28-2017

##
2017 v2 Release

## C1.C1Excel

### Bug fixes

- Unlike build 267,Extra row is shown in C1FlexGrid when load the excel file by using LoadExcel method. (TFS:270393)
- Unlike build 267,'System.ArgumentException' has occurred when loading .xlsx file and saving it as .xls file. (TFS:269675)
- Unlike build 267 ,'System.OutOfMemoryException' was occurred on loading an excel file which has freeze panes. (TFS:269679)
- Different output file being generated for SaveCsv() method using 2016v3 and 2017v1 builds. (TFS:268424)
- Location of merged cells in saved excel file changes when a row's height/column's width is changed after merging in C1Excel. (TFS:268784)
- Request to provide information on how to use XLReferenceMode Enum in C1Excel. (TFS:242729)
- When a .xlsx file is load and saved just as it is, the user definition format of a cell changes. (TFS:251891)
- C1XLBook throws an unhandled exception of type 'System.ArgumentException' when loading a xslx file. (TFS:245883)
- Fixed work with print area (Excel: Seting print area). (TFS:204542)
- Request to improve performance for saving excel file. (TFS:253350)

### Improvements

- Added UseDefaultCsvEncoding property in C1XLBook (use the default encoding for CSV files), for Japanese version true by default.
- Added support XLReferenceMode.R1C1 (and ReferenceMode property for C1XLBook) for C1Excel (Request: TFS:242729)

## C1.C1Pdf

### Breaking changes

- Lengths of dashes in non-solid lines (dash, dash-dot etc) may change compared to previous versions.

### Bug fixes

- Text are cut off in pdf exported file when PrintInfo.FitHorizontally and FitVertically are set to True. (TFS:237520)
- Gradient of Ellipse is not rendered when Gradient Brush is specified to fill Ellipse. (TFS:255411)

### Improvements

- Added C1PdfDocument.SetDashPattern() method which allows to change default dash patterns for predefined dash styles.
  Added C1PdfDocument.ResetDashPatterns() method to reset dash patterns for predefined dash styles to defaults.

## C1.C1Report

### Breaking changes

- C1Report now references/requires the C1.C1Pdf.4 assembly.

## C1.C1Word

### Bug

- System.FormatException is thrown when load the word file contain bullet and use the C1.C1Word.2dll. (TFS:269585)
- [Word 2013] System.FormatException occurred when load the certain specific file. (TFS:269598)
- Footer are clipped in exported Word file with docx format. (TFS:268805)
- [JPN] Checkmark for some check mark style are not shown in expored word file. (TFS:255387)
- [JPN] CheckedSymbol are shown as number instead of CustomSymbol in exported word file. (TFS:255389)

### Bug fixes

- Text style in the original document is not retained when save it in another document. (TFS:268303)
- Header and footer are not shown when load the word document and save it in another document. (TFS:268381)
- FormatException is thrown when a word document is loaded. (TFS:261763)
- Image are not displayed in Docx format. (TFS:262936)
- Alignment of picture is not effected with Docx format. (TFS:263451)
- Image drawn by "DrawMetaFile" method is distorted when read and write in another word document with rtf format. (TFS:263844)
- Color of image drawn by "DrawMetaFile" method is not retained when read and write in another word document. (TFS:263860)
- Ellipse,Arc,Beziers and line shapes are not shown in output documents. (TFS:215107)
- PageBreak is not effected in output docx file if the C1WordDocument contain RTFPicture and RTFTable. (TFS:251877)
- RtfLineBreak between RTFTable and RTFPicture is not effected in output docx file. (TFS:251845)
- "FirstLineIndent" property is not effected in output document when save the C1WordDocument with docx format. (TFS:251784)
- "Can't Open" error is thrown when save the C1WordDocument contained RTFHeader and RTFFooter with docx format. (TFS:251776)
- Image drawn by "DrawMetaFile" method is not shown when read and write in another word document. (TFS:249571)
- CheckedSymbol are shown as number instead of CustomSymbol in exported word file. (TFS:255389)
- Checkmark for some check mark style are not shown in expored word file. (TFS:255387)

## C1.Win.BarCode

### Breaking changes

- Added the limitation, some barcode types has mandatory checksum: Code_128_A, Code_128_B, Code_128_C, Code_128auto, MSI, PostNet, UPC_A, Code_93, Code93x, EAN_8, RM4SCC, UCCEAN128.

## C1.Win.C1Command

### Bug fixes

- [TopicBar] Links of C1TopicBar was not changed to RightToLeft when RightToLeft was set as 'Yes'. (TFS:269615)
- Order of pages changes in C1OutBar when pages are clicked. (TFS:261626)
- [C1DockingTab] SelectedTabChanged is fired when form with C1DockingTab control is closed. (TFS:257122)
- OutPage was disappeared when collapsed the out page. (TFS:258311)
- NullReference Exception was thrown when all pages were removed from c1TopicBar at design time. (TFS:256353)

## C1.Win.C1Document

### Breaking changes:

- Exporting a Pdf file using C1PdfDocumentSource to Word and Excel was removed.

### Bug fixes:

- Alignment of text applied MarginLeft and Left are not equal in exported word and excel file. (TFS:268438)
- Background color of sections are not effected in output Word file with docx format. (TFS:267171)
- All borders are effected by color and width in some exported file although only one border of field is set in Design. [Excel part] (TFS:251350)
- Cell format warning are shown in exported excel file when export the field value with "Percent" format. (TFS:264813)
- "Index was outside the boundary" is shown when export the pdf file contained Arabic text to HTML file. (TFS:264252)
- "Unable to read beyond the end of the stream" error is shown when export the pdf file using "Times-Roman" font to HTML. (TFS:264332)
- Export to BMP takes too much time.
- Exception can occurs during opening certain PDF files. (TFS:245104)
- Blank pages is displayed by the C1PdfDocumentSouce if document is protected with password from modify. (TFS:260561)
- Exception can occurs during rendering PDF files if they contains hyperlinks. (TFS:256665)
- "System.draw.Bitmap" text is shown beside the group header name in exported excel file. (TFS:252999)
- When there are more than one fields of "MS Mincho" font and "MS P Mincho" font, the drawing text in "MS Mincho" field of exported PDF file becomes incorrect. (TFS:253203)
- Long text in the Text field are wrap to next line although WordWrap property is set to false. (TFS:252532)
- All borders are effected by color and width in some exported file although only one border of field is set in Design. (TFS:251350)
- Some databse field in the FlexReport are not shown in exported excel file. (TFS:251329)
- Setting UseCompression property of PdfFilter to true consumes more memory. (TFS:250303)
- Line break in the Paragraph field is not effected in exported excel file. (TFS:255715)
- Customize margin value of page is not effected in some exported files. (TFS:255733)
- Fields with currency format in FlexReport have "General" type when exported to excel. (TFS:256139)

### Improvements:

- Following methods and classes were added to the C1.Win.C1Document, C1.Win.FlexReport due to addining C1FlexViewer.HyperlinkJump event. They allow to analyse where hyperlink points.
  -- C1LinkTargetBase and its descendants. Define a link to another document or position in the same document.
  -- C1Hyperlink. Represents hyperlink.
  -- C1DocumentAction, SSRSOpenReportAction, SSRSToggleItemAction, SSRSSortAction. Define an action which can be executed by the C1DocumentSource, this action can be specified for C1LinkTarget to execute before navigating.
  -- C1DocumentSource.ExecuteAction(C1DocumentAction) method. Executes specified action.

## C1.Win.C1FlexGrid

### Bug fixes

- New row's height was not shown as default size when loading '.xls' excel file to C1FlexGrid. (TFS:270470)
- New row could be added when entering existing ID in bound grid (AllowAddNew=true). (TFS:256738)
- Multiple issues were observed when using "ReadXml" method for databinding. (TFS:256778)
- Highlight BackColor changed back to default when set at design-time. (TFS:260889)
- Font of the grid's content changed when data was loaded from XML file using ReadXml method. (TFS:261834)
- [C1FlexGrid] Background images were getting painted over text in cells having dropdown editors. (TFS:263929)
- Even if XML document was loaded to a grid using ReadXml method, a style of C1FlexGrid wasn't reflected with it. (TFS:264324)
- NullReferenceException was thrown when add new row after deleting the column 'ID'. (TFS:265352)
- Request to provide information on how to edit with ImeMode of the custom editor of the Column. (TFS:259926)
- Selected item is not shown in cell after selecting all row and choosing item from comboBox Editor. (TFS:252661)
- Numeric value was able to enter exceed Max/Min value by using NumericUpDown Editor. (TFS:252722)
- NullReferenceException was thrown when CellStyleCollection.Clear method was called using an object of the class inheriting CellStyleCollection. (TFS:256127)
- Request to provide information on inserting page break on arbitrary rows. (TFS:256009)
- Subtotals in TreeView of Flexgrid disappeared if at least one column was editable. (TFS:256133)
- Old value of ComboBox cell was not cleared when an empty row was copied from Excel to C1FlexGrid. (TFS:257516)
- Request to provide information on setting 'RightToLeftLayout' property of 'FilterEditorForm' to true. (TFS:257514)
- Request to provide information on setting position of Horizontal Scrollbar and Font in FilterEditorForm's ListBox. (TFS:257515)

### Improvements

- Added CountDistinct value to AggregateEnum enumeration. CountDistinct option is used for calculating the count of unique non-empty cells in a group. (TFS:251514)
- Added support of themes to the FilterEditorForm.

## C1.Win.C1GanttView

### Bug fixes

- Added C1GanttView property ScrollPosition that gets the task and date in left upper corner of chart view or scrolls the grid and chart views to the specified task and date. (TFS:264267)
- 'ArgumentOutOfRangeException' was thrown when custom calendar in which start/end of work week is deleted is set through 'Change Working Time' dialog. (TFS:268378)
- Added Tasks.OriginalIndexOf(Task) method to retrieve the original Task's number in grid. (TFS:260538)
- Link was not displayed dim when inactivating successor task. (TFS:256317)
- 'Conflict Resolver' message was not displayed and ConstraintType is changed to 'Start No Earlier Than when dragging forward Auto scheduled task. (TFS:256151)

### Improvements

- [Enhancement] Implemented the feature for exporting C1GanttView to MS Project. (TFS:233747)
- [Enhancement] Added new event PaintDay to provide the back color for specific day on chart view. (TFS:239174)
- Arranged minimal horizontal and vertical scroll values. (TFS:207696)
- Added SchedulePriority property that defines whether the project will be rescheduled with Duration or Start/Finish priority. (TFS:256302)
- Added possibility to know the Predecessor for Link dialog in the ShowDialog event. (TFS:252425)

## C1.Win.C1Gauge

### Improvements

- Added Office2016 style gauges.

## C1.Win.C1Input

### Breaking changes:

- Custom drop down forms cannot be used in C1ComboBox. DropDownFormClassName is hidden from C1ComboBox property editor.
  An exception is thrown if DropDownFormClassName or DropDownForm properties is set to a custom value. (TFS:260547)

### Bug fixes

- Only image is shown in the text area of C1ComboBox when first item is selected by using up/down arrow key. (TFS:269948)
- C1Combobox's 'ItemsDisplayMember' property is not working. (TFS:268375)
- [C1DateEdit] Month beyond MinDate/MaxDate was able to select in the drop down calendar in second time. (TFS:263461)
- [C1DateEdit] ArgumentOutOfRangeException was occurred when click the next month button after setting year part '9999'. (TFS:264312)
- Drop Down window is not able to close after setting "AutoOpen=True" and "DropDownStyle=DropDownList". (TFS:260905)
- C1ComboBox's item is not able to select by pressing up/down arrow key from keyboard. (TFS:262158)
- [C1DataEdit] Date value was not able to paste in C1DateEdit. (TFS:262172)
- [C1ComboBox] Highlight Item was not shown in second time when highlight on the item by using mouse cursor and press 'F4' key. (TFS:262745)
- [C1ComboBox] Item was not highlighted in sometimes when hovered on the item. (TFS:260913)
- [C1DateEdit] Today date is shown in the text area after closing the drop down calendar. (TFS:262650)
- [C1SplitButton] C1SplitButton's icon bar was cut off after setting sub item and CheckOnClick=True. (TFS:264333)
- Pop-up menu of selecting month in C1DateEdit is still shown although closing the drop down calendar. (TFS:263849)
- NullReferenceException is thrown when click up/down button by using C1NumericEdit as editor in flexgrid. (TFS:265214)
- [C1Button] RightToLeft was not retained when changing VisualStyles (OfficeXXX). (TFS:250647)
- [C1DateEdit] Current date-time was displayed in C1DateEdit textbox when InitialSelection property is set to CaretAtEnd or CaretAtStart even if no date are selected. (TFS:260601)
- Unhandled Exception is occurred after clicking up/down button of C1NumericEdit or up/down arrow keys. (TFS:260578)
- Value is not changed using Up/Down arrow keys when DropDownStyle= DropDownList. (TFS:260557)
- [C1TextBox] C1TextBox performed very slow when a long string was pasted in it. (TFS:150563)
- [C1ComboBox] C1ComboBox's background was not correct after setting "DropedDownStyle=DropDownList". (TFS:256739)

### Improvements

- [C1ComboBox] AutoSuggestMode property. if set to "Contains", it enables partial string match in the suggestion list.

## C1.Win.C1InputPanel

### Improvements

- Implemented the ScrollBars property of C1InputPanel. (TFS:238766)

## C1.Win.C1Ribbon

### Breaking changes

- C1RibbonForm does not use the Fixed3D form border style. (TFS:256625)
- RibbonTextBox's text disappeared and the textbox become read-only when the Child Form containing Ribbon was maximized. (TFS:258685)

### Improvements

- Added the ShowContextMenu method to C1Ribbon showing the contextual menu at the center of the specified control.
- Added the Owner property to RibbonTab class. (TFS:239097)
- Added PressedLargeImage and PressedSmallImage properties to RibbonToggleButton. (TFS:251808)
- Added PressedLargeImage and PressedSmallImage properties to RibbonSplitButton.
- Added scroll buttons of tabs when a ribbon width smaller then a tabs area. (TFS:241983)

## C1.Win.C1Themes

### Improvements

- Added Styles/RowSelectorStyle and Styles/ColumnSelectorStyle to C1TrueDBGrid theme template.

## C1.Win.C1TrueDBGrid

### Bug fixes

- New row was not able to add after double clicking on it in first time. (TFS:270102)
- C1TrueDBGrid's cell border was cut off in the edit mode when RightToLeft was Yes. (TFS:260151)
- C1TrueDBDropdown calculated the height incorrectly when the Caption property was set. (TFS:265415)
- In-built checkboxes did not resize in C1TrueDBGrid when resolution of screen was changed to 240 DPI. (TFS:261807)
- Selected Column Count was not shown correctly when selecting a range of cell by using Select() method and gropping the column. (TFS:256118)
- Position of +/- icons in Hierarchical view of C1TrueDBGrid was not changed to right of the column when grid's RightToLeft property was set. (TFS:257522)
- Split's Row Count did not match with TrueDBGrid.RowCount when the CurrentChanged of BindingContext event fired the EndCurrentEdit method. (TFS:257104)
- TrueDBGrid filter didn't work when FilterMultiSelect was true and column data type was deciamal. (TFS:258711)

### Improvements

- Improved performance of ExpandGroupRow(-1,True) method. (TFS:260589)
- Added support of themes to the ConditionFilter.
- Added RowSelectorStyle and ColumnSelectorStyle property.
- Added the new C1DisplayColumn.ShowReadOnlyAsDisabled property, it indicates whether checkboxes or radiobuttons in this column look like as disabled when this column is read only. (TFS:241628)

## C1.Win.Calendar

### Bug fixes

- Mnemonic keys in Today date were not processed. (TFS:260559)
- Exception was thrown during control initialization when set System.Threading.Thread.CurrentThread.CurrentCulture to PersianCulture with PersianCalendar. (TFS:261636)
- Exception was thrown when clicking first 6 day of January 0001. (TFS:263454)
- Exception was occurred when trying to set 29 February 2020 (or any leap-year). (TFS:265309)
- ArgumentException was thrown when navigating January 0001/ December 9999 and then navigating previous/next month through MonthName ListBox. (TFS:260213)
- Days before MinDate had Trail style but not Disabled style when MinDate and MaxDate in the same month. (TFS:260576)
- Only two characters of day names were displayed when setting DayNameLength>2. (TFS:260926)
- Exception message was thrown at designer when resetting Font property. (TFS:256357)
- ArgumentOutOfRangeException was thrown when select December 9999 with default MaxDate. (TFS:250716)
- Trail day was not marked as bold when setting trail days in current month as 'AnnuallyBoldedDates'. (TFS:245351)
- Flickering was observed at the corner of screen by pressing Window key and the Up key many times while opening Month name ListBox. (TFS:256351)

### Improvements

- Shown C1CalendarView.CurrentCulture and C1CalendarView.Calendar properties.
- The size of C1CalendarView became the same for all months, regardless of how many weeks it contains.
- Added C1DateEdit control. It used for displaying and editing date and/or time values.
  C1DateEdit includes a dropdown calendar for easy input of datetime values.
- Added CaptionFormat property that gets or sets the format to use for the calendar caption.
- Added DayNameLength property that gets or sets the maximum length of day names.
- Added Padding and Margins properties to C1CalendarView styles.
- Added TodayFormat property.
- Added Today button. Today button appearance configured using properties "ShowToday" and "TodayFormat". (TFS:238438)
- Added TitleNavigation option to CalendarSettings class. This option used to enable/disable showing of month and year editors in the drop down calendar. (TFS:257821)
- Theme is set to the initial value when Theme property is set to null.

## C1.Win.FlexChart

### Bug fixes

- [Win] IndexOutOfRange exception thrown when using DateTime X-axis values for Stochastic oscillator (TFS:261840)
- [Win][FinancialChart] MovingAverages are not getting rendered on a CandleStick/HLOC chart (TFS:260556)
- [Win][FinancialChart] Fixed exception when adding second series to LineBreak/Kage chart(TFS:234350).
- Legend displayed in TreeMap control (TFS:264880)
- TreeMap's data labels displayed according to Position property (TFS:265138)
- TreeMap's data labels can have border (TFS:265153)
- Fixed exception when setting header or footer of TreeMap (TFS:265201)
- Fixed exception when TreeMap's BindingName property is not set (TFS:265213)
- TreeMap handles collection change notifications (TFS:265246)
- TreeMap renders correctly with negative data (TFS:265400)
- [Win][Sample] 'NullReferenceException' is thrown when choosing 'None' again in Sorting of 'DataManipulation' sample (TFS:265779)
- [Win]Slices in FlexPie are not rendered correctly when binding with negative value (TFS:265305)
- Changing values at runtime is not reflected back in FlexChart,FlexPie and Sunburst controls. (TFS:209490)
- Setting Tooltip.Active to False does not works when an AnnotationLayer has been added to FlexChart. (TFS:256221)

### Improvements

- Added Treemap design time data.
- Improve the style of Pie "Slice color" sample. (TFS:229559)
- Added DrawChart(Graphics,...) to allow draw to Graphics objects.

## C1.Win.FlexPivot

### Bug fixes

- A blank detailed view of FlexPivot was displayed when DataEngine is used in C1FlexPivot. (TFS:259977)
- Right clicking on empty C1FlexPivot's "Grid" throws ArgumentException. (TFS:252517)

## C1.Win.FlexReport

### Bug fixes

- Exception occurs during report rendering if report contains subreports with groups and group footer has Repeated == true. Please note, Repeated property still not supported for sections in subreports.
- Exception can occurs during report rendering in certain complex scenarious. (TFS:253945)
- NullReference exception occurs during report rendering if DataView specified as DataSource.Recordset and DataSource contains sorting definintion or filter or calculated fields. (TFS:256502)
- Reports with gradient backgrounds and images in page header can be exported to DocX incorrectly in non-paged mode. (TFS:253833)

### Bug fixes:

- Column report can be rendered incorrectly in complex scenario when RecordsPerPage is not zero and ForcePageBreak is specified for group footer with zero height. (TFS:267573)
- Bar�odeField.SizeOptions.Module size specified in twips always rounded to DIP's (1/96) inch during barcode rendering. (TFS:265743)
- Only top level outlines exported to PDF. (TFS:266864)

### Improvements

- Added methods to load C1FlexReport from XDocument:
  public void Load(XDocument doc, string reportName)
  public void Load(XDocument doc, string reportName, out bool converted)

## C1.Win.FlexReport Designer App

### Bug fixes

- C1FlexReport resets the Custom PaperSize when user clicks Page Setup and says OK. (TFS:258990)
- Updated localization resources for the error window. (TFS:251297)

## C1.Win.FlexViewer

### Bug fixes

- Context menu was shown on the boundary of C1FlexViewer if it is opened with the Menu key. (TFS:264858)
- Unlike the WPF version, context menu of C1FlexViewer cannot be opened with "Shift+F10". (TFS:264851)
- C1FlexReport resets the Custom PaperSize when user clicks Page Setup and then OK. (TFS:258990)

### Improvements

- Added the HyperlinkClicked event to C1FlexViewerPane (occurs when the user clicked some active element, such as a hyperlink or expanding/collapsing icon). (TFS:259423)
- Added the HyperlinkHovered event to C1FlexViewerPane (occurs when the mouse pointer hovered some active element, such as a hyperlink or expanding/collapsing icon).
- Added the OutlineClicked event to C1FlexViewerPane (occurs when the user clicked an outline element).
- Added the PresentationFrozen boolean property that allows to prevent redrawing of C1FlexViewerPane.
- Implemented deferred rendering for the page thumbnails.

### Other changes

- The shortcut keys for the Outlines panel changed from Ctrl+O to Ctrl+E.
- Changed default KeyTips for the Outlines button ('O'->'E') and for the Export button ('E'->'S').

## C1.Win.Map

### Improvements

- Bing Rest API was supported. To use it pass Bing maps key to the VirtualEarthSource constructor like this: c1Map1.TileLayer.TileSource = new VirtualEarthHybridSource("Bing_maps_key");

## C1.Win.TreeView

### Bug fixes

- TreeView column was getting moved to the left while scrolling the vertical scrollbar to the bottom. (TFS:255426)

### New features

- Added new AutoCheckChildNodes property. This property indicating whether auto check child nodes when parent node is changed checked state. (TFS:253889)

## C1ReportDesigner App

### Bug fixes

- Error occurs when adding a Map custom field in the designer app. (TFS:267231)

## ComponentOne WinForms Basic Library

### Bug fixes

- ScrollablePanel wrong scrolled a content int RTL mode when the ContentElement sets the offsets in the GetScrollOrigin method. (TFS:255426)
- When a MdiForm was Maximized and contained a ControlHostElement on top location then the ControlHostElement was set as invisible. (TFS:258685)

# Release version 4.0.20171.262 - May-15-2017

## C1.Win.C1Document

### Bug fixes:

- "System.draw.Bitmap" text is shown beside the group header name in exported excel file. (TFS:252999)
- Warning bout cell format is shown for the last row of each group when export the report to excel file. (TFS:253008)

## C1.Win.FlexReport

### Bug fixes

- Exception can occurs during report rendering in certain complex scenarious. (TFS:253945)

# Release version 4.0.20171.260 - May-06-2017

##
2017 v1 HotFix 2

## C1.C1Pdf

### Bug fixes

- Exception is thrown when C1PdfDocument.DrawLine() method is executed. (TFS:253939)

## C1.Win.C1Chart3D

### Bug fixes

- The Chart3DView.IsInteractive and Interaction.Enabled properties now behave as expected transitioning from design time to runtime. (Tfs:255413)
- The Chart3DView.IsInteractive and Interaction.Enabled properties now behave as expected for specified values even when repeatedly set. (Tfs:255413)

## C1.Win.C1Command

### Bug fixes

- DockingTab is disappeared when resize the form after setting C1MainMenu and C1DockingTab in one CommandDock. (TFS:256509)
- [C1TopicBar] Background image of C1TopicBar was not shown after applying the theme. (TFS:256369)
- GUI resources are present in memory even after dispose. (TFS:210282)
- BackColor of C1TopicBar theme had no effect. (TFS:252605)
- Restoring two side-by-side aligned C1DockingTab creates wrong placement. (TFS:209455)
- C1DockingManager's Dragging event is fired multiple times. (TFS:253435)
- C1DockingTab's (4.0) Toolbox bitmap is not set (TFS:252243)

## C1.Win.C1FlexGrid

### Breaking changes

- Setting value of C1FlexGridBase.Rows.Count property does not add additional row in unbound mode if C1FlexGridBase.AllowAddNew property is true. (TFS:252513)

### Bug fixes

- Font Style of highlighted cell was not applied when VisualStyle was set other than "System". (TFS:106927)
- Resize cursor flickered while moving up and down on column header. (TFS:116668)
- FlexGrid cells were blank when the text was too long. (TFS:248756)
- FlexGrid hung when SetCellCheck(row, col, CheckEnum.Grayed) was called in a loop. (TFS:250278)
- Selecting row in Hierarchical C1FlexGrid did not working properly. (TFS:251364)
- When setting AllowAddNew = true in an unbound grid, the set value of Rows.Count was not reflected correctly. (TFS:252513)
- New row was not able to add when rows were merged until to new row. (TFS:252639)
- New row was not added automatically by checking the checkbox of new row after selected Boolean column in Unbound mode. (TFS:252983)

### Improvements

- Added IsCellSelectedRowHeader(int row, int col), IsCellSelectedColumnHeader(int row, int col) methods to C1FlexGridBase class. These methods are used for determing if cell is a row/column header with a selection in this row/column. (TFS:92519)

## C1.Win.C1GanttView

### Bug fixes

- Sub summary task bar was disappeared while deleting parent summary task and using Undo function. (TFS:238775)
- All days can be set to non-working days through 'Default Days Off' in Project Information dialog. (TFS:249862)
- '% Complete' of inactive task can be edited through 'Task Information' dialog and grid pane. (TFS:249863)
- 'System.ArgumentOutOfRangeException' occurred if select all cells in left grid and remove columns by Columns Dialog. (TFS:251871)
- NullReferenceException raised when loading MS Project xml with explicit TimephasedData in C1GanttView. (TFS:250942)
- Rightmost child milestone of Summary was not reflected on Summary task in Report Preview. (TFS:253385)
- FieldStyle for tasks was not reflected properly when C1GanttView is Print Previewed and the FildStyle is defined for each task. (TFS:253872)

### Improvements

- Added a resolving dialog to the process of moving automatic task if there is a conflict with constraint types. (TFS:129998)
- Added a resolving dialog to the process of moving automatic task if there is a conflict with project limits (before ProjectStartDate or after ProjectStartDate). (TFS:130009)

## C1.Win.C1Input

### Bug fixes

- [C1ComboBox] Image and text was not shown in the text area when select the item in the drop down after setting "ItemMode=HtmlPattern". (TFS:255097)
- [C1ComboBox] Highlighted item was not shown in the text area when highlight on the item by using mouse cursor and press 'F4' key. (TFS:249738)
- [C1ComboBox] Highlighted items in dropdown was still changed by pressing 'down' key although last item was selected while dropdown was opened. (TFS:200234)
- "PostValidated" event fired twice if user clicked Up or Down button from C1NumericEdit. (TFS:37824 case 1)
- "PreValidated" event does not fired. (TFS:37824 case 2)
- [C1SplitButton] Backcolor of checkbox in ImageBar was shown as white when Themes applied. (TFS:56552)
- [C1ColorPicker, C1FontPicker] Next adjacent item was not shown in the text area although selecting items by pressing 'Down' arrow key when "TextDetached= True". (TFS:250577)
- [C1ComboBox] Item in the drop down was not highlighted when pressed up/down key after setting "AutoOpen=True". (TFS:251308)
- [C1ComboBox] Some drop down item of C1ComboBox was cut off by setting MaxDropDownItem property and applying the theme on it. (TFS:250718)
- [C1ComboBox] DataBound C1ComboBox could not display HTML Entities correctly. (TFS:240357 surrounding issue)
- [C1ComboBox] Appended item sometimes was not selected in the drop down after setting AutoCompleteMode = Append. (TFS:250813)
- Application form is put behind all opened applications with C1DropDownControl and all descendents on Windows 10 Creators Update. (TFS:252527)

### Improvements

- [C1ComboBox] Selected item of c1Combobox shows on top of dropped list.

## C1.Win.C1InputPanel

### Bug fixes

- Selected items in InputComboBox did not show '&' when Office 2010 Blue theme was applied. (TFS:247866)
- GotFocus and LostFocus events were fired when the Enable was False of some C1InputPanelcontrols. (TFS:247865)
- Added new property InputControlHost.SupportScrollAfterFocus. This property indicates whether the C1IputPanel should scroll the hosted control when it gets the focus. (TFS:250602)

## C1.Win.C1List

### Bug fixes

- [C1Combo] Drop down list of c1Combo was not able to open when using it as ControlHost in Ribbon. (TFS:255103)
- [C1Combo] Validating event of MS Textbox was raised more than 50 times when C1Combo is clicked. (TFS:251878)

## C1.Win.C1Report

### Bug fixes

- Exception was thrown when a group in SSRS report is expanded. (TFS:252385)

## C1.Win.C1Ribbon

### Bug fixes

- MDI child window was not active when switching the windows. (TFS:256621)
- C1Ribbon didn't render correctly when FormBorderStyle property of C1RibbonForm was Fixed3D. (TFS:250698)
- After changing system calendar to Japanese and adding DatePicker to C1Ribbon's group, application throws "ArgumentOutOfRangeException" exception. (TFS:250313)
- An exception occurs when you use RibbonForm as MDI child, display QAT Key Tips, and click "close" context menu of its title bar. (TFS:252608)

## C1.Win.C1Themes

### Bug fixes

- Command's Section "Add Theme" thrown "Cannot add theme to the project: startup project could not be determined" error. (TFS:247636)
- "Theme not found" error message was thrown when open the project contained the custom theme. (TFS:244799)

## C1.Win.C1TrueDBGrid

### Breaking changes

- TrueDBGrid will use the default textbox as editor for filter when FilterMultiSelect is true. (TFS:253722)

### Bug fixes

- When the Style.HorizontalAlignment was set to "General" and it was connected to a numeric field, it was not right-aligned. (TFS:256251)
- Filter didn't work for date/time midnight. (TFS:245529)
- Focus didn't shifts from one filterbar to another when arrow keys were pressed. (TFS:152648)
- AND filter was applied when saved filter definition of an OR condition filter was loaded. (TFS:248073)
- Sorting was applied automatically on resizing a column in C1TrueDBGrid when 'Cursor' property is set to 'Cursor.Default'. (TFS:78488)
- FilterDropDown contained all values present in ValueItem collection of corresponding column even if ValueItem was not present in DataSource of the grid. (TFS:250650)
- When grouped column was placed between selected cell range, selected a range of cell was split after added grouped column to group area of c1TrueDBGrid. (TFS:238434)
- Filter was applied after pressing a key up/down when the MultiFilterSelect was True. (TFS:245365)

### Improvements

- Added support for changing language of GroupIntervalEnum.DateSpan in C1TrueDBGrid. (TFS:76723)

## C1.Win.C1TrueDBGrid.Excel

### Bug fixes

- LoadExcel() method was not properly importing excel having multiple type data in single column. (TFS:247099)
- C1TrueDBGrid was exported incorrectly with grouped rows. (TFS:247605)

### Improvements

- Supported Footer Row in SaveExcel method. (TFS:253641)

## C1.Win.Calendar

### Bug fixes

- All days were disabled except MaxDate when setting MaxDate whose month is less than current month. (TFS:250070)
- Trail days were not highlighted when selecting days between two months. (TFS:243231)
- BackImage of Day's title was not shown in C1CalendarView. (TFS:239186)
- Month name list box filled the screen when pressing Window + Up key while opening list box and then reopening it again. (TFS:250101)
- ArgumentOutOfRangeException was thrown when entering greater than default MaxDate and less than default MinDate. (TFS:250716)
- ArgumentOutOfRangeException was thrown by opening year dropdown of year greater than year of MaxDate when setting CalendarDimension and PeriodSelectionType=List. (TFS:250723)
- Font property of C1CalendarView control was not effected. (TFS:253185)

### Improvements

- Added DayNameLength property that gets or sets the maximum length of day names.

## C1.Win.FlexPivot

### Bug fixes

- C1FlexPivot's Dispose method is throwing "System.ArgumentException" when it is created twice. (TFS:252439)

## C1.Win.FlexReport

### Bug fixes

- Additional fixes linked with 253413 bug, bug still occurs if report contains groups with KeepTogether != None. (TFS:253413)
- Report rendered incorrectly if it contains group footer with Section.Repeat == true, Section.PrintAtPageBottom == false and Detail section splits between pages. (TFS:253655)
- Report can be rendered incorrectly if it contains group headers with Section.Repeat == true and C1FlexReport.RecordsPerPage > 0. (TFS:253486)
- Reports containing subreports with Across column layout can be rendered incorrectly. (TFS:252988)
- SumOverGroup value specified for Field.RunningSum processed as SumOverReport. Fixed. (TFS:253413)

## C1.Win.TreeView

### Bug fixes

- NullReferenceException occurred in c1TreeView when applying the c1Themes and setting 'EditorType' of c1TreeColumn. (TFS:250699)
- The modified color Node was not retained from color picker when it was getting changed as edit mode again. (TFS:250649)
- Scrolling the nodes using horizontal scrollbar did not show the whole content and scrollbar hid when dragged back towards left and there was a long content in the nodes. (TFS:253392)
- TreeView dotted lines were not shown when the RightToLeft was yes and scroll bars showed. (TFS:253408)

## C1ReportDesigner App

### Bug fixes

- When exporting from preview to Excel with the same file already open in MS Excel, after the error message shows, the 'stop' button remains active instead of 'refresh'. (TFS:253065)

# Release version 4.0.20171.254 - Apr-05-2017

##
2017 v1 HotFix 1

## C1.C1Excel

### Bug fixes

- PrintSettings.Header/Footer not able to display an ampersand in excel file. (TFS:249878)

## C1.Win.C1Command

### Bug fixes

- AutoHide button and Close button is not refresh immediately after setting "RightToLeft=Yes" at run time. (TFS:242840)
- Tab page is disappeared after resizing the tab page when maximize the form. (TFS:229230, TFS:204350)
- C1OutBar flickers when focus was toggled between form and Command Link. (TFS:238068)
- [C1DockingTab] SelectedIndexChanged event does not fire when the TabPage is closed. (TFS:150349)
- C1DockingTab not working properly when Taskbar is left/top aligned. (TFS:245095)
- [C1DockingTab] Tab page is moved to another side after autohiding and reopening the tab page when restore layout. (TFS:246969)
- Tab captions are clipped when the window is resized. (TFS:210078)

## C1.Win.C1Document

### Bug fixes:

- Exception can occurs while previewing C1PdfDocumentSource or C1FlexReport in C1FlexViewer in certain scenarios. (TFS:238571,TFS:245527)

## C1.Win.C1FlexGrid

### Bug fixes

- Other selection cells were still selected although one cell was selected after selecting multiple cell. (TFS:252371)
- [C1FlexGrid] Frozen cells were not getting selected when the grid was in focus. (TFS:251085)
- C1FlexGrid thrown NullReference Exception when using Dispose method. (TFS:234189)
- [SearchPanel] Incorrect searched results were displayed on searching after filtering through FilterDropDown. (TFS:227964)
- Extra row was shown and NullReference Exception was occurred by adding some new row after deleting all row in Bound Mode. (TFS:245085)
- C1FlexGrid AutoSearch set the focus to invisible and/or collapsed rows. (TFS:246970)
- Grid's Border disappeared partially when its BorderStyle property was set to FixedSingle and the grid was hidden behind another application. (TFS:245553)

### Improvements

- Added support of changing color of the DBCursor glyph through the theme.

## C1.Win.C1GanttView

### Bug fixes

- Filter value were disappeared when click on the field of filter row in the "Advanced Filter" dialog box. (TFS:242901)
- Conflict error was not disappeared when inactivate the successor task. (TFS:245352)

## C1.Win.C1Input

### Bug fixes

- [C1ColorPicker] Color was shown in the text area while hover on the custom color in the color drop-down (TFS:250633)
- [C1ComboBox] Last item in the drop down of C1ComboBox was not highlighted when mouse left the drop down. (TFS:250785)
- Highlighted item was changed according to the mouse cursor when the items in the drop down list of C1ComboBox were scrolled using up down arrow keys. (TFS:142365)
- [C1SplitButton] DropDownList of C1SplitButton was not opened by pressing "F4" key when C1SplitButton is placed on the dropDownForm. (TFS:207852)
- [C1ComboBox] Item of C1ComboBox was not highlighted in the DorpDown list after typing the item in the text area from keyboard. (TFS:202916)
- [C1SplitButton] Separator line of SubMenu buttons with children renders uneven with its succeeding line when Themes applied. (TFS:56524)
- [C1FontPicker][C1ColorPicker] Validation Error message box was shown when select the item by using up/down key when TextDetached and AutoOpen are set to True. (TFS:230018)
- [C1Button] When VisualStyle is set in design-time, UseVisualStyleBackColor reset to false at runtime. (TFS:245800)

### Improvements

- [C1ComboBox] Added MaxDropDownItems property to C1ComboBox class. This property is used for setting the maximum number of items which will be shown in the drop-down portion. (TFS:145590)

## C1.Win.C1Report

### Bug fixes

- Fixed a localization issue for the German locale. (TFS:247317)

## C1.Win.C1Themes

### Bug fixes

- Selected date was not highlighted when ExpressionLight theme is applied. (TFS:56814)

### Improvements

- Added Office2016white themes for C1 controls.

## C1.Win.C1TrueDBGrid

### Bug fixes

- TrueDBGrid filter didn't work when FilterMultiSelect was true and column data type was double. (TFS:251661)
- All the level 2 groups in grid did not render as expanded even if GroupInfo's "OutlineMode" was set to StartExpanded. (TFS:247100)
- ExportToHTML did not work from Local System Account Service. (TFS:247107)

### Improvements

- Added support of 'Like' FilterOperator for not string DateType.

## C1.Win.Calendar

### Bug fixes

- ArgumentOutOfRangeException was thrown on clicking year part when MinDate and MaxDate was less than 3 years different and PeriodSelectionType=List. (TFS:250029)

## C1.Win.FlexChart

### Bug fixes

- Multiple issues are occured in AxisScrollBar by hiding series with Secondary Axis Y when setting 'Left' to Position of secondary AxisY and Primary AxisY.(TFS:251294)
- [Win][FlexChart] Secondary Axis Labels are cut off by hiding series with Primary Axis Y when setting 'Left' to Position of secondary AxisY and Primary AxisY. (TFS:250569)
- [Win][AxisScrollBar]Duplicate Axis Labels and Axis Lines are displayed when AxisScrollBar.Visible=false. (TFS:250542)
- Axis Labels are covered by AxisScrollBar added at secondary axis of FlexChart. (TFS:247291)
- [Win][FlexChart] Secondary Axis Labels are cut off by hiding series with Primary Axis Y when setting 'Left' to Position of secondary AxisY and Primary AxisY. (TFS:250569)

## C1.Win.FlexReport

### Bug fixes

- C1Report xml file can not be loaded by C1FlexReport if it contains embedded subreports. (TFS:251337)
- DataSource.MaxRecords is ignored if XML file specified as data source. (TFS:251626)
- Horizontal alignment specified for Field, TextField, ParagraphField is ignored if WordWrap is false and text width exceeds field's width. (TFS:251520)

## C1.Win.TreeView

### Bug fixes

- Node editor was moving along with scroll bar when scrolling by mouse. (TFS:242931)
- C1TreeView could not set a node value in Unbound Mode when the value was DBNull. (TFS:242864)

# Release version 4.0.20171.249 - Mar-01-2017

## C1.C1Word

### Bug fixes

- Image drawn by DrawMetaFile() method is stretched when save the document with docx format. (TFS:245461)

## C1.Win.C1FlexGrid

### Bug fixes

- FlexGrid editing did not work in Merged Ranges. (TFS:240643)

## C1.Win.C1TrueDBGrid.Excel

### Bug fixes

- C1TrueDbGrid.Excel dll showing wrong version information. (TFS:245482)

# Release version 4.0.20171.248 - Feb-28-2017

## C1.Win.C1Command

### Bug fixes

- NullReferenceException is thrown when change to some visual style after applying the themes on C1MainMenu/C1ToolBar/C1OutBar. (TFS:227797)
- CharCategory property of C1TextBox does not work as expected. (TFS:236510)
- Tab page is not retained to the previous position when e.Cancel is set to true in floating event of c1DockingManager. (TFS:204816)
- TabPage caption is cut off when RightToLeft=Yes , CanAutoHide=False and CloseBoxEnum=ActivePage/AllPage (TFS:242713)

## C1.Win.C1FlexGrid

### Bug fixes

- BackGroundImage of Alternate style was not displayed for the cell [1,1] when setting VisualStyle to 'Office xxxx'. (TFS:202009)
- ChangeEdit event was raised for a cell with DataMap. (TFS:229557)
- Grid did not work with negative cell values correctly. (TFS:237585)
- Using BeginUpdate and EndUpdate methods added extra row while setting row count in C1FlexGrid. (TFS:238042)
- Scroll Event was fired when column width is changed in C1FlexGrid. (TFS:238175)
- When BindingSource' Current change, FlexGrid did not scroll cell to view. (TFS:238770)
- C1FlexGrid.Row was -1 when add row by bindingSource. (TFS:239343)
- '-' symbol was ignored if it was input in the column that DataType was set as 'double'. (TFS:239571)
- AutoSizeRows method might change height of empty grid rows. (TFS:240065)
- Text of first row was dim after setting "AllowAddNew=True" and setting cell checkbox. (TFS:241961)

## C1.Win.C1GanttView

### Bug fixes

- Start date of second task was being moved to non-working day when set the predecessor link with first task. (TFS:236833)
- All days can be set to non-working days through 'Change Working Time' dialogs. (TFS:236220)
- "Delete Task" button was enabled when match rows are not shown in C1GanttView after applying filter (TFS:237426)
- Text in the grid view is disappeared when make the some changes while cursor is still in edit mode. (TFS:237503)
- Empty task names in the "Link Information" dialog box are now changed to its IDs. (TFS:237262)
- Added Lag value to Predecessors column if the Lag is defined. (TFS:237156)
- Text was overlapped and corner of task bars were cut off in Print Preview when PrintInfo.FitHorizontally is set to true. (TFS:234187)
- Inactive task allowed draw the percent completed progress bar on it. (TFS:236771)
- A half-finished task could be made inactive. (TFS:236763)
- Working day coudn't be undo after changing the working day from "Conflict Reslover" dialog. (TFS:233712)
- "Save" button in the "Advance Filter" dialog was disabled after deleting Filter line. (TFS:242868)
- Previous filter line row was deleted when select blank row and click on "Delete" button in the "Advanced Filter" dialog. (TFS:242879)

### Improvements

- [Enhancement] Added "Delete" button in "Advanced Filter" dialog box. (TFS:233747)

## C1.Win.C1Input

### Bug fixes

- [C1ComboBox][C1FontPicker][C1ColorPicker] Items could be selected by pressing up/down key although ReadOnly property is set to true. (TFS:224909)
- [C1DateEdit] Months and year are not shown correctly when select month and year from the header of calendar dropdown after setting RTL=Yes. (TFS:195149)
- [C1ComboBox] Html tag was showed in text area of C1ComboBox when user selected item from C1ComboBox with ItemMode=Html by pressing up/down key. (TFS:223823)
- C1NumericEdit's TextChanged event was fired twice when a text was changed from a value to another value directly. (TFS:235165)
- [C1SplitButton] Selected dropdown item with sub-items did not use themed hot style. (TFS:56576)
- [C1SplitButton] Sub-items of disabled dropdown item are displayed and could be accessed. (TFS:56750)
- [C1SplitButton] Button ForeColor does not dim in the disabled C1SplitButton. (TFS:56859)
- [C1ComboBox] DataBound C1ComboBox could not display HTML Entities correctly. (TFS:240357)

## C1.Win.C1InputPanel

### Bug fixes

- Minor corrections for C++/CLI apps.

## C1.Win.C1List

### Improvements

- [C1Combo] The SelChange event was replaced to the SelectionChanging event. It is possible to cancel selection change in the SelectionChanging event. (TFS:237578)

## C1.Win.C1Report

### Bug fixes

- Grid View part of C1GanttView is black in exported excel file. (TFS:234513)

## C1.Win.C1Themes

### Bug fixes

- C1ThemeController showed an error when a custom theme was added to a project from multi-project solution. (TFS:221449).

## C1.Win.C1TrueDBGrid

### Bug fixes

- Previously matched value are appeared in the FilterBar of other column after applying filter by filter drop down in one column when 'MultiFilterSelect=True'. (TFS:245350)
- MultiFilter was not worked correctly when 'MultiFilter=True'. (TFS:244796)
- ComboSelected event was not fired when selecting item from comBobox by using keyboard. (TFS:238531)
- C1TrueDbGrid lost new row data when it was bound to BindingSource. (TFS:236567)

### Improvements

- ScrollBar is scrolled automatically to the last row while selecting multiple rows by selecting one row and dragging mouse over the last rows. (TFS:238034)
- Column selection was changed, now mouse down event by column header sets selection state for column. (TFS:238434)

## C1.Win.FlexChart

### Bug fixes

- IndexOutOfRangeException is thrown by selecting slices when setting Inside/Outside to 'DataLabel.Position' , SelectionMode='Point' and SelectedItemPosition = 'Left'. (TFS:242755)
- Multiple issues are observed when setting some value to DataLabelPosition , Offset, SelectedItemOffset and 1 to InnerRadius. (TFS:244411)
- IndexOutOfRangeException is thrown by shrinking form size when DataLabelPosition is set to any position other than 'None'. (TFS:243301)
- LineMarker contents disappear when toggling Visible property of LineMarker. (TFS:244589)
- 'IndexOutOfRangeException' is thrown when setting 'InnerRadius' to greater than '0' and 'DataLabelPosition' to 'Inside'/'Outside' in FlexPie. (TFS:236055)
- 'IndexOutOfRangeException' is thrown when setting 'InnerRadius' to '1' and 'DataLabelPosition' to 'Radial'/'Circular' in FlexPie. (TFS:236057)
- LineMarker with 'Drag' interaction moves with the pointer after pressing 'Window+D' keys while dragging LineMarker. (TFS:235982)
- Unlike 2016V2 builds, series are not plotted correctly in Area/SplineArea chart when setting FlexChart's Rotated to true. (TFS:237571)
- Large data value is drawn over legend when unsorted/ascending data is used and FunnelType is 'Rectangle'.(TFS:236398)

### Improvements

- Added Fibonacci tools.
- Added Envelops and Bollinger Bands overlay series.
- Added MACD, Stochastic indicators.
- Added Box & Whisker series.
- Added ErrorBar series.
- Provide a mechanism to display the percentage share of slices in the Sunburst chart DataLabels.
- Allow to change the size of AxisScrollbar.

## C1.Win.FlexReport

### Bug fixes

- Series text in FlexCharField generated incorrectly if Series.YExpression contains spaces.(TFS:240383)
- Report saved in C1FlexReportDesigner application can not be loaded in UWP FlexReport if it contains DataSource with SortDefinition and SortDirection specified as Descending.

## C1.Win.FlexViewer

### Bug fixes

- Highlight on the search result text disappeared when click on the "Match Case" or "Whole Word" button. (TFS:236700)

## C1.Win.Map

### Bug fixes

- Image returned from ITileSource.GetTile's user implementation was not considered by TileManager. (TFS:238627)

### Improvements

- Added property HorizontalLoop that defines whether the map will be scrolled to west or east endlessly. (TFS:236362)
- Added C1Map.Proxy property. (TFS:236432)

## C1.Win.Olap

### Bug fixes

- Field(s) data was not grouped properly in C1Olap. (TFS:236718)

## C1.Win.TreeView

### Breaking changes

- BorderStyle property of C1TreeView is hidden, use Style.BorderStyle, Style.Border and Style.BorderColor properties.

### Bug fixes

- Expanded and Expanding events of c1TreeView were fired when a node had not child nodes. (TFS:239118)
- C1TreeNode was not able to edit date when column editor type was DatePicker and C1TreeView had not data source. (TFS:239618)
- Any control was visible on form in runtime when it was set as Editor in c1TreeColumn. (TFS:239712)

### Other changes

- TreeNodes editor uses only the Text editor in design time. (TFS:239573)
- Added reference to C1Command.

# Release version 4.0.20171.243 - Feb-17-2017

##
2017 v1 Release

## C1.C1Excel

### Bug fixes

- An Exception thrown when load an Excel file by C1Excel (part 2: 元ファイル20161029_nv1.xlsx). (TFS:213273)
- C1Excel replaces "@" symbol to new line"\n". (TFS:235074)

## C1.C1Pdf

### Bug fixes

- Result pdf file with Arabic text have some scrambled. (TFS:238493)
- Unlike previous build 238, draw lines on bottom and right are not displayed in the first page of result pdf. (TFS:236582)
- Unlike previous build 238, Hebrew text are exceed from the border in exported pdf file. (TFS:236599)

### Improvements

- Output in one pass for text drawing (TextOut methods of PdfDocumnet and PdfDocumentBase).

## C1.C1Word

### Bug fixes

- "System.InvalidCastException" exception is thrown when load the rtf file contained table. (TFS:236199)

## C1.Win.Bitmap

### Bug fixes

- Fixed a bug with image DPI in the Import(C1Bitmap) and CreateImage methods of C1Bitmap. (TFS:239348)

### Improvements

- Added the CreateImage method to C1Bitmap which creates the internal image of the given size with uninitialized content.
- Added the Import(C1Bitmap) method for more efficient copying the image between instances of C1Bitmap.

## C1.Win.C1Document

### Breaking Changes:

- Now C1.Win.C1Document.4.dll and C1.Win.FlexReport.4.dll references System.Xml.Linq.xml, it is added by default to new Net4 projects so it should not cause any problems.
- Now C1.Win.C1Document.4.dll references C1.Win.Bitmap.4.dll.

### Bug fixes:

- Background color of shape is not effected in RTF and Word file. (TFS:239716)
- Text are not displayed in exported excel file when add the TextField to the Shape field and its Zorder property is set. (TFS:239727)
- Currency sign replace with undefined character in exported excel file. (TFS:238162)
- Exception may occur in C1PdfDocumentSource if pdf file contains not standard fonts which are not installed in the system by default. (TFS:238571)
- Some PDF files are not displayed by the C1PdfDocumentSource at all. (TFS:235798)

## C1.Win.C1FlexGrid

### Breaking changes

- The default value of C1FlexGridBase.EmptyAsNull property was changed to false.

### Bug fixes

- A part of the strings of the cell was dropped out, when TextAlign of the column is set besides "Left" and the font is set to "MS Gothic" and 12 point. (TFS:236906)
- Scrolling lagged using vertical scrollbar in C1FlexGrid. (TFS:238070)
- Custom FilterRow could not be edited. (TFS:237902)
- Cell could not be edited, if any column other than the first column of the merged range is clicked. (TFS:236536)
- Multiple checkboxes' values could not be changed, if multiple rows are selected with any other than column other than boolean. (TFS:236560)
- 'BuildString' method of C1FlexGrid's Style object ignored the 'WordWrap' information while storing the style into a string. (TFS:237142)
- When moving a table column a black block was displayed on the screen on higher resolutions. (TFS:208268)
- C1FlexGrid frozen columns behaved strangely when horizontal scroll bar is scrolled right to left. (TFS:225050)
- Cell content might overlap with fixed merged cols. (TFS:232553)
- When ValueFilter are applied with FilterDefinition, no rows were visible. (TFS:235180)
- Changed specification of KeyChar property of KeyPressEditEventArgs class. (TFS:235703)
- Column Editor settings got cleared in certain scenarios. (TFS:236027)

### Improvements

- Added ApplySearch(string search, bool highlight, bool filter, bool onlyVisibleColumns) method to C1FlexGridBase class. This method is used for full text search across all visible columns with data of C1FlexGrid. (TFS:234729)

## C1.Win.C1GanttView

### Bug fixes

- Matched tasks are not shown when applying 'Percent Complete' filter by using "Equal" and "DoesNotEqual" testOperator after dragging the 'Percent Complete' as '63' value in tasks. (TFS:234986)
- Spelling mistake for "nonworking day" in the "Conflict Resolver" dialog. (TFS:233718)
- Text in the grid view was not dim for the inactive task. (TFS:234325)
- Exception raised when press "Undo" button after clearing tasks from code. (TFS:236024)
- 'Inactive' and 'BarStyles' buttons were disabled when blank row is contained in selection of multiple rows. (TFS:234340)
- Link line was shown over tiers while drawing predecessor line and scrolling until start dragging task cannot be seen. (TFS:235292)

### Improvements

- Added method C1GanttView.ClearUndoRedo() that clears undo-redo stack.

## C1.Win.C1Input

### Bug fixes

- When "Furigana" is obtained using ReadingStringOutput object of C1TextBox, incorrect results are sometimes obtained. (TFS:227986)
- [C1ComboBox] C1ComboBox showed the system context menu when a DropDownStyle value was set to DropDownList. (TFS:236124)
- [C1ComboBox] Selection was not shown in drop down list although selected item was shown in text area when ItemMode=Html. (TFS:236100)
- [C1DateEdit] Setting the property C1DateEdit.Calendar.CalendarWeekRule is ignored. (TFS:231625)
- [C1DateEdit] C1DateEditt was not working properly when calendar's MinDate and MaxDate are the same day. (TFS:202336)

## C1.Win.C1InputPanel

### Bug fixes

- Movement of a form was reset when the SelectedIndexChanged event was raised. (TFS:235016)

## C1.Win.C1IntelliSpell

### Bug fixes

- SpellChecker reference was changed to use .Net40 C1.Win.C1SpellCkecker.4.dll

## C1.Win.C1TrueDBGrid

### Bug fixes

- C1TrueDBGrid was slowed when cell had very large data. (TFS:236554)

### Improvements

- Implemented new method C1TrueDbGrid.LoadExcel to provide import from Microsoft Excel file (needs reference to C1.Win.C1TrueDBGrid.Excel.4 assembly).
- Changed sample TrueDbGrid\CS\Excel (added the demonstration of the C1TrueDbGrid.LoadExcel feature).

## C1.Win.C1TrueDBGrid.Excel

### Bug fixes

- About box of c1Excel was appeared when using the 'SaveExcel()' method in run time. (TFS:238560)

## C1.Win.FlexChart

### Improvements

- Added axis binding.
- Support of multiple plot areas.

## C1.Win.FlexViewer

### Improvements

- The Dock property of a C1FlexViewer is set to 'Fill' when adding the control from the toolbox (see TFS:236210).

### Other changes

- Added reference to C1.Win.Bitmap.4.dll.

## C1.Win.TreeView

### Bug fixes

- TreeView doted lines were distorted when mouse was over a node and RightToLeft was yes. (TFS:238664)
- Node wasn't expanded when mouse over on it and other node is dragged. (TFS:207534)
- TreeView showed message box about licensing when the EditorType was set as 'DatePicker' or 'NumericEdit'.

### New features

- Added new properties C1TreeColumn.DisplayFormat and C1TreeColumn.EditFormat. This properties gets or sets the format string used to the value when the node cell is in edit mode or is not in edit mode.

# Release version 4.0.20163.238 - Jan-26-2017

## C1.C1Report

### Bug fixes

- Text are jump to the new line in exported docx file when RenderObjects use BaseNine fonts. (TFS:235816)

## C1.C1Word

### Bug fixes

- Text are jump to the new line in exported docx file when RenderObjects use BaseNine fonts. (TFS:235816)
- System.FormatException is thrown when load the certain docx file. (TFS:227601)

## C1.Win.BarCode

### Bug fixes

- C1BarCode did not render correct image when code type set as 128 and module size set as 1. For some readers, you should set a value of QuietZone as 1 or more when the ModuleSize set as 1. (TFS:233682)

## C1.Win.C1Command

### Bug fixes

- [C1DockingTab] ShowSingleTab does not work if there is an invisible tab. (TFS:235847)
- [C1DockingTab] Border disappears by setting ShowSingleTab='false' although setting DockingTab's BorderStyle to 'FixedSingle'. (TFS:235815)
- [C1TopicBar] The size of a TopicBar page title was not refreshed when page styles contained a different font size. (TFS:233795)

## C1.Win.C1FlexGrid

### Bug fixes

- EditMask set on one column worked for another. (TFS:235049)

### Improvements

- Added AllowNull property to Column class and EmptyAsNull property to C1FlexGridBase class. AllowNull property used to determine that cells in current column will accept null value or null will be replaced by default value in unbound mode. EmptyAsNull property used to determine that empty string from editor will be transformed to null or not after submitting value. (TFS:228266)

## C1.Win.C1GanttView

### Bug fixes

- Exception raised when press "Undo" button after clearing tasks from code. (TFS:236024)
- Link line was shown at incorrect position while drawing the Predecessors line between two tasks. (TFS:234349)
- "Conflict with a linked task" error was still shown although one task is set into inactive task. (TFS:234363)

### Improvements

- Added method C1GanttView.ClearUndoRedo() that clears undo-redo stack.

## C1.Win.C1Input

### Bug fixes

- [C1ComboBox] NullReferenceException was occurred when a item was selected and used HTML code with ordered list in 'Item' property. (TFS:235750)
- [C1ComboBox] Selected text in text area was displayed incorrectly when using HTML code with unordered list in 'Item' property. (TFS:61258)
- [C1TextBox] Modified property of C1TextBox did not return correct value. (TFS:212014)

## C1.Win.C1Schedule

### Bug fixes

- FirstVisibleTime property is ignored in the TimeLine view. (TFS:235784)

## C1.Win.C1TrueDBGrid

### Bug fixes

- When the ValueItems.Presentation was set as SortedComboBox then this caused the memory leak. (TFS:218858)

## C1.Win.FlexReport

### Bug fixes

- WMF images processed by the C1FlexReport incorrectly as raster (not vector) images. (TFS:235058)

## C1.Win.FlexViewer

### Improvements

- The error message text is shown on a page that can not be rendered because of an internal error.

## C1.Win.TreeView

### Bug fixes

- NullReferenceException was occurred when the TreeViewColumn EditorType was set as 'CheckBox' and the theme was applied at design time or run time. (TFS:234475)

# Release version 4.0.20163.234 - Jan-18-2017

## C1.C1Report

### Bug fixes

- In some rare cases RTF Field does not split between pages even if KeepTogether == false. (TFS:143697 case 2)

## C1.C1Word

### Bug fixes

- Image and chart in the flexreport file are not shown in exported rtf file. (TFS:229115)

## C1.Win.C1Document

### Bug fixes:

- Numbers of generated file are incorrect when export the file using RenderToFilter method in multithread application. (TFS:230016)

## C1.Win.C1Schedule

### Improvements

- Added C1Schedule.MinSlotWidth and MinDaySlotWidth properties to control slot width in the C1Schedule TimeLine view. (TFS:221311)

## C1.Win.C1SplitContainer

### Improvements

- Added events SplitterMoving and SplitterMoved for C1SplitContainer. (TFS:200856)

## C1.Win.C1TrueDBGrid

### Improvements

- Implemented new method C1TrueDbGrid.SaveExcel to provide fast export to Microsoft Excel file (needs reference to C1.Win.C1TrueDBGrid.Excel.4 assembly). (TFS:214687)
- Added new sample TrueDbGrid\CS\Excel to demonstrate the C1TrueDbGrid.SaveExcel feature.
- ComboSelect event is obsolete, use new ComboSelected event instead. The new ComboSelected provides SelectedIndex property. (TFS:13757)
- Added support of selecting multiple rows by selecting one row & dragging mouse over other rows. (TFS:5505)

### New features

- Added the Select method. This method selects a range of cells. (TFS:13756)

## C1.Win.C1TrueDBGrid.Excel

### Initial release

- Export to Excel extension C1.Win.C1TrueDBGrid.Excel.4.dll/
  Adds method SaveExcel to C1TrueDbGid.

## C1.Win.Calendar

### Initial release

- WinForms Calendar control. (C1.Win.Calendar.4.dll)

## C1.Win.FlexReport

### Bug fixes

- Content of subreport is not refreshed if subreport has no parameters and user presses "Refresh" in preview. (TFS:233859)
- Arial Narrow font processed incorrectly, as regular Arial font. (TFS:233723)

## C1.Win.TreeView

### Breaking changes

- Removed the ContextMenu property from the C1TreeNode. Added the BeforeContextMenuShow event into the C1TreeView.

### Bug fixes

- C1TreeView reset styles settings when a theme was applied.

### Improvements

- Added support of drag & drop for multiple selected nodes. (TFS:207529)

### New features

- Added the CustomContentPresenter property to C1TreeColumn. Added the CustomContentPresenter abstract class.
- Added the Tag property to C1TreeNode. (TFS:229523)
- Added a tooltip support. (TFS:229203)
- Added the ScrollPositionChanged event to C1TreeView. (TFS:229506)

## ComponentOne WinForms Basic Library

### Bug fixes

- GridRow.HitTest worked incorrectly when the GridCell.RowSpan was set.

# Release version 4.0.20163.231 - Jan-16-2017

## C1.C1Word

### Bug fixes

- Text are not fit into field's bound in RTF/Word/Excel exported file when use "TextFitMode". (TFS:191006)
- An unhandled exception of type 'System.FormatException' occurred in C1.WPF.Word.4.dll. (TFS:233860)
- Table contents are shown as twice in output RTF document if any content is added under the RTF table. (TFS:233976)

### Improvements

- Added support expand (spacing between characters) value for DOCX format.

## C1.Win.C1Command

### Bug fixes

- When the C1DockingPage is selected and is opened, then if TabPages collection is cleared, then the selected tabpage does not get deleted and continues to display. (TFS:75980 case1)
- There is a lot of space encountered between tabs when Office2007 or Office 2010 TabStyle is applied and tabs between two tabs are hidden. (TFS:227580)
- Restoring two side-by-side aligned C1DockingTab creates wrong placement. (TFS:209455)
- C1Outbar crashes when OutPage with controls were collapsed. (TFS:219454)
- The size of TopicBar page was less than a size of current font. (TFS:227312)

### Improvements

- C1DockingTab prevents C1DockingTabPage from being dragged under Windows Task bar. (TFS:19665)

## C1.Win.C1Document

### Bug fixes:

- Text are not fit into field's bound in RTF/Word/Excel exported file when use "TextFitMode". (TFS:191006)
- Image in the report's header are shown twice when export to the Excel file. (TFS:233985)
- Rotated text are distorted in exported excel file if text field is set border. (TFS:230964)

## C1.Win.C1FlexGrid

### Bug fixes

- Width of TreeStyleFlags were not fit when use the "TreeStyleFlags" in C1FlexGrid. (TFS:233879)
- [C1TouchToolKit] TargetControl event data of GcMagnifier events returned garbled characters on magnifying in edit mode. (TFS:37050)
- C1FlexGrid displayed all the rows when manually assigning FilterDefinition with 'Equals' numeric filter that is set to nothing. (TFS:201873)
- Multiline text containing line feeds lost top alignment in the grid. (TFS:222075)
- C1SearchPanel searched data was not highlighted when C1FlexGrid is placed on C1Ribbon Form. (TFS:222792)
- Clicking on column header took time to select data in C1FlexGrid (TFS:227978)
- C1flexgrid paste result was not correct with sort. (TFS:229947)
- [FlexGridSearchPanel] Toolbox icon of C1FlexGridSearchPanel was missing in VS Toolbox. (TFS:232856)
- [FlexGridSearchPanel] When SearchMode is Always, and when '"' is typed as first key, exception was thrown. (TFS:227810)

## C1.Win.C1GanttView

### Improvements

- Added possibility to fit C1GanttVie into a page while printing. In this connection it's added two properties PrintInfo.FitHorizontally and PrintInfo.FitVertically. (TFS:220623)
- Added the following events th C1GanttView: MouseDown, MouseUp, MouseClick, MouseDoubleClick, MouseWheel, KeyDown, KeyUp, KeyPress, Paint. (TFS:200300)
- Task could not be edited through grid while grouping tasks. (TFS:231027)

## C1.Win.C1Input

### Bug fixes

- [C1ComboBox] Even if SelectedIndex of C1ComboBox is set, it doesn't sometimes become effective. (TFS:233696)
- [C1ComboBox] C1ComboBox did not change a value when it used ItemsImageList. (TFS:192093)
- [C1NumericEdit] "NaN" is not displayed when pressing F4 when NumericInput and NumericInputKeys.F4 properties are True. (TFS:33952)
- [C1NumericEdit] Decimal char could be entered even if NumericInputKeys.Decimal property is False. (TFS:33952)
- [C1DateEdit] Custom format that contains 'E' for EditFormat is not displayed correctly in edit mode. (TFS:139827)

## C1.Win.C1InputPanel

### Bug fixes

- Validated event fired multiple times when a MessageBox is shown from the event handler. (TFS:203791)
- Validating event fired multiple times when a MessageBox is shown from the event handler. (TFS:203791)

## C1.Win.C1IntelliSpell

### Bug fixes

- Incorrect duplicate words was appeared in Resx files. (TFS:38167)

## C1.Win.C1List

### Bug fixes

- C1Combo items were not rendered when the form closed and loaded without creating anew. (TFS:223448)

## C1.Win.C1Ribbon

### Bug fixes

- DropDownList in Custom VisualStyle RibbonComboBox Loses Ampersand. (TFS:227315)

## C1.Win.C1TrueDBGrid

### Bug fixes

- NullReferenceException was occurred when the DataView was changed in the AfterFilter event. (TFS:228308)
- Cursor was not displayed in the edit mode when an editor has a few lines and the font size more then 9. (TFS:228417)

## C1.Win.FlexChart

### Bug fixes

- Height of the bars in BarChart is shortened when it includes a long value for the "BindingX" parameter.(TFS:230947)

## C1.Win.FlexReport

### Bug fixes

- Now if label is not specified for Series of FlexChartField then Series.YExpression will be used as series caption. (TFS:233017)
- C1FlexReport uses invalid paper size for B4 and B5 sizes. (TFS:227796)

## C1.Win.FlexViewer

### Breaking changes

- The default value for the C1FlexViewer.UseIncrementalSearch property changed from False to True.

### Improvements

- Added a notification when the document is saved to a file (see TFS:230220).
- Optimized printing multiple copies (see TFS:230322).

## C1.Win.TreeView

### Bug fixes

- Long text of Nodes was not shown completely when BorderStyle=Full, Border=2 and WordWrap=True. (TFS:224751)
- The LineStyle of C1TreeView was not shown properly when the LineStyle was set to 'Custom'. (TFS:224956)
- "InvalidCastException" exception was occurred when the C1TreeColumn EditorType was set as ColorPicker and a value of cell didn't has the Color type. (TFS:225022)
- DropDownButton border was shown in a cell when mouse over to another cell. (TFS:226724)
- DropDown button was shown at the right side when the RightToLeft was set to the Yes value and the EditorType was set to the ComboBox/DatePicker/NumericEdit value. (TFS:227221)
- Visual Studio stopped responding when the C1TreeView's column was changed visibility to false via designer. (TFS:230009)

### Improvements

- DataMap property translates value in a cell using a IDictionary.

# Release version 4.0.20163.226 - Jan-05-2017

## C1.Win.C1FlexGrid

### Bug fixes

- AutoSizeCols method threw exception when Rows.Count is set to 0 in C1FlexGrid. (TFS:232726)

## C1.Win.C1TrueDBGrid

### Bug fixes

- ArguementOutOfRange was occurred when the grid didn't contain a filter value and the grid contained empty rows. (TFS:232525)

# Release version 4.0.20163.225 - Dec-23-2016

##
2016 v3.5 Release

## C1.C1Excel

### Bug fixes

- [FlexGrid] Multiple issues are observed when loading .xlsx file that contains cells with thousand separators and 11 decimal values. (TFS:208468)
- Unlike build 216,'I' cursor is not shown in c1FlexGrid edit mode when loading .xlsx excel file to c1FlexGrid by using LoadExcel() method. (TFS:228390)
- Height of Image is reduced when image is added and saved to excel file using C1Excel. (TFS:223304)
- Error 'Invalid Excel OpenXml file' is occurred on opening of an excel file contains TabColor and formula after saving as another one. (TFS:197450)
- First sheet is always selected when setting 'SelectedIndex' value less than 'FirstIndex' value. (TFS:19584)
- One of the columns in the second sheet becomes invisible after saving in the different path and opening it. (TFS:15297)
- Japanese characters, font styles, watermarks and shapes are not rendered in output .xlsx file. (TFS:204191 cases 2 & 5)
- Multiple issues are observed when loading .xlsx file that contains cells with thousand separators and 11 decimal values). (TFS:208468 case 1)

## C1.C1Pdf

### Bug fixes

- Attachment Pdf document is not opened when adding attachment to pdf document by using C1PdfDocument.AddAttachment() method. (TFS:213228)
- System.NullReferenceException occurred in C1.UWP.Pdf.dll when creating lines in PdfDocument using PdfDocument.DrawLines() method. (TFS:209579)

### Improvements

- Get font data using DX library.

## C1.C1Report

### Bug fixes

- Added a few missing Japanese localization strings. (TFS:129848)
- The about link in C1Report and related components' design time action lists are not localized for Chinese and Korean locales. (TFS:29003)

## C1.C1Word

### Bug fixes

- 'System.InvalidCastException' is thrown when load the rft file contained image to C1WordDocument. (TFS:223542)
- Image in the MS Word file is not retained when load to C1WordDocument and save with Docx format. (TFS:204965)
- RTFString is not shown in output when save the C1WordDocument with RTF format. (TFS:224900)
- Text in the table are not shown when save the C1WordDocument with RTF format. (TFS:224907)
- Forecolor of RTF paragraph is not effected when save the C1WordDocument with RTF format. (TFS:224991)
- Image in the MS Word file is not retained when load to C1WordDocument and save with Docx format. (TFS:204965)
- "\n" in the paragraph is replaced by underscore when save the C1WordDocument with RTF format. (TFS:218071)

### Improvements

- Changed from internal to public some properties of the Word/RTF drawing canvas.
- Changed DOCX format reader for support merged cells of the table.
- Added ForeColor for Word/RTF paragraph object.

## C1.Win.BarCode

### Bug fixes

- Improved Image property behavior when barcode is not on the form, but just in memory. (TFS:211509)

## C1.Win.Bitmap

### Bug fixes

- System.ArgumentException is thrown when rotate the JXR file by using TransformOptions. (TFS:227961)

### Other changes

- The first public build of C1Bitmap.

## C1.Win.C1Command

### Bug fixes

- "NullReferenceException" is thrown when restore the layout after docking and autoHiding. (TFS:228243)
- When docking side by side, there is no splitter between the two tabs. (TFS:191750 case 2)
- Docking tab page is not refresh to the dock position when re-dock the floating tab page. (TFS:227193)
- If toolbar contains invisible items, layout is changed on first form load in the Designer. (TFS:202366)
- C1DockingTab's right scroll button not rendered properly with some of the Visual style options. (TFS:223571)
- On double click, C1DockingTabPage does not return to its original position when in float state (TFS:222680 Case 1,2,3,4)
- Error message box is shown by pressing 'Ctrl+Z' after drag and drop C1CommandDock on the form. (TFS:224712)
- Docking tab page is not retained to the drop position when maximize the form after docking and floating tab page. (TFS:224749)
- BackgroundColor and BorderColor properties of NormalPage style were not serialized at design time.
- C1NavBar panel was not refreshed after VisualStyle was changed. (TFS:220896)
- C1NavBar VisualStyle (2003Olive) was not applied when set in design time. (TFS:220896)
- [C1TopicBar] Some properties of the C1TopicBar.PageStyle were not applied.

### Improvements

- [C1DockingManager] added Dragging event.

## C1.Win.C1Document

### Bug fixes:

- Setting of font-bold / italic sometimes becomes incorrect for printing or exporting when there are more than one fields. Fix double bold and italic settings. (TFS:223802)
- Setting of font-bold / italic sometimes becomes incorrect for printing or exporting when there are more than one fields. (TFS:223802)
- Exception can occur in rare cases if document contains the large blocks of text. (TFS:215531)
- Selection works incorrectly in some scenarious. (TFS:215424)

## C1.Win.C1DX

### Improvements

- Many small improvements to the common structures like Matrix3x2 and others.

## C1.Win.C1FlexGrid

### Breaking changes

- Improved the EditMask behavior for numeric fields in FlexGrid. Formerly the EditMask was used only for string fields. If EditMask was determined for numeric fields the GridEditorTextBox was used instead of GridEditorNumericTextBox. Now the GridEditorNumericTextBox is used with improved EditMask behavior.

### Bug fixes

- Unlike build 216,'I' cursor was not shown in c1FlexGrid edit mode when loading .xlsx excel file to c1FlexGrid by using LoadExcel() method. (TFS:228390)
- Grid took more time in loading when the width of a column is decreased at runtime. (TFS:206007)
- It took a long time for scrolling / resizing of the C1FlexGrid that has so many rows. (TFS:224687)
- Exception was thrown in C1FlexGrid designer. (TFS:214465)
- Opening in-built designer of C1FlexGrid having C1SplitContainerPanel as parent crashed Visual Studio. (TFS:222218)
- RowValidating event's e.Cancel did not work. (TFS:222671)
- [FlexGridSearchPanel] C1FlexGridSearchPanel's cursor was moved to start position when space symbol is typed in SearchPanel. (TFS:222793)
- Bottom border for column headers and the right border for row headers were missing. (TFS:208263)
- Arabic words did not display correctly in C1FlexGrid. (TFS:218223)
- [3350] Cell labels were shown even when the complete text is visible in the cell. (TFS:11326)
- AutoSizeCols took more time in adjusting the width of all columns in the grid. (TFS:205719)
- Text margins inside a cell was reduced from previous build. (TFS:218246)
- [FlexGridSearchPanel] Search results in grid were incorrect when setting 'FilterSearchResults' after searching using FlexGridSearchPanel. (TFS:215448)
- Percentage (%) cell value was disappeared in edit mode when loading excel file that contains percentage values. (TFS:208470)
- 'I' cursor was not displayed in c1FlexGrid edit mode when loading excel file to c1FlexGrid by using LoadExcel() method. (TFS:209409)
- [Input][FlexGrid] Flickering was observed in column header by double-clicking/opening dropdown of editor when setting some c1Input controls as Custom Editor (TFS:218009)

### Improvements

- Added HandleInvisibleChildren property to GridTree class. This property used to display or not collapse/expand button if all children of node are invisible. (TFS:128520)

## C1.Win.C1GanttView

### Bug fixes

- Some menu items from context menu of c1GanttView's chart pane were in active state although all the rows are deleted. (TFS:212864)

## C1.Win.C1Input

### Bug fixes

- NullReferenceException is thrown when reopen the dropdown after pressing delete key and setting EmptyAsNull property is set to true. (TFS:229558)
- [SplitButton] Item added to dynamically created DropDownItem object does not show at RunTime. (TFS:37336)
- C1TextBox validating goes wrong in the case of exit (lose focus) twice. (TFS:227996)
- GDI resource leak.
- [C1ComboBox] C1ComboBox was not provided circular selection on pressing key when DropDownStyle = DropDownList. (TFS:220924)
- [C1ColorPicker] The focused item and the selected item didn't match when the selected item was dragged down of dropdown portion. (TFS:117626)
- C1NumericEdit threw "OverflowException" exception on setting its value to "double.PositiveInfinity" (TFS:222683)
- [C1DateEdit] C1DateEdit's DropDown Calendar opened behind the Form if the Form was shown as a modal dialog. (TFS:207328)
- [C1CheckBox] 'Flat' and 'Pop up' FlatStyle was not displayed correctly when VisualStyle or Theme is set. (TFS:106546)
- [C1DateEdit] DateValueSelected event did not fired by using Keyboard (TFS:94009)
- C1DateEdit and C1NumericEdit were not refreshed after they theme was changed. (TFS:89210)
- [C1TextBox] White strip(or artifacts) was appeared in BackColor near the border. (TFS:219200)
- [C1SplitButton] DropDownItemClicked event was fired only after the dropdown is closed (TFS:50697)
- [C1ComboBox] Key is duplicated if pressed before DropDownForm is not opened while DropDownStyle is set to DropDownList. (TFS:220924)
- Exceptions were thrown when the Value property was set DBNull.
- [C1ComboBox] DropDown of C1ComboBox was opened while DropDownStyle=DropDownList even if character that does not match the items from dropdown list is pressed. (TFS:210650)
- The dropdown list of C1FontPicker was still opened when the dropdown form of C1DropDownControl was parent of C1FontPicker and the C1DropDownControl was closed. (TFS:218856)
- Height of the blank row is less than the other rows when font size of C1ComboBox is increased. (TFS:207919)
- [C1RangeSlider] RightToLeft property did not work. (TFS:110740)
- [C1Button] VisualStyle of C1Button was not changed to Custom on applying BackColor after VisualStyle is set. (TFS:79386)
- [C1FontPicker] White space was appeared at the end of ListBox in the dropdown and selected font was not shown in the text area when select the font by using arrow Key. (209342)
- [C1DBNavigator] BackColor remained in some part of C1DBNavigator even after the resetting. (TFS:97009)
- [C1TextBox] C1TextBox did not apply the Multiline property when the Enabled was set to false. (TFS:207708)
- [C1DateEdit] ValueChanged event of C1DateEdit did not fired when pressing UpDown arrow key or clicking UpDown button of control. (TFS:213255)
- [C1Label] Sometimes the C1Label border was drawn incorrectly or not drawn at all when BorderColor property is changed. (TFS:139514)
- [C1TextBox] C1TextBox's Text was selected when the focus was shifted to it and Escape key was pressed for the first time. (TFS:210401)
- [C1TextBox] ForeColor property value was changed to SystemColors.WindowText when Enabled property is set to False. (TFS:79450)
- [C1TextBox] Letters in C1TextBox can not be deleted forward by pressing Delete key when EditMask is set (TFS:205416)
- [C1NumericEdit] Change the Calculator.ButtonFlatSyle property value before the Calculator form is opened did not give any effect. (TFS:73388)

### Improvements

- Removed "C1Input" from validation and data conversion error dialogs' captions. (TFS:44271)
- [C1ColorPicker] The C1ColorPicker default size was increased. (TFS:206862)

## C1.Win.C1IntelliSpell

### Bug fixes

- [c1IntelliSpell] Unlike VS2010 , Context menu of Task List is missing in VS 2015 and VS15 preview. (TFS:208481)
- [c1IntelliSpell] Unlike VS2010 , 'Next' and 'Previous' navigation button in ComponentOne IntelliSpell Dialog box is not work correctly in VS2015 and VS15 Preview 4 (TFS:208482)
- Fixed the c1IntelliSpell sporadical VS2015 hanging in the case when it makes Undo pending changes and close file in editor simultaneously.

## C1.Win.C1List

### Bug fixes

- [C1Combo] Items are not completely visible in the drop down list when the list is opened for the first time in the case of MaxDropDownItems property had increased. (TFS:110086)
- [C1Combo] Extended part of dropdown was not populated with columns if DropDownWidth greater then C1Combo. (TFS:214125)

## C1.Win.C1Report

### Bug fixes

- Printing progress in Print progress dialog is not updated when C1PrintDocument is printed from code via C1PrintDocument.Print(...) method.(TFS:214436)

## C1.Win.C1Ribbon

### Bug fixes

- C1Ribbon dropdown/popup windows worked after pressing the Windows+Down/Windows+Up keys. (TFS:83498)

### Improvements

- Added the AllowExtendedSubmenuHeight property to RibbonApplicationMenu to allow the submenu options to extend outside the application menu. (TFS:119849)

## C1.Win.C1SpellChecker

### Bug fixes

- [Localization] Description of "BadWordFound" event was not localized in Japanese. (TFS:223894)
- No description was shown for the "BadWordAdded" event handler in the Properties Grid. (TFS:223867)

### Improvements

- Added C1Spellchecker.UserDictionary.BadWordAdded event. (TFS:68661)

## C1.Win.C1Themes

### Improvements

- Theme Office2007Blue was changed for C1TextBox. (TFS:194456).

## C1.Win.C1TrueDBGrid

### Bug fixes

- Editor of first row was still visible when the condition filter was applied. (TFS:222556)
- Text from FilterBar disappeared when user typed second "/" in DateTime column. (TFS:221443)
- Application hung when C1TrueDbGrid's MarqueeStyle was set to FloatingEditor and C1TrueDbGrid was added to nested SplitContainer. (TFS:219459)
- In HeadingStyle, Borders style setting did not apply to grid. (TFS:10721)
- AfterColEdit event was raised after the TrueDBGrid Filterbar was lost focus. (TFS:42197)
- AfterFilter event was raised twice after a checkbox column was filtered.(TFS:42219)
- ConditionFilter worked incorrectly with conditional operators: Contains, DoesNotContain, BeginsWith and EndsWith when datatype of column was DateTime.
- HeadingStyle font did not reset after PrintPreview was shown. (TFS:21260)
- Unwanted blank row space was observed when EmptyRows was set to true and the last row visibility was set to false. (TFS:60633)
- The Print method didn't used PrinterSettings of TrueDBGrid. (TFS:20941)
- A drop down list was shown to the upper left square of the grid, after double-clicking on the combobox type cell when the AutoDropDown was set to true. (TFS:214575)
- EvenRowStyle/OddRowStyle didn't apply for buttons. (TFS:149235)
- C1TrueDbGrid filter did not changed when the FilterText was set from event handler for the ribbon button Click event. (TFS:214795)
- Application did not close when ShutDownMode was set to "When last form closes" and TrueDBGrid's combobox was opened. (TFS:215135)
- Checkbox wasn't checked in the filter dropdown although all data was shown in the grid. (TFS:214906)

## C1.Win.FlexChart

### Bug fixes

- Description and remarks of the properties of Funnel Chart's Options are incorrect. (TFS:228077, 228076)
- LineMarker disappears after chart's ancestors changing.
- Legend is not displayed when binding data with series in Funnel chart.
- LineMarker is still visible by changing another tab page when adding C1FlexChart to TabControl.
- FunnelChart is not displayed correctly when binding data that contains null value. (TFS:227298)
- Designer issues resulting in exceptions and design time property sheet issues are fixed. (TFS:227230)
- LineMarker improvements.
- SymbolRendered event now fires when appropriate (TFS:207186)
- LineMarker in Rotated=true mode
- LineMarker exception when top form's size changes
- Moving/Dragging the LineMarker does not changes its Content when using "Bar" ChartType (TFS:223801)
- Fixed TFS issue: 224746

### Improvements

- AxisScrollbar behavior improvements.
- Moved design time code to separate assemblies to permit FlexChart and FinancialChart to operate in ClientProfile.
- Added funnel chart

## C1.Win.FlexPivot

### Bug fixes

- Even if the values of upper and lower cells are same, these cells didn't merge together. (TFS:204147)

## C1.Win.FlexReport

### Breaking Changes

- SubreportParameterValue was renamed to ReportParameterValue.
- SubreportParameterValues was renamed to ReportParameterValues.

### Bug fixes

- Vector images were garbled (TFS:210217).
- C1FlexReport.EndPage event not fired for last page of the report. (TFS:227288)
- BarCodeField rendered incorrectly in some rare cases if it is within GroupHeader. (TFS:225008)
- Calculated report field rendered incorrectly if it is in the ReportFooter and linked with report's Main DataSource, it shows no data. (TFS:223736)
- Error occurs during rendering if name of field of DataSource equals to VBScript keyword like "To", "While" etc. (TFS:221944)
- Report can render incorrectly in Turkish locale if any identifiers in the report (such as report or data field names) contain the character "i". (TFS:218530)

### Improvements

- Added two more variants to define hyperlink in the report (see FieldBase.Hyperlink property):\
- ReportLinkTargetScript. Script will be executed when user perform navigation, see "Interactive Report" sample.\
- ReportLinkTargetBookmark. Added properties Report and ParameterValues properties which allow to create a link to another report or to same report with different parameters.
- Added new FlexChartField report field, supporting the following chart types: Column, Bar, Line, Scatter, LineSymbols, Area, Spline, SplineSymbols, SplineArea, Bubble, Candlestick, HighLowOpenClose, Funnel. The new FlexChartField is supported on all platforms (WinForms, WPF, UWP). FlexChartField internally uses the FlexChart control, so now C1.Win.C1Document.4 and C1.Win.FlexReport.4 assemblies require the C1.Win.FlexChart.4 assembly.
- Now ForcePageBreak specified for FieldBase, Section or SubSection assigned to the RenderObject.LayoutBreak this allows to improve exporters.
- Now ForcePageBreak specified for FieldBase, Section or SubSection assigned to the RenderObject.LayoutBreak this allows to improve exporters.

## C1.Win.FlexReport Designer App

### Breaking changes

- Added "Add FlexChart" button on the INSERT tab. The "Add Chart" button is now hidden by default (the new "Show legacy Chart field" checkbox on the Options dialog brings it back).

## C1.Win.FlexViewer

### Bug fixes

- InvalidOperationException was occurred by clicking the Next or Previous button on the search bar of C1FlexViewer while search is in progress. (TFS:215358)
- It was impossible to switch from Custom paper size to a standard paper size in the Page Setup dialog.
- Disabled the Page Setup and Portrait/Landscape buttons for PDF documents. (TFS:222016)
- When a form containing C1FlexViewer is inherited from another Form, the page count label in C1FlexViewer always displayed zero (0). (TFS:219196)
- An error occurred when the type of report parameter default value does not match the type of allowed values.
- Keyboard support was broken for the Thumbnails view in RightToLeft mode.
- Backward/forward navigation was broken in RightToLeft mode.

### Improvements

- Added the ThumbScrollDirection property specifying the direction of scrolling for the Thumbnails view.
- Slightly changed scrolling animation.

### Other changes

- Added reference to C1.Win.FlexChart.4.dll.

## C1.Win.TreeView

### Bug fixes

- InvalidOperationExcepiton was occurred at design time after 'Ctrl+Z' where pressed. (TFS:227960)
- The SelectedNodes property had the EditorBrowsableState.Never attribute and the IntelliSense did not see it. (TFS:223560)
- Text of nodes was cut off when a node was collapsed or expanded and the RightToLeft was the Yes value. (TFS:224989)
- Exception was occurred after cell was edited and DataColumn was read only.
- Vertical alignment 'Top' was shown as 'Bottom'.
- 'Remove' and 'Add child' buttons were not localized in TreeNodes Editor. (TFS:222631)
- The ImageList control was removed after the c1TreeView was removed at design time. (TFS:218968)
- Vertical scrollbar of c1TreeView did not scroll while dragging any node to bottom most or top most nodes. (TFS:218982)
- Redo/Undo function did not work correctly in c1TreeView at Design Time. (TFS:211024)

### Improvements

- The focus rectangle equals the cell size.

### New features

- Added the C1TreeNode.IsReadOnly method. This method gets a value indicating whether the contents of the nodes cell can be changed.
- Added the LinesStyle property of style. This property gets or sets the style of dashed lines.
- Added C1TreeColumn.DataMap. This property gets or sets an IDictionary used to associate cell values with display values in the ComboBox editor.
- Added new default editors: DatePicker, NumericEdit, ColorPicker.
- Added the support of themes for default editors.
- Added the ContextMenu property into the C1TreeNode.

### Other changes

- Styles of nodes applied to the contents of the node but not the row.
- TreeView showed a combobox editor always. Now TreeView shows the combobox editor only for a hot node cell.

## C1Themes Designer App

### Bug fixes

- Enabled maximize button in regular and ribbon-based preview forms. (TFS:45123)
- Fixed calendar icon in theme preview. (TFS:46187)

### Improvements

- Reduced clutter in "Find" and "Filter" combos' dropdowns (e.g. if user types "h", "ho" and "hot", only "hot" will be saved in the dropdown). (TFS:44285)

# Release version 4.0.20163.212 - Nov-01-2016

##
2016 v3 Release

## C1.C1Excel

### Bug fixes

- Cannot apply underline font style to a cell in C1Excel (only WinForms). (TFS:214429)
- When the .xlsx file which the cell border is read and saved as it is, the cellborder is sometimes lost. (TFS:213511)

## C1.C1Word

### Improvements

- Added new method (AddCanvas) of the C1WordDocument class for adding drawing canvas objects to Word/RTF document.

## C1.Win.BarCode

### Improvements

- Barcode initializes with CaptionGrouping = true by default. (TFS: 207604)
- Added WideToNarrowRatio property. Use WideToNarrowRatio property to change ratio of wide and harrow bars. (TFS: 205480)

## C1.Win.C1Command

### Bug fixes

- ArgumentException is thrown after docking tab page to the top and autoHiding. (TFS:218045)
- Tab pages are overlapped when docking tab page is re-docked to the previous position. (TFS:214584)
- C1DockingTabPage does not fill the complete space as that of C1CommandDock. (TFS:191750 case 1)
- Application form goes back under next window and becomes not visible when re-docked the floating tab page. (TFS:214442)
- ArgumentNullException is occurred on DockingTab drawing when setting visualStyle of C1DockingTab. (TFS:213813, TFS:213770)
- Unhandled exception is thrown after create new theme with standard build-in theme template. (TFS:213266)
- TabPageClosed and TabPageClosing event of C1DockingManager is not fired when close the floating tab page. (TFS:210224)
- TabForeColorSelected property of C1DockingTabPage reset to ControlText at runtime when AutoHiding is set to true. (TFS:203243)

### Improvements

- [Themes, C1DockingTab] Improved theme properties tree for C1DockingTab.
  Added tab page size, tab page mode, caption trail image, C1DockingTab border colors for different states, caption padding and margin.
- [Themes, C1DockingTab] Improved theme properties tree for C1DockingTab.
  Added new properties to specify corners of different parts, hot & disabled styles for captions, tabs and buttons. (TFS:152852)
- New events in C1DockingManager TabPageClosed - Occurs after a page has been closed.
  TabPageClosing - Occurs when the currently selected page is about to be closed by the user. Allows to cancel closing the page.

## C1.Win.C1Document

### Bug fixes

- Specifies the number of milliseconds to wait for server communications. (TFS:204523)
- Line Style of Arc, Pie and Triangles are not effected in PDF and other exported files. (TFS:203746)

### Bug fixes:

- DocumentInfo specified for ExportFilter is ignored. (TFS:214352)

### Improvements:

- Now changing properties of the parameter of the C1SSRSDocumentSource will force set of C1SSRSDocumentSource.Dirty to true.
- added property:
  public int C1SSRSDocumentSource.ConnectionOptions.Timeout { get; set; }

## C1.Win.C1FlexGrid

### Bug fixes

- When a file saved with MS Excel 2003 is opened in C1FlexGrid, additional columns were seen. (TFS:213246)
- Request to provide information on setting ScrollPosition of grid in a specific scenario. (TFS:197880)
- Grid did not scroll to the bottom end by selecting all rows using Ctrl+click on Row header and then dragging to the bottom when its SelectionMode is ListBox. (TFS:209859)
- Cursor location was before last character by deleting character at last position in c1flexgrid when setting column format to 'N0' and 'C0'. (TFS:209830)

### Improvements

- Added new control C1FlexGridSearchPanel. This control is used for full text search across all data in C1FlexGrid.
- Added GetCellStyle(int row, string colName), SetCellStyle(int row, string colName, CellStyle newStyle), GetCellImage(int row, string colName), SetCellImage(int row, string colName, Image newImage) methods to C1FlexGridBase class.
  Added Add(int topRow, int leftCol, int bottomRow, int rightCol), Add(int topRow, int leftCol, int bottomRow, int rightCol, bool clearOverlappingRanges) methods to CellRangeCollection class. (TFS:206118)
- Added ApplySearch(string search, bool highlight, bool filter),
  ApplySearch(string search) methods to C1FlexGridBase class. Added SearchBackColor property to CellStyle class. This methods and properties are used for full text search across all data in C1FlexGrid.

## C1.Win.C1GanttView

### Bug fixes

- (Default) bar styles set through 'Bar Styles' dialog at run time were not affected to currently excisting tasks. (TFS:212909)
- Horizontal scrollbar jumps to the corners when scrolling knobs (arrows) were clicked. (TFS:207696)

### Improvements

- Made property C1GanttView.Project.DurationUnitMasks public. (TFS:147921)
- Added dialog like in MS Project in the case then adding task starts from nonworking day. (TFS:199424)
- Implemented import from MS Project XML file by new method C1GanttView.ImportFromMsProjectXml. (TFS:140572)
- Added a new property Task.ReflectOnGroup that indicates whether the task bar will be reflected on Group bar. (TFS:202356)

## C1.Win.C1Input

### Bug fixes

- If an object of reference type is bound to Value of C1TextBox then Value is not changed even if Text is changed. (TFS:210992)
- [C1ComboBox] UseBindingItemsSource property does not work on form load if set in Design Time. (TFS:208278)

### new features

- [C1ComboBox] Added new property TranslateValue (TFS:208277). It allows translate Value into Text using items data source.

## C1.Win.C1InputPanel

### Bug fixes

- HighlightedIndexChanged event fired twice for InputComboBox when the user clicks an item in the dropped down list. (TFS:211025)
- Validating event of InputNumericBox fired two times when the validation failed and the user tries to move to another control. (TFS:209469)

## C1.Win.C1List

### Bug fixes

- [C1List] C1List's cell value was shown as '???' when when column's data type is set to 'TimeSpan' (TFS:209865)

## C1.Win.C1Schedule

### Bug fixes

- Appointments displayed incorrectly when TimeLineView is grouped and navigated by navigation buttons. (TFS:214394)
- Appointment titles disappear when the C1Schedule is scrolled and icons are set on them. (TFS:210094)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Calendar dropdown was shown instead of numeric updown when NumberFormat was set to 'Medium Time'. (TFS:211367)
- The error message was shown when the filter of grid column was edited and datatype of column was TimeSpan. (TFS:211351)
- Data was deleted from cell whenever user enters the edit mode. (TFS:210676)
- Edit mode of TureDBGrid's cell was flick by double clicking on the cell when Column data type is "DateTime" and format is "Long Time or Short Time". (TFS:209765)
- A last character of column header was cut off in some cases. (TFS:193941)
- CellTips was shown unusually long when C1TrueDBGrid1.Style.VerticalAlignment is set to a value other than C1.Win.C1TrueDBGrid.AlignVertEnum.Top (TFS:209854)
- Hierarchical grid showed a sorted data incorrectly. (TFS:17960)
- Hierarchical grid scrolled to the left and rows got collapsed after filtering. (TFS:207694)
- Could not select multiple columns or rows by dragging mouse cursor over a section of TureDBGrid when MarqueeStyle is FloatingEditor. (TFS:14211)
- Unlike build 188, ??? is displayed in c1TrueDBGrid when column's data type is set to 'TimeSpan'. (TFS:209487)
- Some format was shown as "01/01/0001" and "???" in new row after setting AllowAddNew is set to true and Column data type is "DateTime". (TFS:209742)

## C1.Win.FlexChart

### Improvements

- Added SVG rendering.
- INotifyPropertyChanged DataSource elements are now tracked.
- FinancialChart now shows default data at design time to allow styling.
- Financial Chart control is no longer Beta and is licensed for Studio Ultimate and Studio Enterprise.
- Added Sunburst, Polar and Radar charts.
- Added Annotations.

## C1.Win.FlexReport

### Bug fixes

- All fields of child group are removed when user deleted parent group. (TFS:213294)
- In some cases text selected in viewer copied not fully if report contains CheckBoxField. (TFS:211679)

## C1.Win.FlexReport Designer App

### Breaking changes

- Rather than unconditionally selecting all fields in the report, "Select All" (Ctrl+A) now selects fields depending on the current selection:
  o If there are selected sections, all fields in those sections are selected.
  o Else if there are selected sub-sections, all fields in those sub-sections are selected.
  o Else if the primary selection is a field, all fields in its sub-section are selected.
  o Else, all fields in the report are selected.
  If following the above steps the same fields are re-selected that were selected before, all fields in the report are selected.

### Bug fixes

- Fixed app's name in Japanese locale. (TFS:204516)

### Improvements

- Added ability to open expression editor when creating user defined values for parameter in AllowedValuesDefinition editor. (TFS:135783)

## C1.Win.FlexViewer

### Bug fixes

- When the SelectMouseMode property is set to false, the user could still select the text with Ctrl+A but she can't remove the selection. (TFS:212905)

### Improvements

- Added the ability to select text on multiple pages.
- Added the "Select All" action and context menu item.

## C1.Win.TreeView

### Breaking changes

- TreeBoundMode property was renamed to BindingMode. TreeBoundMode enum was renamed to BindingMode.

### Bug fixes

- CryptographicException was occurred when a C1TreeColumn was initialized.
- ApplyNodeStyles and ApplyNodeCellStyles events of TreeView was not getting triggered. (TFS:208033)
- Disabled state of style wasn't supported.

### Improvements

- Styles of tree nodes and cells were changed, now it saves changed properties only.
- Added support of theme scrollbars.
- Default size of nodes was changed.
- Added new icons for 'expand' button and checkbox. Added new CheckBoxStyle and ExpandButtonStyle properties to TreeViewStyles class.

### Other changes

- Added translated strings into Japanese, Korean and Chinese.

## C1ReportDesigner App

### Bug fixes

- If the .settings file is corrupt, the application crashes on startup. (TFS:214796)

# Release version 4.0.20163.191 - Sep-21-2016

##
2016 v3 Preliminary

## C1.C1Excel

### Bug fixes

- Some number in the Paragraph Field are not shown in exported excel file. (TFS:207872)
- [the second case] when .xlsx file is read and saved just as it is, cell format (forecolor, backcolor and horizonntar arrangement, etc.) sometimes changes. (TFS:189899)

## C1.C1Report

### Bug fixes

- Specific character does not get exported to RTF format correctly. (TFS:202996)

## C1.Win.C1Command

### Bug fixes

- The second horizontal toolbar is shown below the first in C1CommandDock. (TFS:202366)
- Project was shown behind the opened file after clicking EditCommandLink/EditCommandProperties/ChangeLinkedCommand from floating toolbar of C1MainMenu. (TFS:202345)
- ContextMenu of C1MainMenu is not same with the previous build when right click on the C1MainMenu. (TFS:205557)
- Error Message box is shown when click 'About C1CommandLink' after clicking 'Append Item...'
  (TFS:205323)

## C1.Win.C1Document

### Bug fixes

- Text field in the some specific file is not shown in exported excel files. (TFS:205548)
- Added Description attribute for several properties. (TFS:203726)

## C1.Win.C1FlexGrid

### Bug fixes

- C1FlexGrid scrolled to leftmost when selecting all cells and then sort rightmost column. (TFS:201305)
- Changing DPI caused Grid to print inconsistent font size. (TFS:202017)
- FlexGrid did not accept empty value in unbound mode if DataType of column is not nullable and the original value was changed previously. (TFS:206138)

## C1.Win.C1GanttView

### Bug fixes

- SplitTask popup was not closed by using Esc key. (TFS:200321)
- Size of indicator of percent complete did not increase while its bar height is increased and then dragging task percent complete icon on chart pane. (TFS:199452)
- Tasks were expanded when right-click on collapsed group header icon. (TFS:199562)
- 'Task Information' dialog box appears instead of 'Link Information' dialog by clicking some part of predecessor link when setting negative lag (Lead). (TFS:204081)
- Predecessor link with negative lag was cut off in print preview of c1GanttView. (TFS:204091)
- Predecessor task did not move according to the numbers of lags set through 'Task Information' dialog box. (TFS:204092)
- OldIndex and NewIndex properties of ListChangedEventArgs always returns 0 (Zero). (TFS:207940)

### Improvements

- Made Task Info Dialog Enabled when C1GanttView is in Read Only. (TFS:204390)

## C1.Win.C1Input

### Bug fixes

- [C1FontPicker] 'DropDownFromAlign' property was not occurred in C1FontPicker although 'DownDownFormAlignChanged' Event is occurred. (TFS:198687)
- White strip was visible in BackColor of C1TextBox when disabled. (TFS:82563)

## C1.Win.C1InputPanel

### Bug fixes

- Validating event was not correctly cancelled when e.Cancel = True in Validating event of InputNumericBox. (TFS:208018)
- GotFocus event of InputComboBox was fired although focus is lost by setting "DropDownStyle=DropDownList". (TFS:201674)
- Second form was activated when open the dropdown of InputComboBox after setting "TopMost=True" for the Form. (TFS:201627)

## C1.Win.C1List

### Bug fixes

- [C1List] ??? is displayed in the DateTime column with NumberFormat property set to "Short Date" when the Format of the system was set to Finnish (Finland) (TFS:204316)

## C1.Win.C1Ribbon

### Bug fixes

- RibbonTab could not be opened the second time in Minimized mode after updating RibbonLabel while the tab popup is visible. (TFS:201839)
- Two tabs were selected after adding a new tab from the properties grid at design time. (TFS:204005)
- An issue occurred when remove and add RibbonContextualTabGroup programmatically. (TFS:204330)
- A small image applied on a button in LeftPaneItems of RibbonApplicationMenu displayed as large image. (TFS:206376)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Grid's color scheme is not applied on the exported excel file when UseGridColors property is set to true. (TFS:207970)
- Grid displayed empty rows when the rows contains line feeds "\r\n". (TFS:208237)
- Filter was not cleared when FilterText property is set in code and Clear button in FilterDropdown is clicked at runtime. (TFS:203765)
- Filter of data source was incorrect when a column filter applied without changes. (TFS:198514)
- ??? was displayed in the DateTime column with NumberFormat property set to "Short Date" when the Format of the system is set to Finnish (Finland) (TFS:204493)

### New features

- Added new member 'Fill' to 'BackgroundPictureDrawModeEnum'. With 'Fill' option the image is stretched and aspect ratio is saved. (TFS:88030)

## C1.Win.FlexReport

### Improvements

- Added support of Date parameters, see ParameterType.Date.
- Added property:
  int Parameter.MaxLength { get; set; }
  Gets or sets the maximum number of characters that can be manually entered into the string parameter.

## C1.Win.FlexReport Designer App

### Bug fixes

- Fatal error is thrown when edit the report that has no DataSource by using smart tag panel of C1FlexReport. (TFS:205399)

## C1.Win.TreeView

### Bug fixes

- Remove button did not work in TreeNode Editor. (TFS:204003)
- Indicating lines between nodes were shown in second column when first column is hidden by resizing. (TFS:204064)
- Style of Column did not apply in design time. (TFS:204049)
- TreeNode Editor dialog is immediately closed by double clicking TreeNodes in TreeNodeEditor. (TFS:204415)
- Indicating displays lines are separated with c1TreeNodes by scrolling horizontal scrollbar when RightToLeft=Yes (TFS:204056)
- Expand/Collapse icon was changed without changing expand state of node when e.Cancel is set true in both of Collapsing and Expanding events. (TFS:207542)
- 'NullReferenceException' was occurred while pressing 'Shift' key and selecting the node by mouse at the same time. (TFS:207521)
- 'NullReferenceException' was occurred after editing node when data source is self-referencing.

### Improvements

- C1TreeColumn.DisplayFiledName property was changed: last field name sets the field to be displayed in the column on all of the following levels. (TFS:207498)

## ComponentOne WinForms Basic Library

### Bug fixes

- Added support RTL to ScrollablePanel when the ContentElement sets the offsets in the GetScrollOrigin method. (TFS:204056)
- Width of GridPanel cell was set incorrectly in some case when AutoWidth = true.
- Hidden some properties of C1.Framework.XView from PropertyGrid (these properties are for internal use only).

# Release version 4.0.20162.193 - Sep-23-2016

##
2016 v2.5 HotFix

## C1.Win.C1Command

### Bug fixes

- Tab bar disappears from the window permanently when enough space is not available to accommodate it. (TFS:209439)

## C1.Win.C1FlexGrid

### Bug fixes

- Cell of C1FlexGrid could not be changed when setting cell editor's multiline property to false. (TFS:209521)

## C1.Win.C1Input

### Bug fixes

- System.NullReferenceException thrown when form containing C1Input.C1TextBox control is closed/disposed. (TFS:209440)

# Release version 4.0.20162.188 - Aug-26-2016

## C1.C1Pdf

### Bug fixes

- Hyperlink in the C1PdfDocument is not worked when hyperlink is set by HTML <a> href Attribute. (TFS:204382)

## C1.C1Word

### Bug fixes

- Japanese About box is shown when add C1WordDocument of C1Word.2dll (eng build) onto the form. (TFS:152899)
- Table borders are not shown and text are overlapped when save the C1Word with Docx format. (TFS:146519)
- Image icon jump to new line in table when save with Docx format. (TFS:151254)
- Table.BackwardDiagonal and Table.ForwardDiagonal borders are not shown when save the document with RTF Format. (TFS:153087)

## C1.Win.C1Command

### Bug fixes

- NullReference exception is shown after clicking the autoHide button when c1Mainmenu is contained in Application Form. (TFS:204195)

## C1.Win.C1Document

### Breaking Changes:

- HtmlFilterBase: default value of SingleFile property changed to true.

### Bug fixes

- Text is corrupted in some places when report export to PDF. (TFS:204527)
- Borders of Ellipse,Arc and pie are shown as rectangle box in exported PDF file when SweepAngle of shapes is set to 360. (TFS:203712)

## C1.Win.C1InputPanel

### Improvements

- Added the missing descriptions for members of the following enumerations: StyleBrush, StyleColor, StyleConst, StyleFlag, StyleFont, StyleGlyph. (see TFS:195750)

## C1.Win.C1Ribbon

### Improvements

- Added the missing descriptions for members of the following enumerations: StyleBrush, StyleColor, StyleConst, StyleFlag, StyleFont, StyleGlyph. (TFS:195750)

## C1.Win.FlexChart

### Bug fixes

- Various bug fixes.

### Improvements

- Various improvements.

## C1.Win.FlexReport

### Bug fixes

- Application hangs up when XMLLink specified in DataSource.DataProvider and name of table specified as report parameter. (TFS:205351)
- ImageField does not render image correctly if its Picture property specified as expression and expression returns path to the image file. (TFS:204387)

## ComponentOne WinForms Basic Library

### Bug fixes

- Hyperlink in the C1PdfDocument is not worked when hyperlink is set by HTML <a> href Attribute. (TFS:204382)

# Release version 4.0.20162.182 - Aug-17-2016

## C1.C1Excel

### Bug fixes

- When an excel file is loaded and saved using C1Excel, blank cells appear with a black background in the resultant file. (TFS:200400)

## C1.C1Word

### Bug fixes

- Styles in the rtf file are not effected when load the rtf file to C1Editor. (TFS:145656)

### Improvements

- Changed behavior: not disposed stream at DOCX saving.

## C1.Win.C1Command

### Bug fixes

- DockingStyle of C1CommandDock is disabled when docking c1dockingTabpage to another c1dockingTabpage after setting 'Dock' property is set to 'Fill'. (TFS:203151)
- DockingTab is not able to dock to another docking by using DockingStyle when two dockingTab is placed in one CommandDock. (TFS:200741)
- C1Docking TabPage does not fill the complete space as that of C1CommondDock. (TFS:191750 case1)
- Height of C1DockingTab is not retained at run time although height of C1DockingTab is changed at design time. (TFS:203575)

### Improvements

- new component C1DockingManager. Allows disable/cancel certain docking actions. (TFS:194427, TFS:150359)
- [C1NavBar] Style-defining properties are collected under a roof of a new Style property. (TFS:151591)

### New features

- [C1TopicBar] New property C1TopicBar.PageStyles. Allows to customize Font, Border, Background, ForeColor, ArrowColor of topic pages. (TFS:151969)

## C1.Win.C1Document

### Bug fixes

- [C1PdfDocumentSource] Disabled the "Text Select Tool" and "Find" buttons in C1FlexViewer when load the pdf file onto it. (TFS:202190)
- Added sanity code for SetPrintSettings methods, C1PageSettings may be null (XLS/XLSX/DOCX/RTF exports).
- Added support of hyperlink actions to the C1SSRSDocumentSource.
- (partly) Rotated text applied by "TextAngle" are not rotated when export to RTF/Word/Excel files. (TFS:190933)
- Font color of "RTF Field" is not effected in exported Docx and RTF files. (TFS:201537)
- Font type and size of RTF field are not retained in exported Docx and RTF files. (TFS:201552)
- Page Size and Orientation of the report changes when exported to excel. (TFS:201875)
- Excel and RTF/Word export option forms: removed "Open XML document" option, document type is determined by the caller (such as toolbar button). (TFS:150186, 150337)
- [WF][UWP]Text in the Paragraph field in the Vertical WritingMode are wrong direction in output RTF/Docx/Excel. <<TFS:196271>>

### Improvements:

- Following members of the C1DocumentSource were made public (were internal):
  -- public void Generate()
  -- public IAsyncActionWithProgress<double> GenerateAsyncEx()
  -- public Task GenerateAsync()
  -- public event EventHandler<AsyncCompletedEventArgs> GenerateCompleted
  -- public void Export(Export.ExportFilter exportFilter)
  -- public IAsyncActionWithProgress<double> ExportAsyncEx(Export.ExportFilter exportFilter)
  -- public Task ExportAsync(Export.ExportFilter exportFilter)
  -- public event EventHandler<ExportCompletedEventArgs> ExportCompleted
  -- public void Print(C1PrintOptions options)
  These methods allow to work with C1DocumentSource descendants (C1SSRSDocumentSource, C1FlexReport, C1PdfDocumentSource) in a similar way.
- Added C1.Win.C1Document.C1TextSearchManager class which can be used to search a text with document managed by the C1DocumentSource.

## C1.Win.C1FlexGrid

### Bug fixes

- C1FlexGrid Highlight style wordwrap caused multi column drop down to display incorrectly. (TFS:201542)

## C1.Win.C1GanttView

### Bug fixes

- 1.Selected unit in 'Units' comboBoxes was not correspondent to its value. 2.Selected format in 'Format' comboBoxes was not updated according to selected 'Units' in 'Units' ComboBoxes in three 'Tier' Tabs (Top Tier, Bottom Tier, Middle Tier). (TFS:201891)
- '{0:D} is nonworking' was shown when selecting non-working days on calendar in 'Change Working Time' dialog. (TFS:199433)
- Task was drawn to non-working days in chart pane although setting valid duration that does not exceed non-working day. (TFS:201536)
- Task bar’s start date or finish date does not move when selecting the “Predecessor Type” according to the predecessors and predecessors type. (TFS:201565)
- Task bar did not move when setting negative lag (Lead) through 'Link Information' dialog box. (TFS:201566)

## C1.Win.C1Input

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

### Bug fixes

- [C1ColorPicker] Next color of selected color was not shown in the text area when selecting with arrow key. (TFS:198555)
- [C1ColorPicker] "InvalidCastException" was thrown when open the dropdown after pressing Delete key and EmptyAsNull property is set to true. (TFS:202987)
- [C1ColorPicker] "InvalidCastException" was thrown when open the dropdown after pressing Delete key and EmptyAsNull property is set to true. (TFS:202987)
- Unlike MS text box , 'ModifiedChanged' event of C1TextBox is fired two time. (TFS:199281)
- Unlike MS NumericUpDown, ValueChanged event is fired although value of C1NumericEdit is not changed. (TFS:199344)
- DropdownForm of C1DropDownControl is closed when opening the dropdown list of C1SplitButton placed on the dropdownform (TFS:194815)

## C1.Win.C1InputPanel

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

### Bug fixes

- Error Dialog box is appeared when clicking ellipse button of 'ToolTipText' of c1InputPanel Item. (TFS:203146)
- When dropdown of InputCombobox is opened and AutoCompleteMode=Suggest, two drop-down lists were opened at the same time while typing characters. (TFS:201643)
- DropDown of InputComboBox and InputDatePicker is able to open although "ReadOnly" property is set to true. (TFS:201669)

## C1.Win.C1Ribbon

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

### Bug fixes

- When dropdown of RibbonCombobox is opened and AutoCompleteMode=Suggest, two drop-down lists were opened at the same time while typing characters. (TFS:201808)
- Adding a C1Ribbon object in the form causes internal error in compiler for Win32 app. (TFS:154115)

## C1.Win.C1Schedule

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

### Bug fixes

- Improved scrolling performance in TimeLineView. (TFS:191278)

## C1.Win.C1SplitContainer

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

## C1.Win.C1SuperTooltip

### Breaking changes

- ImageCollection class moved to C1.Win assembly.

### Improvements

- The C1SuperTooltip control is now inherited from the C1SuperTooltipBase control from the C1.Win assembly.
- The C1SuperLabel control is now inherited from the C1SuperLabelBase control from the C1.Win assembly.

## C1.Win.C1TrueDBGrid

### Bug fixes

- EditorStyle did not work when MarqueeStyle is set to FloatingEditor. (TFS:137768)

### Improvements

- Added new property Wrap (instead WrapText). This property can set wrap state, where line-breaking occurs if the line overflows beyond the available block width, even if the standard line breaking algorithm cannot determine any line break opportunity, as in the case of a very long word constrained in a fixed-width container with no scrolling allowed. (TFS:148217)

## C1.Win.FlexReport

### Bug fixes

- bool C1FlexReport.BehaviorOptions.EnableAggregatesOnReportFields was added to improve
  compatibility with C1Report. Set it to true if in your report aggregate functions use report fields. (TFS:203132)

## C1.Win.FlexViewer

### Improvements

- Supported page rotation by 90/180/270 degrees, added the RotateView property to C1FlexViewer.

## C1.Win.TreeView

### Breaking changes

- The C1.Framework namespace has been moved into C1.Win assembly.

### Bug fixes

- Indicating lines between nodes did not disappear when first column isn't visible. (TFS:201963)
- Checkbox of C1TreeNode is displayed incorrectly when CheckState has Indeterminate state. (TFS:201989)
- TreeView columns wasn't able to resize when RightToLeft = Yes. (TFS:201946)
- Node's height did not update after WrodWrap property changed to false. (TFS:202006)
- C1TreeView node did not support serialize Images property in design time.
- 'Object reference not set to an instance of an object' error is occurred when adding new column at design time. (TFS:203191)

### New features

- Added new method GetNodeAtPoint. This method gets the node located at the specified point of client area.
- Added Drag & Drop. (EnableDragDrop property & ItemDrag event)
- Added new property TreeBoundMode. This property gets or sets a value indicating type of the bound mode.

## ComponentOne WinForms Basic Library

### Other changes

- Added the set of core controls and elements from the C1.Framework namespace.
- Added the core classes from C1.Win.C1SuperTooltip namespace.

# Release version 4.0.20162.176 - Aug-05-2016

## C1.C1Pdf

### Bug fixes

- "text-decoration:none" does not takes effect for "<a>" anchor tag while defining the style in DrawStringHtml() method of C1Pdf. (TFS:202215)

## C1.C1Word

### Bug fixes

- Text's alignment of original document is not retained in new document. (TFS:191068)
- Backfilling color changes in output .rtf and not effected in output .docx file when load/save the MS Word Document to C1Word. (TFS:196282)
- Font Size of MS word file is not retained when load and save in C1WordDocument. (TFS:193081)
- System.FormatException is thrown when load the docx file contained bookmark and save it in another document. (TFS:192836)
- PageBreak from MS word does not effect in C1WordDocument when load MS word file and save it in C1Wordocument. (TFS:193054)
- Position of Footer text are different in RTF and Docx Files. (TFS:196953)
- Text behind the tab character "\t" are disappeared in output RTF file. (TFS:197388)
- Background filling color of main section in the C1WordDocument is not effective in output RTF and DOCX files. (TFS:153736)
- WidthPercent of Table row is not effected in word doucument with Docx format. (TFS:153145)
- Font color of "RTF Field" is not effected in exported Docx and RTF files (TFS:201537)

## C1.Win.C1Chart

### Bug fixes

- Spline and Bezier curves no longer generate out-of-memory exceptions in some cases with pen widths greater than 1. (TFS:199983)

## C1.Win.FlexChart

### Bug fixes

- Changing the FlexChart DataSource now results in a Rebind() and the chart is correctly repopulated. (TFS:200374)
- Various bug fixes.

### Improvements

- Added Sunburst chart control for visualization of data hierarchies.
- Various improvements.

## C1.Win.FlexReport

### Bug fixes

- Fields with FieldBase.Anchor != AnchorEnum.Top split incorrectly between pages in some cases. (TFS:202376)

## C1.Win.FlexReport Designer App

### Bug fixes

- Now format painter copies more properties between different field types (e.g. from RtfField to TextField etc.). (TFS:201520)

# Release version 4.0.20162.174 - Aug-03-2016

## C1.C1Pdf

### Bug fixes

- Multiple issues in C1PdfDocument when UseFastTextOut is set to false. (TFS:201306)

## C1.C1Report

### Bug fixes

- Text of RTF Field (Field.RTF == true) rendered incorrectly if it starts with digit. (TFS:200949)

## C1.Win.C1Command

### Bug fixes

- C1TopicBar link displayed incorrectly when Align property of page is set to 'Center'. (TFS:199057)

## C1.Win.C1FlexGrid

### Bug fixes

- [46622-139] Font property of C1FlexGrid was stored in the form's designer file when a custom style is created for the grid. (TFS:82397)
- C1FlexGrid was not filtered when FilterDefinition is assigned manually. (TFS:197713)

## C1.Win.C1GanttView

### Bug fixes

- Four-digits hours and minutes changes to 3 digits when setting duration formats and then pressing 'F2' (editing). (TFS:198087)
- Task was not moved automatically when change lag in Link Form. (TFS:197758)

## C1.Win.C1Input

### Bug fixes

- Unlike build 166 NullReferenceException has occurred When C1NumericEdit is used as editor in c1Flexgrid. (TFS:201684)

## C1.Win.C1InputPanel

### Bug fixes

- New items were not rendered correctly after adding on C1InputPanel at design time if RightToLeft is set to 'Yes'. (TFS:199486)

## C1.Win.C1Ribbon

### Bug fixes

- The current ribbon tab became unselected when dragging it with the mouse to a new position at design time.

## C1.Win.C1TrueDBGrid

### Bug fixes

- Filter editor lost focus when found string is very long and columns has AutoComplite set to true. (TFS:196957)
- BackColor for Caption style does not work. (TFS:153013)
- Text of the grouped row was displayed in the next column when the column displaying group text is resized. (TFS:141765)
- Filterbar lost focus when keypressed in grouped C1TrueDBGrid. (TFS:189099)

## C1.Win.FlexReport

### Bug fixes

- CheckBoxField rendered with exclamation mark in C1FlexReportDesigner when CheckBoxField.CheckMark.Style changed to Standard. (TFS:201704)
- In some rare cases extra blank first page is added to the report on second call ofC1FlexReport.Render() method.
- Text of RtfField or Field with Field.RTF == true rendered incorrectly if it starts with digit. (TFS:200949)

### Improvements

- Now text can be specified for report's watermark or overlay. Following properties were added to the Watermark class describing C1FlexReport.Watermark and C1FlexReport.Overlay:
  -- public string Text { get; set; }
  -- public WritingMode WritingMode { get; set; }
  -- public FieldAlignEnum Align { get; set; }
  -- public Color ForeColor { get; set; }
  -- public float TextAngle { get; set; }
  -- public bool WordWrap { get; set; }
  -- public FontHolder Font { get; set; }
  -- public double LineSpacing { get; set; }
  -- public TextFitMode TextFitMode { get; set; }
  -- public double Opacity { get; set; }
  If both Watermark.Picture and Watermark.Text are specified then watermark/overlay will be rendered as image.

## C1.Win.FlexViewer

### Bug fixes

- The margins of the FlexReport kept on decreasing when Page Setup dialog box of FlexViewer is opened and closed repeatedly and Format of the system is set to Germany. (TFS:201301)

# Release version 4.0.20162.172 - Jul-21-2016

##
2016 v2 HotFix

## C1.C1Excel

### Bug fixes

- #VALUE! is shown in the cell with .xls excel file after loading and saving an excel file which has '=SUM((B1,B2))' formula with C1Excel. (TFS:195419)
- When a Excel file that has RTF texts including line break is loaded, an unnecessary blank is inserted between the 2 byte characters at the time of an RTF translation (Regression from TFS:191100). (TFS:198035)

## C1.C1Pdf

### Improvements

- Add support PDF/A compliance for PDF annotations. PDF/A bug fixing.

## C1.Win.BarCode

### Bug fixes

- Change the default encoding from shift-jis to UTF-8. (TFS:140253)

## C1.Win.C1Command

### Bug fixes

- DockingTabs not collapsing to single row. (TFS:194430)
- Ellipsis is not being displayed correctly on C1DockingTabPage Caption when there are many tabs. (TFS:197448, 106533)
- Size of DockingTab in c1CommandDock is changed by resizing c1DockingTab from different c1CommandDock (TFS:190789)

## C1.Win.C1GanttView

### Bug fixes

- Splitted task was distorted and incorrectly shown when change the duration unit. (TFS:153891)
- Duplicate filter name were allowed in Advance Filter and More Filter dialog box. (TFS:153979)
- Column name were overlapped and date from calendar view were shown outside of border in exported pdf file. (TFS:154018)

### Improvements

- Added tool strip button "Split Task" and floating tooltip to improve usability of splitting. (TFS:153895)

## C1.Win.C1Input

### Bug fixes

- Items of C1ComboBox are not shown immediately in the dropdown list by opeing the dropdown when setting 'RTL=Yes'. (TFS:198357)
- C1TextBox's Modified is false after changing text, unlike MS TextBox. (TFS:192107)
- C1DBNavigator with Command Dock gives error when form closed in designer. (TFS:191303)
- Flickering is seen in C1ComboBox when Shift+Tab is pressed in DropDownList mode, Combo's DropDown appears when Shift key is pressed (TFS: 191920)

## C1.Win.C1TrueDBGrid

### Bug fixes

- GDI+ exception is thrown, when a very long string is displayed in the grid. (TFS:199972)
- C1TrueDBGrid drew the Arabic digits incorrectly. (TFS:125579)
- C1TrueDBGrid aligned properly incorrectly when set RightToLeft. (TFS:151834)
- Condition filter parameters were not retained when the FilterDefinition is saved and loaded again. (TFS:121149)
- Exported to delimited csv file, opened in MS Excel and saved again, lost it's comma delimiters and gets instead tab delimeters (problem with encoding preamble in delimited file). (TFS:152485)
- BeforeUpdate and AfterUpdate events fired twice when there is a master detail relation between two grids and a new record is entered. (TFS:144317)
- BeforeColUpdate event fired twice before the cell is updated. (TFS:124592)
- The HorizontalAlignment property did not work for HeadingStyle when DataView of TrueDBGrid is set to DataViewEnum.Form. (TFS:152430)
- The method ColContaining did not return the exact column index when there are multiple splits available in the grid. (TFS:152840)

## C1.Win.FlexChart

### Bug fixes

- Nullable data values with more than 2000 data points are now property handled. (TFS:199560)

## C1.Win.FlexReport

### Bug fixes

- "RightToLeft" layout is not effected for Map Field in the FlexReport Designer. (TFS:194972)
- Valid ZoomLevel value is not automatically changed for Map Field when set invalid ZoomLevel value. (TFS:195205)

## C1.Win.FlexReport Designer App

### Bug fixes

- In some cases in the error list window the copy command did not work while being enabled. Now it is only enabled if there is a current entry that can be copied. (TFS:197811)

## C1.Win.FlexViewer

### Bug fixes

- If the number of copies for printing is set to more than 2, C1FlexViewer printed "square of the number" of copies. (TFS:200264)
- Page was not scrolled when slide the scroll bar of C1FlexViewer with touch. (TFS:196228)
- Text selection grips were shown far away from selection start/end when using touch to select the rotated text. (TFS:195761)

# Release version 4.0.20162.166 - Jun-23-2016

## C1.C1Excel

### Bug fixes

- Error occurs in output file while loading and saving of the border style containing .xls/.xlxs to C1Excel. (TFS:191302)
- When the report is exported to Excel file with .xls format, background color in some field may change. (TFS:195006)
- Comment of cell in result excel file is not properly shown in C1Excel when loading and saving to C1Excel. (TFS:191100)
- Unlike build 149,'System.ArgumentOutOfRangeException' has occurred when loaded excel file that saved fomula. (TFS:191200)

## C1.C1Pdf

### Breaking changes

- Added reference to C1.Win assembly.

### Bug fixes

- Column name are overlapped and date from calendar view are shown outside of border in exported pdf file. (TFS:154018 partly for EMF+)
- When ParseEmfPlus property is set true and is exported to pdf, occurs exception and shape isn't drawn correctly. (TFS:109670/part 2)
- When saving a PDF document with FontType specified as Standard or TrueType causes unexpected rendering. (TFS:153782)
- DrawString does not work correctly when StringFormat.Alignment != StringAlignment.Near and C1PdfDocument.UseFastTextOut is set to false. (TFS:190750)

## C1.C1Report

### Bug fixes

- Text in cell of RenderTable is not clipped when it is to long to fit into cell in XPS export. (TFS:153297)
- Gradient custom field rendered incorrectly if large fonts selected in system. (TFS:192647)
- RenderBarCode object renderes barcodes incorrectly if text contains chars with codes from 0x00 to 0x1F. (TFS:144535)
- C1Report RTF filter crashes if field's text starts with ' ', '(' or ')'. (TFS:191574)
- If Style.Brush is specified via SolidBrush then document will be exported to the XPS very uneffective all backgrounds are exported as images. (TFS:191333)

### Improvements

- Added German, Italian and Spanish localizations for most end user-visible strings.

## C1.C1Word

### Bug fixes

- DiagonalBorders are not shown if border width of table cells are not set and save with RTF format. (TFS:153082)
- Font type of original document is not retained when load the document and save in new document. (TFS:153407)
- (partly) Paragraph under image is not jump to new line when save the document with RTF format. (TFS:153414)
- Spelling mistake for BackFilling,ForeFilling of RtfBorderObject and RTF paragraph. (TFS:154016)
- Borders of MainSection are not shown in output DOCX file. (TFS:154014)
- "Can't Open" error is shown when save the C1WordDocument contained "RtfDateField" with Docx format. (TFS:153727)

## C1.Win.C1Chart3D

### Improvements

- The Chart3DView XScale and YScale lower limits have been changed from 0.1 to 0.01.

## C1.Win.C1Command

### Bug fixes

- Caption of docking tab page is not refreshed after floating tab page. (TFS:192548)
- [C1TopicBar] Borders of TopicLink are not updated after font of LinkStyle was changed. (TFS:193082)
- C1DockingTabPage is disappeared when maximized the form after docking and floating tab page. (TFS:192397)
- NullReference Exception is thrown when maximized the form after docking 'Tab Page' by using DockStyle property and Auto Hiding. (TFS:192406)
- If navigating to another page, ArgumentOutOfRange Exception is thrown when opening DockingTabPage in float style. (TFS:83247)
- Text of tab page is cut off when floated tab page is changed to 'Docked' by double clicking on header of floated tab page at Maximized state. (TFS:189903)

### New features

- [C1TopicBar] Added new property C1TopicLink.Pressed - the value indicating whether the link was pressed. (TFS:144522)
- Docked c1DockingTabPage is overlapped with another c1dockingTabPage that is auto hide state after c1Docking Tabs are dock and hide again in a scenario. (TFS:190264)

## C1.Win.C1Document

### Bug fixes

- RightToLeft text in the TextField are wrap into new line in exported Word and RTF files. (TFS:192174)

## C1.Win.C1FlexGrid

### Bug fixes

- 'ArgumentOutOfRangeException' was thrown when try to remove values before a comma in the cell that is set a numerical value. (TFS:195412)
- Checkboxes in boolean column were changed to true/false values when AutoGenerateColumns is set to false. (TFS:192842)
- Subtotaling did not group some records in C1FlexGrid. (TFS:193642)
- C1FlexGrid was not deriving the font set for the parent form at runtime. (TFS:93003)

## C1.Win.C1GanttView

### Breaking changes

- Added reference to C1.Win assembly.

### Bug fixes

- Task splitting did not store after loading from xml at design-time. (TFS:153833)
- Duration of task was changed when split the task. (TFS:153890)
- Filtering did not work on "Percent Complete" field. (TFS:153991)
- NullReference Exception was thrown when choose the "SplitTask" from context menu without selecting the task. (TFS:191131)
- "Task Information" and "Split Task" items from context menu did not work when right click on the timescale tire. (TFS:191135)
- NullReferenceException was thrown when using 'GroupBy' if task has no Start/Finish date and visible of Duration column is set to true. (TFS:191301)
- When the child tasks are collapsed or expanded, scroll bar knob flashed on and off intensify. (TFS:189578)
- The week numbers displayed in the GanttChart were incorrect in some cultures. (TFS:151897)

### Improvements

- Added Task.SplitTask(double[] durations) public method.
- Added a possibility to change the display format of Duration column in the grid of C1GanttView. (TFS:147921)
- Added C1GanttView.Schedule.CalendarWeekRule property. (TFS:151897)

## C1.Win.C1Input

### Breaking changes

- Added reference to C1.Win assembly.

### Bug fixes

- When two form opened, opening dropdown calendar in one window gets another window activated. (TFS:36466)

### Improvements

- Added ComboBoxDataBinding sample.
- [C1ComboBox] Improved RTL handling. Text in non-RTL languages doesn't change words order when shown with RTL layout.

## C1.Win.C1InputPanel

### Breaking changes

- Added reference to C1.Win assembly.
- Added reference to C1.Win.C1SuperTooltip assembly.

### Bug fixes

- Items of InputPanel disappeared after setting "RTL=Yes". (TFS:195214)

### Improvements

- InputControlHost can be saved to XML and loaded from XML at runtime. (TFS:144830)
- Added the ControlHostFromXmlNode event to C1InputPanel. It allows to detect user's ControlHost in XML tree.
- Added the ControlHostNodeName property and Load/SaveControlHostProperties virtual methods to InputControlHost.
- Added InputPanelDeserialized and ItemDeserialized events to C1InputPanel.

## C1.Win.C1List

### Bug fixes

- [C1List] Background/Foreground image of column did not show at run time. (TFS:190348)

## C1.Win.C1Report

### Improvements

- Added German, Italian and Spanish localizations for most end user-visible strings.

## C1.Win.C1Ribbon

### Breaking changes

- Added reference to C1.Win assembly.
- Added reference to C1.Win.C1SuperTooltip assembly.
- ImageEntry class has been moved to C1.Win.C1SuperTooltip assembly.

### Improvements

- RibbonControlHost can be saved to XML and loaded from XML at runtime (if supported by ControlHost developer).
- Added the ControlHostFromXmlNode event to C1Ribbon and C1StatusBar. It allows to detect user's ControlHost in XML tree.
- Added the ControlHostNodeName property and Load/SaveControlHostProperties virtual methods to RibbonControlHost.
- Added a few *Deserialized events to C1Ribbon and C1StatusBar to allow subscribing to event handlers after loading from XML.

## C1.Win.C1Schedule

### Breaking changes

- Added reference to C1.Win assembly.
- Added reference to C1.Win.C1SuperTooltip assembly.

### Bug fixes

- Improved scrolling in C1Scheduler when there are large number of appointments. (TFS:191278)
- Corrected showing first time slot when ShowWorkTimeOnly is true. (TFS:191278)

### Improvements

- Improved RTL handling. Text in non-RTL languages doesn't change words order when shown with RTL layout.

## C1.Win.C1SplitContainer

### Breaking changes

- Added reference to C1.Win assembly.
- Added reference to C1.Win.C1SuperTooltip assembly.

## C1.Win.C1SuperTooltip

### Breaking changes

- Added reference to C1.Win assembly.

### Bug fixes

- Text of C1SuperToolTip and C1SuperLabel are cut off by setting 'rtl' to bi direction attribute. (TFS:152743)

### Improvements

- Improved RTL handling. Text in non-RTL languages doesn't change words order when shown with RTL layout.
- [C1SuperToolTip] added RightToLeft property. Default property value is RightToLeft.Inherit, which means that tooltip will be shown with the same layout as associated control.

## C1.Win.C1TrueDBGrid

### Bug fixes

- When FilterBar is clicked e.LastCol and e.LastRow are reversed in RowColChange event for TrueDBGrid. (TFS:190996)

### Improvements

- Added Add(int[] rows) method for C1TrueDBGrid.SelectedRows collection. This method is used for adding several rows at once for selection. (TFS:152618)

## C1.Win.FlexChart

### Improvements

- Added FinancialChart control for visualisation of financial data(BETA license).
- Added FinancialChartExplorer sample.
- Added TrendLine class for plotting trend lines. It can be used with FlexChart/FinancialChart.
- Added Axis.TitleStyle property for customization of axis title appearance.
- Added Legend.Orientation property for setting legend orientation.
- Added Legend.Title/TitleStyle properties for customization of legend's title.
- Added FlexChart.SeriesVisibilityChanged event. The event fires when series visibility was changed.
- Added Series.AltStyle property that allows to specify alternative data point appearance.

## C1.Win.FlexPivot

### Improvements

- It is now possible to use a single field multiple times in any role, in Values,
  Rows, Columns, Filters. Main uses of this feature are to apply different
  subtotal functions to a single field at the same time (adding the field to Values)
  and to group by the same field more than once using different formats (adding the
  field to Rows or Columns), for example, to see subtotals by year and by quarter
  using the same date field.
- Added Show As feature. It allows to show results as difference or percentage with
  respect to the previous row or column. Great for showing how measured values are
  changing from previous year or quarter, compare different measures,
  and other tasks like that. To specify a Show As calculation, use the new Show As tab of
  the Field Settings dialog on a value field.
- FlexPivot grid now has a context menu with Copy, Show Detail, Field Settings.
- Added TotalsBeforeData property. It is False by default, which means that subtotals
  rows and columns appear after data rows and columns. If it is set to True, subtotals
  will appear before data.
- Weighted group operations (aggregations, subtotals) are now supported in DataEngine.
  Previously, they were only supported for the DataSource data option.
  Weighted subtotals are specified using the "Weigh by" combo box on the Subtotals
  tab of the Field Settings dialog.
- Cancelling current calculation is faster now. Current operation is cancelled if the user
  changes view settings while the engine is calculating. Previously, the engine had to
  finish the current operation (not necessarily the entire calculation; a calculation
  ususally consists of multiple operations), which in some cases could take considerable time.
  Now, cancel is virtually immediate in all cases.
- DataEngine queries now support custom operations. Both group operations (aggregation)
  and simple operations can now be custom, user-specified. Programmers can write arbitrary
  code in a custom class, that will constitute the body of a custom operation.
  Actions/calculations performed on the data are no longer limited to the stock operations,
  and performance is kept on the same lightning-speed level because loop over
  data, including indexing, is performed by DataEngine using the same optimizations
  as in the stock operations.

## C1.Win.FlexReport

### Breaking Changes:

- All export filters (classes derived from C1.Win.FlexReport.ExportFilter) were moved to C1.Win.C1Document.4 assembly, namespace for all those classes was changed to C1.Win.C1Document.Export. The following classes were affected by this change:
  C1.Win.FlexReport.GraphicsFilter -> C1.Win.C1Document.Export.GraphicsFilter
  C1.Win.FlexReport.ImageFilter -> C1.Win.C1Document.Export.ImageFilter
  C1.Win.FlexReport.RasterImageFilter -> C1.Win.C1Document.Export.RasterImageFilter
  C1.Win.FlexReport.JpegFilter -> C1.Win.C1Document.Export.JpegFilter
  C1.Win.FlexReport.PdfFilter -> C1.Win.C1Document.Export.PdfFilter
  ...and so on.
  Static properties on C1FlexReport returning static registered instances of supported export providers were moved to the ExportProvider class.
  (The reason for this change is the addition of the new C1PdfDocumentSource component which uses the same export filters as C1FlexReport.)

### Bug fixes

- When C1FlexReportDesigner called from design-time C1DataSource objects are invisible in designer. (TFS:147970)
- Description of some properties for MapField are not shown in C1FlexReportDesigner application. (TFS:191971)

### Improvements

- Added parameterized constructors for TextField class. (TFS:149234)
- Added properties:
  float TextFieldBase.TextAngle { get; set; }
  float Field.TextAngle { get; set; }
  Gets or sets the angle of text rotation within the field.
  double TextFieldBase.LineSpacing { get; set; }
  double Field.LineSpacing { get; set; }
  Gets or sets the line spacing between text lines in the field, in percent. The default is 100 which corresponds to normal line spacing.
  TextFitMode TextFieldBase.TextFitMode { get; set; }
  Gets or sets a value indicating how the text is fit into field's bounds.
- Behavior change: previously, if the type of a field could not be resolved while loading a report, an exception occurred. Now instead of the exception a text field is created, with the following text:
  Unknown field type [XXX]. This field type may not be supported in the current edition of FlexReport.

## C1.Win.FlexViewer

### Bug fixes

- Time value was not available for DateTime parameters in C1FlexViewer. (TFS:153471)
- COMException was thrown when a report is printed using a network printer. (TFS:150683)

### Improvements

- Supported text selection with touch.
- Added the WideLayout property specifying whether a multi-column layout is applied to wide reports by default.

## C1.Win.Map

### Initial release

- The WinForms map control, using the core FlexMap.

## C1.Win.TreeView

### Initial release

- WinForms TreeView control. (C1.Win.TreeView.4.dll)

# Release version 4.0.20161.150 - May-22-2016

## C1.C1Excel

### Bug fixes

- [the second case] when .xlsx file is read and saved just as it is, cell format (forecolor, backcolor and horizonntar arrangement, etc.) sometimes changes. (TFS:189899)

## C1.Win.C1Command

### Bug fixes

- C1DockingTab is not positioned correctly by operating for maximize/nomal of form (TFS:115006)
- Image in C1ContextMenu was not clearly visible. (TFS:147973)
- C1DockingTabPage gets shifted from its original location when 'MinimumSize' property of C1DockingTab is set to some value 'AutoHiding' property is set to true. (TFS:97769)

## C1.Win.C1FlexGrid

### Bug fixes

- In the mask cell, if it presses the Esc key in the edit cell when IME is On, IME editor is displayed. (TFS:99838)
- Text displayed in FilterPanel was not resize when cell contains multi line text. (TFS:150102)
- When there are no 'normal' columns, row highlight color did not render properly. (TFS:151669)
- GetValue method returned datamap value according to only first display column. (TFS:151962)
- Cell label was not display although hovering the cell after switching back to the application by using Alt+Tab shortcut. (TFS:152285)
- The grid failed to filter when the filter is created in XML format. (TFS:152478)
- The C1FlexGrid.Rows[index].Selected returned false when the row is selected and hidden. (TFS:152851)

### Improvements

- Added C1SuperErrorProvider property to show customizable error tips. (TFS:95475)

## C1.Win.C1Input

### Bug fixes

- Border of C1Label was not rendered properly when 'AutoSize' is set to True and text is changed. (TFS:144968)
- ValueChanged event fired when value of C1Label is not changed. (TFS:152614)

## C1.Win.C1InputPanel

### Bug fixes

- On selecting a value x in InputComboBox, dropdown focus is on the first value that starts with x rather than x. (TFS:153293)

## C1.Win.C1List

### Bug fixes

- [C1Combo] When font size is changed after adding items to C1Combo, items were not rendered properly. (TFS:150185)

## C1.Win.C1Ribbon

### Bug fixes

- Color of Ribbon title bar with Office2010 styles changed when HideTabHeaderRow is set to true. (TFS:152911)
- <br> tags in tooltips were not honored if they are not preceded with some text.

## C1.Win.C1Schedule

### Bug fixes

- Appointments are not refreshed correctly when ShowWorkTimeOnly is set to true. (TFS:152080).

## C1.Win.C1TrueDBGrid

### Bug fixes

- 'KeyNotFoundException is thrown when applying filter to hierarchical C1TrueDBGrid. (TFS:189902)
- While editing in Korean language, cell only shows last character. (TFS:150751)
- No text is shown in cell tip of c1TrueDBGrid on PictureHeader when FetchCellTips event is used and ToolTip is changed. (TFS:152912)
- Columns can't be unfrozen after datasource change. (TFS:139545)
- Cannot interpret token ":" at position 15" error is thrown when TimeSpan column is filtered using FilterDropDown. (TFS:144552)

### Improvements

- Added BorderColor property and BorderColorChanged event. (TFS:144011)

# Release version 4.0.20161.147 - May-05-2016

## C1.C1Word

### Bug fixes

- [WinForm] C1WordDocument is not shown in intellisense. (TFS:153062)
- "Your trial period has expired" and exception dialogbox is shown when add the C1WordDocument component onto the form. (TFS:153133)
- Hyperlink is not shown in C1WordDocument when save the document with Docx format. (TFS:152889)
- "CurrentAlignment" property of C1WordDocument is not effected in output docx and rtf file. (TFS:152949)

# Release version 4.0.20161.145 - Apr-25-2016

##
2016 v1.5 Release

## C1.C1Excel

### Bug fixes

- When a Excel file that has RTF texts including line break is loaded, the line break isn't processed correctly at the time of an RTF translation. (TFS:152067)
- When .xlsx file is read and saved just as it is, cell format (forecolor, backcolor and horizontal arrangement, etc.) sometimes changes. (TFS:149858)
- When reading .xlsx file, FitPageAcross property or FitPagesDown property of a sheet can sometimes be obtained incorrectly. (TFS:147203)

## C1.C1Pdf

### Bug fixes

- Reports with images exported to PDF/A-2B format failed to be compliant when verified with veraPDF or other PDF verification tools. (TFS:149065)
- Texts are garbled when PDF is made with JIS2004 environment (Windows 7/Server 2008 for example) and displayed in JIS90 environment (for example Windows XP). (TFS:151721)
- Using ImageQuality = ImageQualityEnum.Medium would erroneous PDF document. (TFS:150985)
- Text gets distorted when the report containing SuperLabel field with xml text is exported to PDF. (TFS:149239)
- EMF image content doesn't added properly in PDF document. (TFS:145595)

## C1.C1Report

### Bug fixes

- Text gets distorted when the report containing SuperLabel field with xml text is exported to PDF. (TFS:149239)
- WPF version/export to XPS: some reports produced invalid XPS (due to invalid element names). (TFS:143153)

## C1.C1Word

### Bug fixes

- [WinForm] C1WordDocument is not shown in intellisense. (TFS:153062)
- "Your trial period has expired" and exception dialogbox is shown when add the C1WordDocument component onto the form. (TFS:153133)
- Hyperlink is not shown in C1WordDocument when save the document with Docx format. (TFS:152889)
- "CurrentAlignment" property of C1WordDocument is not effected in output docx and rtf file. (TFS:152949)
- ArgumentOutOfRangeException is thrown when save the some specific Docx file. (TFS:152637)
- Toolbox icon of C1Word is missing in VS Toolbox. (TFS:152597)
- There is no footer visible in the Word document created using C1Word when it is saved in Docx format. (TFS:150574)
- ForeFilling color of table in the C1Word Document is not effective in output RTF and DOCX files. (TFS:144710)
- Line break key 'Ctrl+Enter' in the Text Field, RTF Field and Paragraph Field are not effected in
  Word export. (TFS:139058)
- "ArgumentNullException" is thrown when save the document contained icon file with Docx format. (TFS:150623)

### Improvements

- Add support of table cell pading for Open XML format (DOCX).
- Impoved support of Word/RTF borders (for all RtfBorderObject heirs). Added RtfDiagonalObject
  for all table objects (RtfTable, RtfRow and RtfCell).

## C1.Win.C1Command

### Bug fixes

- After changing the floating state of C1DockingTabPage, an exception of ObjectDisposedException occurred if the C1ComboBox's item on it is selected. (TFS:150228)
- C1TopicBar can't show image when use Theme. (TFS:150420)
- [C1ToolBar] C1ToolBar did not showed the "Customize ToolBar" dialog box. (TFS:150383)
- Docking cannot be done spread across the whole form. (TFS:139820)

### New features

- [C1DockingTab] Added new event AutoHidingChanging. This event fires when the AutoHiding property is about to change. Allows to cancel the change. (TFS:20792)
- [C1CommandLink] Added methods OpenSubmenu() and CloseSubmenu(). These methods open or close a submenu for linked C1CommandMenu. (TFS:141818)
- [C1DockingTab] Added TabClick event in C1DockingTab and DockingTabPage. (TFS:142313)
- [C1CommandDock] Added DockingStyle like in VS2012.

## C1.Win.C1Document

### Bug fixes

- Page orientation specified in C1FlexReport.Layout.Orientation is ignored when report printed via C1FlexReport.Print() method. (TFS:150926)

### Other changes

- New component (BETA): C1PdfDocumentSource, allows to open a PDF document.

## C1.Win.C1FlexGrid

### Bug fixes

- When the check of "indicates the whole" of column style is set to ON or WordWrap property is set to True and if the UseCompatibleTextRendering property is set to True some part of the cell label's text wasn't displayed. (TFS:149909)
- ValidateEditEventArgs.Cancel property of ValidateEdit event was not working when text is pasted from Clipboard into a Cell. (TFS:149127)
- Sort icon was disappeared by using 'Transpose' method to change orientation. (TFS:146505)
- [Query]Filtered data were not properly shown in filter drop down list by using 'Transpose' method. (TFS:146457)
- Height of CellLabel was not fit height of cell if height of text in CellLabel is less than height of cell. (TFS:148800)
- Custom Editor is removed when assigned at design time and application is closed and opened again. (TFS:119958)
- Font of C1FlexGrid of non-default style was not resized when ResizeFonts property of C1SizerLight is set to true. (TFS:129809)
- ForeColor was changed when an ownerdrawn grid is saved via SaveExcel method. (TFS:147421)
- Shift key was not released if right shift key and tab key are pressed in edit mode and released after it. (TFS:147952)

## C1.Win.C1GanttView

### Bug fixes

- The Percentage Complete bar line in GanttView Chart behaved improperly when Duration Unit is set to Week or Month for a task. (TFS:148095)

### Improvements

- Added Layout dialog and new properties ShowLinks, BarHeight, AdaptiveBarHeight, etc. (TFS:141271)

## C1.Win.C1Input

### Breaking changes

- [JPN] C1TextBox - change in Japanese era symbolic display format. (TFS:151937)
  "g.yy/MM/dd" -> "H28/04/20"
  "g..yy/MM/dd" -> "H.28/04/20"
  Previously it was "g.yy/MM/dd" -> "H.28/04/20"

### Bug fixes

- [C1ComboBox] improved C1ComboBox performance when 4000+ items are added to its drop down. (TFS:150907)
- [C1DateEdit] RemoveAnnuallyBoldedDate method doesn't work properly. (TFS:61691)
- When set theme to C1Input control by C1ThemeController, the state of setting of BorderColor was different between design time and run time. (TFS:109131)
- [C1ComboBox] reduced initialization time. (TFS:150414)
- [C1DateEdit] reduced initialization time. (TFS:143815)
- [C1TextBox] method SetCutureInfo marked as obsolete, use SetCultureInfo method instead. (TFS:109922)
- [C1TextBox] Color of C1TextBox/C1Combobox was not correct. (TFS:147192)
- Added Padding property to C1RangeSlider.Styles.ThumbStyle. This property is used for setup padding of thumbs.
- Arrow down image of C1ComboBox was shown with long shadow when setting Officexxx VisualStyle and AutoSize=False. (TFS:150796)
- Custom 'C1DateEdit' did not accept inputs '00', '01' and '02' in Hour and Minutes values
  of hh/mm Format when call ParseContent from OnValueChanged override. (TFS:125838)
- If setting CalendarType of C1DateEdit to "JapaneseCalendar", an exception occurs when inputting a date before first day of first era（1868/9/8" (TFS:135323)
- Arrow down image on C1NumericEdit remained small when the DPI of the screen is changed
  to 200. (TFS:142206)
- DropDown arrow of c1SplitButton disappeared when large screen DPI was used.(TFS:140700)
- Item in the drop down list was not rendered properly when the drop down list is opened
  using 'Alt+Down' and mouse cursor is placed below the C1ComboBox. (TFS:142366)
- Highlighted item was being changed according to the mouse cursor when the items in the drop
  down list of C1ComboBox are scrolled using up down arrow keys. (TFS:142365)

### New features

- [C1ComboBox] new property UseItemsBindingSource. Keeps SelectionIndex property synchronized with BindingSource.Position. (TFS:148453)
- [C1ComboBox] HtmlPattern mode now supports multiple field names in the pattern like this: {FieldName}. This allows to make multi column combo boxes.
  See example in updated ComboBoxItemModes sample. (TFS:79421)
- Added SmallChange property to C1RangeSlider. This property is used for define small distance which thumb is moved to when arrow keyboard key is pressed.
- Added LargeChange property to C1RangeSlider. This property is used for define large distance which thumb is moved to when mouse click is performed outside of selected area.
- Added ScrollBehavior property to C1RangeSlider. This property describes how thumbs will be moved when SmallChange or LastChange action will be performed.
- Added SelectedAreaColor property to C1RangeSlider.Styles.BarStyle. This property is used for filling area between thumbs with selected color.

## C1.Win.C1InputPanel

### Bug fixes

- Right and Center Text alignment were mixed up in InputDatePicker and InputComboBox. (TFS:150634)

## C1.Win.C1Ribbon

### Bug fixes

- Images with low resolution (less than 96 DPI) displayed incorrectly on C1Ribbon. (TFS:151573)
- NullReferenceException was thrown when setting SelectedIndex of a RibbonComboBox from the Form.InitializeComponent() method. (TFS:149218)
- Large image from the application menu button was shown distorted at the top of the application menu drop-down. (TFS:149602)
- Large images (more than 32x32) on RibbonButtons in RibbonApplicationMenu were not sized correctly. (TFS:147530)

### Improvements

- Added ThemeImages.LoadCustomImages() method for loading the custom theme bitmaps for the Office2007 visual styles.
- Added new style settings available in C1ThemeDesigner (Content\Default\Background, Form\Qat\Default\Background, Groups\GroupPopup). (TFS:148467)
- Added the AllowImageScaling property to RibbonItem to prevent image scaling issues in high-resolution applications. (TFS:144807)

## C1.Win.C1Schedule

### Bug fixes

- Adjusted behavior of the C1Calendar CurrentMonthDisplayOffset property.
  It is only applied to initial position of the current month at control creation.
  This property is not used when end-user changes selection or navigates calendar at run time. (TFS:149237)

### Improvements

- Also fire C1Schedule.SelectedIntervalChanged when the same time interval is selected in other visible group. (TFS:151001)

## C1.Win.C1SpellChecker

### Bug fixes

- Wiggle line parts remained on the top border of the textBoxBase control after scrolling. (TFS:10674)
- Memory leak in C1SpellChecker. (TFS:148109)

## C1.Win.C1SuperTooltip

### Bug fixes

- System.Exception was thrown in C1SuperToolTip when it is used in a multithreaded application. (TFS:141069)
- Text in C1SuperLabel was not shown with RightToLeft layout. (TFS:140222)

## C1.Win.C1TouchToolKit

### Bug fixes

- Removed ZoomFont overrides from the C1FlexGridZoomPolicy policy. This functionality is implemented in the C1FlexGrid control.
- C1Ribbon and C1StatusBar are excluded from zooming and not affected by C1Zoom. (TFS:36242,36947,37086,40821,41716)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Application Loses Focus when first CellTip is displayed. (TFS:150328)
- Cell Tips are cropped and not fully displayed when mouse is hovered over the cell. (TFS:150358)
- When DirectionAfterEnter = MoveRight, cell does not move even by pressing the [ENTER] key in ComboBox type's cell. (TFS:148821)
- When setting MarqueeStyle to FloatingEditor, Enter key doesn't work after cell moving with a Tab key or Shift+Tab key. (TFS:150327)
- Even if the cell value is changed and an Enter key is pressed after focus has moved to C1TrueDBGrid from other windows, the focus doesn't move to the right cell. (TFS:137409)
- If specific column's NumberFormat property is set to "FormatText Event", and the column's value filter is applied after the other column's filter applying, the columns having the converted text within FormatText event also become hidden. (TFS:139654)
- Different BorderStyle was displayed for buttons with Aero theme in C1TrueDbGrid. (TFS:75692)

## C1.Win.FlexChart

### Bug fixes

- Fixed TFS issues: 145668, 145799.
- Enumerable DataSources now correctly display when initial values are null.

### Improvements

- Adjustments to persistence. DataSource is persisted but default design data is not.
- Default data at design time is provided to allow Series styling the default data is not persisted.
- Added Series.SymbolRendering/Rendered event.
- Added some xml documentation.

## C1.Win.FlexReport

### Bug fixes

- If C1FlexReport.Layout.CustomWidth, CustomHeight is zero then C1FlexReport.Layout.Orientation == Landscape will be ignored and rendered pages will have portrait orientation. (TFS:152335)
- C1FlexReport.PageSettings property works incorrectly in certain scenario, it returns value different from value that was assigned before. (TFS:151469)
- [Localization]Description of "UnboundSeriesList" property of ChartField is not localized in Japanese. (TFS:149159)
- [JPN] Context menu of Error Window List are not localized in Japanese. (TFS:147837)
- Barcode is distorted when change the BarcodeDirection of Barcode Field in FlexReport Designer. (TFS: 134062)
- Description of properties are not shown in collection editors of "Chart" field. (TFS:149384)
- Size of the exported pdf document is larger than the size of the A4 sheet when PaperSize is set to A4. (TFS:150576)

### Improvements

- Support unbound ChartField.

## C1.Win.FlexReport Designer App

### Improvements

- When dropping a parameter from the data tree on the report, the new report field's expression is set to "=<parameter-name>.DisplayText" (previously it was set to "=<parameter-name>" which could lead to unexpected results for multi-value parameters).

## C1.Win.FlexViewer

### Breaking changes

- C1FlexViewer and other related classes and enumerations moved from C1.Win.FlexReport to C1.Win.FlexViewer namespace.

### Bug fixes

- It was impossible to localize C1FlexViewer via the Localize window at design time. (TFS:151583)

### Improvements

- Updated default images on C1FlexViewer toolbars.

# Release version 4.0.20161.139 - Feb-28-2016

##
2016 v1 Release

## C1.C1Excel

### Bug fixes

- "Invalid Excel OpenXml file (*.xlsx)" exception is thrown while Importing an Excel(.xlsx) file generated using Altova Mapforce or Telerik SpreadSheetProcessing for Wpf with C1Excel. (TFS:142312)

## C1.C1Pdf

### Bug fixes

- Line alignment is changed when FontType is set to Standard. (TFS:145072)

## C1.C1Report

### Bug fixes

- Superlabel custom field rendered incorrectly when CanGrow or CanShrink is true and screen dpi not 96. (TFS:130016)
- In rare cases RTF text is not split between pages even if KeepTogether is false. (TFS:143697)

## C1.C1Word

### Bug fixes

- Checkbox icon is not shown in word export. (TFS:140679)
- Unhandled exception is thrown when load the RTF/Docx document file. (TFS:144874)
- Stop Working box is shown when load/save the Word Document to C1Word. (TFS:144917)
- Backfilling color of table in the C1Word Document is not effective in output
  RTF file. (TFS:144707)

## C1.Win.C1Chart

### Bug fixes

- Added description for the AxisScroll event. (TFS:138783)
- Excluded data series are now not included in the axis limit calculation. The differences in behavior are noticeable when the chart must assume axis limit values when valid data is not provided for all data series. (TFS:141712)

## C1.Win.C1Command

### Bug fixes

- [C1DockingTab] Memory is not released when the form containing C1DockingTab and C1DockingTabPage is closed. (TFS:142837)
- [C1DockingTab] DockingTab Page is not appear when hovering over the tab page header when two tab pages are place side by side in different C1CommandDock. (TFS:17512)
- [C1DockingTab] Memory leakage problem with C1DockingTab. (TFS:81508)
- [C1DockingTab] Memory Leak Issue is observed when clicking tab to show the docking Tab when it is in AutoHiding state. (TFS:19468)

### Improvements

- Improved support for WindowsFormsHost (TFS:142821)

## C1.Win.C1FlexGrid

### Bug fixes

- Exported freeze columns count was incorrect if there is hidden fixed column and SaveExcel() method is used with IncludeFixedCells and VisibleOnly FileFlags options. (TFS:136236)
- GroupOn and TotalOn result of Subtotal() method was wrong when first column has different data for each row. (TFS:95068)
- ScrollBars' focus was lost when a new row is added. (TFS:143020)
- C1FlexGrid was scrolled to left when SelectionMode is ListBox and the rows are selected using Ctrl+click on row header. (TFS:143166)
- DropDown did not open by pressing 'F2' key when ComboBox is used as editor of C1FlexGrid's cell. (TFS:144193)
- Caret was not moved to position before thousand separator by pressing backspace key. (TFS:139548)
- First or last cell of new empty row was not selected by pressing Home or End key when editing cell. (TFS:143388)
- Caret was moved right when deleting character from string with thousand separator. (TFS:143530)
- If C1FlexGrid's column has the numeric datatype, changing one digit to other was not correct. (TFS:143669)
- New data was placed at the new add row bar in unbound mode. (TFS:42491)
- ValidateEdit event was not fired when data was pasted from Clipboard. (TFS:107100)
- DataMapped dropdown list didn't show picklist until hit F2. (TFS:143586)
- Duplicate shortcut keys were in Italian/Danish/Norwegin/Greek/Finnish localized C1FlexGrid filter. (TFS:90681)
- C1FlexGrid grouped rows with specific umlauts in the wrong way. (TFS:129720)
- Value of C1FlexGrid's cell could not be changed when Multiline property of cell's texbox editor is false. (TFS:141342)
- 'ArgumentOutOfRangeException' was thrown when try to get value of SortColumn when no column is sorted. (TFS:141407)
- New row of bounded C1FlexGrid was not created if value is added to grid in first time. (TFS:142092)

### Improvements

- Added KeepMergedRangePosition option to ScrollFlags enumeration. This option used for specifing scrolling the grid to the first cell of merged range when selecting it. (TFS:140245)
- Added Never and Inherit options for ShowButtons enumeration. Never used for not showing buttons anyway and Inherit used for showing buttons as it is discribed by ShowButtons property of grid.
- Added PreserveEditMode property. This property used for entering edit mode of cell after exiting from previous cell with arrow keys or tab key. (LeySer request)
- Added Transpose method. This method used for reflecting grid over its main diagonal. (LeySer request)
- Added ShowButtons property to Column class.

## C1.Win.C1GanttView

### Breaking changes

- Property ZoomFactor is renamed to ChartViewZoomFactor. This fixes the bug: C1GanttView was not zoomed properly with C1Zoom. (TFS:36652)

### Bug fixes

- Data in custom column were not retained when loading xml file in design time. (TFS:140961)

### Improvements

- Implemented C1GanttView and C1Schedule common data source demo. (TFS:60905)
- Added Link Information dialog. (TFS:129954)
- Added new Task property ReflectOnSummary that allow to show outline task on it's summary bar. (TFS:139875)

## C1.Win.C1Input

### Bug fixes

- [C1TextBox] OverflowException was thrown when a value greater than '1E+28' is entered in the C1TextBox and DataType is set to double, int or float. (TFS:142706)
- [C1TextBox] The controls based of C1TextBox painted text content incorrectly when set DisabledForeColor and RTL='Yes'. (TFS:142884)
- Font of C1ComboBox's DropDownForm is not getting changed in code. (TFS:140098)
- In the dropdown calendar of C1DateEdit, the drop-down menu of selecting month isn't sometimes displayed even if the month numerical value of the upper part is clicked. (TFS:144794)

## C1.Win.C1InputPanel

### Bug fixes

- NullReferenceException was thrown when C1InputPanel is used in a UserControl and InputMenu is clicked multiple times and spacebar key is pressed. (TFS:146201)
- InputControlHost was not displayed on the C1InputPanel when added at design time. (TFS:144104)
- Font property of C1InputPanel components could not be changed since build 110. (TFS:142511)

## C1.Win.C1List

### Bug fixes

- [C1Combo] C1Combo throws an exception for Japanese, Korean and Chinese localization.

## C1.Win.C1Report

### Bug fixes

- Fixed a few small issues in high DPI mode.

## C1.Win.C1Ribbon

### Bug fixes

- Fixed an issue with scaling the Width and Height properties of RibbonControlHost for high DPI mode.
- Images of RibbonButton became dizzy when the DPI of the screen is increased. (TFS:144807)
- When the Ribbon layout is saved to XML using Save method of C1Ribbon, the value of ShortcutKey property of RibbonButton stored in localized form and can not be loaded later for a different culture. (TFS:141532)

## C1.Win.C1RibbonPreview

### Bug fixes

- Page thumbnails were not scaled for high DPI.

## C1.Win.C1Schedule

### Bug fixes

- Alignment property of the Title text is not working properly in C1Schedule. (TFS:147031)

## C1.Win.C1SuperTooltip

### Bug fixes

- Hyperlink is not rendered at proper location when the padding property of C1SuperLabel is set. (TFS:143331)

### Improvements

- Honor HTML table header cells. (TFS:140217)

## C1.Win.C1Themes

### Improvements

- Themes updated: LinkLabel colors fixed, added ImageRecolor in dark themes to better handle typical icons. (TFS:144749)

## C1.Win.C1TileControl

### Bug fixes

- C1TileControl layout changes on loading saved XML when custom DPI is set. (TFS:146216)
- Tiles rendered slowly when the very long text is assigned to the Text property of a Tile. (TFS:143703)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Carriage Returns and Line Feeds characters are not displayed correctly in the C1TrueDBGrid. (TFS:140728)
- Characters in the FilterBar are not getting retained when grid is split in two parts and a row among the last few rows are selected. (TFS:140808)
- Splits become unsynchronized when grid is scrolled and a split is created. (TFS:144334)
- A runtime exception of type 'System.ArgumentException' is thrown when the grid is bound at design time to a BindingSource object. (TFS:144993)
- PrinterSettings are ignored when the settings are retrieved from the PrintDialog and used at the time of printing. (TFS:141947)
- Filter dropdown is not shown under the filter bar when data is viewed using 'Hierarchical' display. (TFS:144879)
- It takes a long time to show filter dropdown when grid with many rows is viewed with 'Hierarchical' display. (TFS:144883)
- Translated column looses centering when RTL. (TFS:135983)
- RTL Grouped Column with ExtendRightColumn = True has wrong size. (TFS:144653)
- Grid renders slow while loading and scrolling when the 'ExtendRightColumn' property is set to true (TFS:142650, 141871)
- FetchRowStyle event fires multiple times for a single row. (TFS:141159)
- “IndexOutOfRangeException” is thrown when there is a standalone parent row in the grid and the filter drop down is opened. (TFS:136971)

## C1.Win.FlexChart

### Bug fixes

- Databound X values of type string are now used to create X axis labels for IListSources
- DataBound series with BindingX set to a string column now plots correctly. (TFS:144393)
- DataBound columns no longer throw an InvalidCastException when values contain DBNull. (Tfs:142859)
- Fixed various TFS issues: 141267, 141307, 141436, 141776, 141934, 141939, 141892, 143027, 143029, 143103, 143505, 144285, 144782, 144786, 144829, 144938.
- Fixed various TFS issues: 141766, 141775, 142537, 143328.
- Fixed various TFS issues: 141127, 141133, 141134, 141156, 141345, 141445, 141530, 141742, 141770, 141873, 141921, 141120, 141266, 141272, 141431, 141434, 141156.

### Improvements

- Added new property FlexChart.SmoothingMode.
- Added new ChartStyle properties StrokeColor and FillColor.
- Added Beta licensing.
- Added FlexPie SelectedItemOffset/Position properties.
- Added Axis.OverlappingLabels property.
- Added axis minor tick marks and grid lines.
- Added support of INotifyCollectionChanged for FlexChart/FlexPie DataSource.
- Added FlexPie demos in FlexChartExplorer sample.

## C1.Win.FlexPivot

### Improvements

- Final release. FlexPivot is no longer in Beta.
- DataEngine is now in a separate dll, C1.DataEngine.dll.
- Major addition: Queries. DataEngine can now be used on its own, separate from FlexPivot,
  to integrate (blend, join), transform, and aggregate (analyze) data. This is done by
  executing DataEngine queries. A query takes data from base tables or from other queries,
  performs operations on that data that can include jolining multiple tables, filtering,
  calculations, grouping, aggregation, and saves results as a new table in the DataEngine.
  For various query examples, see a new sample DataEngineQueries.
  See also another new sample, DataJoin that shows a more advance use of join functionality,
  where the user can select an arbitrary set of fields from any table, and the code in the
  sample builds a dynamic query and executes it to get the joined table that is fed to
  FlexPivot for analysis.
- Added Excel add-in for integration with Power Query. It is now possible to use multiple
  data connectors and data integration functionality of Power Query to import data to
  Data Engine from various data sources.
- Added a new sample PowerQueryConnection showing how to use the Power Query to import data
  to DataEngine in application code transparently for the user without opening Excel.
- Null values are now supported.
- All formats specified on the Format tab in Field settings are now supported.
- All data types are now supported (Beta version did not support unsigned data types and sbyte).
- Multiple value fields are now allowed by default.
- Increased limit on column size for Filter tab to one billion.
- Improved diagnostic messages on Filter tab for the cases where there are too many
  unique values or data size is too large.
- Added Connector.GetData method overload using IDataReader.
- Improved result grid performance on large (several thousands or more) resultsets.

## C1.Win.FlexReport

### Bug fixes

- TextField.Text property can not be assigned from script. (TFS:145984)
- Wrong image used for indeterminate state of checkbox fields. (TFS:145329)
- FlexReport Asc() script function expected a number instead of a string. (TFS:144354)
- Update C1FlexReport ja, zh and ko resource files.
- All built-in Date/Time formats supported by CR is not applied when import to the C1FlexReport Designer.(TFS:143434)
- CheckBox CheckMark font use CheckBoxField font instead of its own font, fixed.
- Update C1FlexReportDesigner app ja, zh and ko resource file.

### Improvements

- Added Field.SubreportHasData, SubreportField.SubreportHasData properties.
- Added direct support of SQLite data provider, now SQLite connection can be specified in the FlexReportDesigner. SQLite ADO.NET provider should be installed on the system, see https://system.data.sqlite.org for more details.

## C1.Win.FlexReport Designer App

### Breaking changes

- Designer window layouts saved in previous versions are ignored. This is to ensure that the error list gets shown if needed.
- Update localization resources for ShowErrorList rbtn.
- In previous builds, the C1FlexReportDesigner.4.exe was built for x86 as the target so it always ran in 32 bit mode. Starting with build 131, C1FlexReportDesigner.4.exe targets 'Any CPU' so on 64 bit systems it will run in 64 bit mode. To allow using 32 bit only data providers (such as Microsoft.Jet.OLEDB.4.0), a 32 bit executable C1FlexReportDesigner32.4.exe is now included in the build.

### Bug fixes

- Chart axis lables are overlapped when import the Crystal chart to C1FlexReport designer application. (TFS:143647)
- Exception occurred when creating a new report conntected to an XML database. (TFS:143316)
- When connecting to an external assembly data provider, failed to load the assembly. (TFS:143329)
- If the .flxr file loaded into the designer was deleted by another application, the designer could crash.
- Changing data provider in the create report wizard crashed the designer app. (TFS:142958)

### Improvements

- Error list window added, shows any errors and/or warnings that occurred during last report generation. 'Error List' button (shows the error list if it was hidden) added to the Home tab's View group.
- If an undo or redo reverts to a state in which the report was in an unchanged state, that state is now restored too.

## C1.Win.FlexViewer

### Improvements

- Supported panning with the middle mouse button.
- C1FlexViewerPane don't use embedded ScrollBar controls anymore.

## C1ReportDesigner App

### Bug fixes

- When a drop down of "BarCode" property of barcode field is expanded, an exception occurs. (TFS:144998)

# Release version 4.0.20153.112 - Jan-16-2016

##
2015 v3.5 HotFix

## C1.Win.C1Command

### Bug fixes

- C1NavBarPanel does not get selected at Design time when clicked on its corresponding C1NavBarButton. (TFS:141262)
- C1CommandHolder does not update statuses of C1Commands in multithreaded application. (TFS:120263)
- [C1DockingTab] "ArgumentException" is thrown after Drag outer c1DockingTab to inner c1DockingTab When c1DockingTab is nested. (TFS:33760)
- [C1CommandDock] Localization Descriptions for some property of C1CommandDock is not localized for Korea text. (TFS:141085)
- [C1TopicBar] 'LinkStyle' is only applied to C1TopicLink when visual style is set to C1TopicBar as 'Window XP' and 'Custom'. (TFS:116816)
- [C1DockingTab] Tab Pages are not removed when C1DockingTab is in unpinned state. (TFS:23108)
- [C1DockingTab] C1DockingTabPage disappear when resizing another tab page to cover over this tab page. (TFS:141088)
- [C1DockingTab] When moved the right DockingTab to the left control between two DockingTabs disappeared. (TFS:27910)
- [C1DockingTab] When press AltGr + 2 in a textbox on C1TabPage using a Norwegian keyboard, focus is switches to another TabPage instead of "@" is display. (TFS:33504)

### Other changes

- Changed method RemoveAt of PagedControlsCollectionBase class to virtual. (TFS:23108)

## C1.Win.C1Document

### Bug fixes

- Update ja, ko and zh resources to translated strings.

## C1.Win.C1Input

### Bug fixes

- [C1ComboBox] C1ComboBox flickers once by opening dropdown when setting RightToLeft property to 'Yes'. (TFS:61332)
- [C1DropDownControl] Dropdown button isn't shown as clicked button when opening the dropdown using Alt+Up/Down arrow keys. (TFS:63033)
- [C1ComboBox] Selected item and index is changed when using Alt+Up/Down to close the dropdown. (TFS:60882)
- [C1DropDownControl] Dropdown of ComboBox/DropdownControl/DateEdit/NumericEdit can not perform toggle action with F4 key. (TFS:88279)
- [C1ComboBox] C1ComboBox cannot search items when DropDownStyle is DropDownList. (TFS:73648)
- [C1SplitButton] C1SplitButton does not close the dropdown list when pressing of Alt+Down key. (TFS:88517)

## C1.Win.C1InputPanel

### Bug fixes

- Overflow Exception was thrown after entering 1e+60 value in InputNumericBox and clicking the increment button. (TFS:141171)

## C1.Win.C1List

### Breaking Change

- [C1List] SelChange event is replaced by two events: SelectionChanging and SelectionChanged. It is possible to cancel selection change in the SelectionChanging event. (TFS:139377)

## C1.Win.C1Ribbon

### Bug fixes

- RibbonItem deleted at runtime when the item is added to QAT and then user makes the Undo action. (TFS:141090)
- ArgumentOutOfRangeException was thrown when an item is removed from the QAT under certain circumstances. (TFS:141277)
- RibbonTabs and RibbonGroups did not switch to Disabled appearance when C1Ribbon.Enabled property is set to False.
- It was impossible to resize popup menus and galleries with the stylus.
- Disabled command buttons might appear pressed if their Enabled property changed between MouseDown and MouseUp events.
- ArgumentOutOfRangeException was thrown when the RibbonTab containing a RibbonControlHost with Transparent background becomes not selected. (TFS:141416)

### Improvements

- Honor html table header cells (<th> tag) in tooltips.
- Added the ImageRecolor setting to C1Ribbon theme. If not empty, this color will replace non-transparent and non-white colors in ribbon images.

## C1.Win.C1TileControl

### Improvements

- Added the TileMoved event to C1TileControl. It occurs when some tile is moved. (TFS:121591)

## C1.Win.C1TrueDBGrid

### Bug fixes

- BeforeColUpdate and AfterColUpdate events are fired even if there are no changes made in the cell. (TFS:140433)

## C1.Win.FlexReport

### Bug fixes

- Exception occurs when export C1FlexReport to BMP or GIF formats if ExportFilter.UseZipForMultipleFiles is true. (TFS:141264)
- Update localization resources. (TFS:141039, 138888)
- Update C1FlexReportDesigner app ko resource file.

# Release version 4.0.20153.110 - Dec-30-2015

##
2015 v3.5 Release

## C1.Win.C1Chart3D

### Bug fixes

- Corrected issue where Chart2D throws an exception when stacking values and there are
  no values at the point to stack. (TFS:134744)

## C1.Win.C1Command

### Bug fixes

- [Forum] Application crashes on resizing the form when the last TabPage of C1DockingTab is selected (TFS:84269)

## C1.Win.C1FlexGrid

### Bug fixes

- Custom glyph bitmaps were disposed on FlexGrid dispose call.

## C1.Win.C1InputPanel

### Bug fixes

- The Validating event is now fired for InputNumericBox when the entered value exceeds the Maximum value. (TFS:140514)

## C1.Win.C1Report

### Improvements

- Now options dialog is displayed for PDF exporter of C1SSRSDocumentSource, so is it possible to define addtitional PDF options which were added for SSRS PDF export.

## C1.Win.C1SpellChecker

### Bug fixes

- Application hangs when the application(.exe) is executed in Release mode and email id is typed into WebBrowser with spell checking enabled. (TFS:139665)

## C1.Win.FlexReport

### Bug fixes

- Error occurs during rendering if expression of CalculatedField uses aggregate functions.(TFS:140921)

## C1.Win.FlexViewer

### Improvements

- Added the collapsing/expanding buttons to the outline panel.

# Release version 4.0.20153.109 - Dec-21-2015

##
2015 v3 HotFix

## C1.C1Excel

### Bug fixes

- At times, position of a string is changed to BottomAligned in the output. (TFS:139667)
- [Only WinForms] Style's ForeColor is not set correctly if setting ForeColor before setting Font to style. (TFS:137374)
- [Partly fixed] Image and CheckBox is not retained when the Excel file containing check box and image is saved. (TFS:136880)

### Improvements

- Added new C1XLBook.ListSeparator property for using in methods C1XLBook.Load (for .cvs files), XLSheet.LoadCsv and XLSheet.SaveCsv.

## C1.C1Pdf

### Bug fixes

- [Case 2] Extra 􀀃 character is added when user copy/paste text from exported pdf file to notepad. (TFS:137824)
- Color for pie chart is not exported correctly to pdf file. (TFS:137852)
- Extra 􀀃 character is added when user copy/paste text from exported pdf file to notepad. (TFS:137824)
- Round Bracket from wmf file is replaced by 􀀌 when copy/paste from exported pdf file. (TFS:137844)

## C1.C1Report

### Bug fixes

- Added descriptions to C1MultiDocument and C1PrintDocument public events. (TFS:29001)

### Improvements

- Added support for PDF/A (level 2B) compatible export to PDF (option in PDF export form, new FileFormatEnum member FileFormatEnum.PDFA).
- Update PDF/A (level 2B) compatible localization resources.
- Added support of RightToLeft to text objects of C1PrintDocument and C1Report.
- C1PrintDocument:
  Added ambient Style property bool Style.RightToLeft { get; set; }, default value is false.
- C1Report, added properties:
  bool? Field.RightToLeft { get; set; }, default value is null, in this case C1Report.RightToLeft is used.
  bool? C1Report.RightToLeft { get; set; } specifies default RTL value for the report, default value is null, in this case static C1Report.DefaultRightToLeft property is used.
  static bool C1Report.DefaultRightToLeft { get; set; } specifies default value of RightToLeft property.

## C1.Win.C1Command

### Bug fixes

- [C1ToolBar] Text of C1Command overlaps the image when RightToLeft property of C1Toolbar is set to True. (TFS:138918)
- [C1ToolBar] ToolBar incorrectly draws wrapped CommandLinks when property RightToLeft of C1CommandDock is set to 'Yes'. (TFS:130605)
- [C1DockingTab] C1DockingTab does not scale child controls correctly. (TFS:72674)
- [C1NavBar] OptionMenu of C1NavBar incorrectly works in a multithreaded mode. (TFS:49566)
- [C1TopicBar] TopicLink's of C1TopicBar sticks out of a topic page. (TFS:136821)
- [C1TopicBar] Links goes out of the page boundary when there are fifteen or more links present in a single page of C1TopicBar (TFS:136822)
- [C1DockingTab] DockingTabPage cannot be resized when 'AutoHide' is enabled and page is resized to the smallest width. (TFS:45589)

### Improvements

- [C1ToolBar] Until this build 'More..' button was not visible if AutoSize was False. Now it will be visible if the all buttons can not fit in the toolbar's size and Dock is not None. (TFS:48900)

### New features

- [C1DockingTab] Added keyboard support to rename tab by pressing F2 key on selected tab. (TFS:40326)

## C1.Win.C1Document

### Bug fixes

- [JPN]Incorrect "Tolerance decting text bounds (points)" is shown in the 'Save as XLS' dialog box. (TFS:139614)
- SSRS reports with cascading parameters processed incorrectly in some rare cases. (TFS:129873)
- C1SSRSDocumentSource can not render SSRS report if it contains internal report parameter. (TFS:137773)
- Invalid barcode data is displayed on exporting barcodes with direction TopToBottom/BottomtToTop in Pdf format. (TFS:137025)

## C1.Win.C1Editor

### Bug fixes

- Font of the text cannot be changed back to previous font when a new font is assigned (TFS:137300)
- C1Editor's ContextMenuScrip's SourceControl is null. (TFS:134925)

## C1.Win.C1FlexGrid

### Bug fixes

- Chinese texts for clear and cancel buttons were the same in filter editor form. (TFS:139558)
- ValidateEdit event did not fire when EditMask and ComboList properties of C1FlexGrid are set. (TFS:137848)
- Microsoft Visual Studio stopped working when setting AllowMerging property of C1FlexGrid to Spill at design time. (TFS:138368)
- Selection of cells was discarded on editing if the selection is started from any cell after the first cell in the merged cell range. (TFS:49176)
- Text was moved automatically when alignment of cells with newline text is set to center and some cells with trailing space are shown. (TFS:121365)

### Improvements

- Added showing of sort icon in each sorted column accordingly to the sort order when sorting MultiColumn. (TFS:24485)

### Other changes

- Added FrozenAlternate cell style. This style used to render cells that are frozen (editable and selectable, but not scrollable) in even-numbered rows.
- Added ValuesLimit property to ValueFilter class. If ValueFilter has more than ValuesLimit values than only ConditionalFilter will be shown.

## C1.Win.C1GanttView

### Bug fixes

- Child tasks became inactive when selecting all child tasks of SummaryTask and clicking outdent toolbar button. (TFS:140286)
- The first row could not be moved down when clicking Move Down from toolbar. (TFS:139729)
- All columns were deleted when open the project created with old build. (TFS:137691)
- Row heights were not uniformed. (TFS:138407)
- Decreased the number of GDI-objects in process of print preview. (TFS:130028)
- Groups and summaries was not being sorted properly in grouping mode. (TFS:106095)

### Improvements

- Added date tooltip to timeline.
- Added possibility to make task inactive. (TFS:130006)

## C1.Win.C1Gauge

### Bug fixes

- When some control is arranged on C1Gauge, a PointerDragMove event doesn't fire any more. (TFS:137712)

## C1.Win.C1Input

### Bug fixes

- [C1DropDownControl] While opening dropdown of some input controls, pressing Windows key or Ctrl + Esc doesn't navigate to Start Menu. (TFS:89051)
- [C1ColorPicker][C1FontPicker][C1DateEdit] Item was not selected correctly by typing while opening dropdown when setting AutoOpen to 'true'. (TFS:121181)
- [C1ComboBox] Application is not responding on pressing of "Window + D" while opening of ComboBox dropdown. (TFS:88148)
- [C1CheckBox] System.ArgumentException is thrown when C1CheckBox uses theme. (TFS:134493)
- [C1RangeSlider] Both thumbs were moved to left when clicking bar between thumbs while left thumb position is far from left. (TFS:119049)
- [C1DateEdit] Even if a pop-up menu of selecting month in C1DateEdit is displayed, and garbage collection is put into effect by closing the form, the garbage collection isn't freed any more (TFS:139851).
- [C1TextBox] Even if the AutoSize of C1TextBox is set to True, C1TextBox height is changed according to changing size of C1Sizer. (TFS:135631)
- [C1TextBox] C1Textbox height increases incorrectly when used in combination with C1SizerLight. (TFS:129208)
- [C1TextBox] The height of the C1TextBox not changed after size of font changed. (TFS:135619)
- [C1TextBox] C1TextBox incorrectly shows password Text when VisualStyle set to other than 'System' and C1TextBox is disabled. (TFS:97637)
- [C1CheckBox] Database is not updated when the C1CheckBox is checked. (TFS:55739)
- [C1SplitButton] 'Object reference not set to an instance of an object' error message is shown when cancel the addition of C1SplitButton on the form. (TFS:40746)
- When to set AutoCompleteMode and AutoCompleteSource property of C1ComboBox in designer, AutoComplete is not applied. (TFS:120688)
- If setting CalendarType of C1DateEdit to "JapaneseCalendar" and setting MinDate of Calendar, an exception occurs when setting the calendar's year part to edit state and its focus is removed. (TFS:135251)
- When set to JapaneseCalendar and CurrentMonthDisplayOffset is set and click clear button in calendar, exception occurs. (TFS:117786)
- 'WeekDay' names not localized on changing the 'Culture' of C1DateEdit. (TFS:131842)

### New features

- [C1CheckBox] New event ValueChanged occurs when the Value property has changed. (TFS:55739)

## C1.Win.C1InputPanel

### Bug fixes

- ListBox control flickers and other components appear grayed when ListBox is used as the InputControlHost. (TFS:138534)

### Improvements

- Added the DateClick event to InputDatePicker. It fires when the user clicks a date in the drop-down calendar. (TFS:139034)
- Added right-to-left layout support to C1InputPanel.
- Supported zooming in/out with C1Zoom (C1InputPanelZoomPolicy required). (TFS:117499)
- Added support for DPI-aware apps.

## C1.Win.C1List

### Bug fixes

- [C1Combo] In some themes dropdown arrow is not visible. (TFS:48673)
- [C1Combo] C1Combo does not open when the DropDownContainer is closed in runtime. (TFS:128230)
- [C1Combo] In drop down list of C1Combo appears a line from border of form. (TFS:126170)

## C1.Win.C1Report

### Bug fixes

- Form.BackColor was seen under the Thumbnail View of C1PrintPreviewControl. (TFS:86497)
- When a C1PrintPreviewControl is added to the standard TabPage and its NavigationPanelVisible property is set to False, the navigation panel did not become hidden at runtime. (TFS:139811)

## C1.Win.C1Ribbon

### Bug fixes

- Large image was shown as Small image after removing ribbon and add Small then Large images in the Application Menu. (TFS:140211)
- Small image was shown as Large image when Large image is set to None in the Application Menu. (TFS:140214)
- Undo action was not sometimes available after setting the Large or Small image in the Application Menu. (TFS:140226)
- KeyTips and popup windows for collapsed groups appeared at the wrong position under certain circumstances.
- The borders of a C1RibbonForm with Custom VisualStyle appeared above the dialog box displayed from the Form.Shown event.

### Improvements

- Added the FlipImageRtl property to RibbonItem. The property indicates if the image should be flipped horizontally in RightToLeft mode.
- Added the ChildCaptionInSquareBrackets property to C1Ribbon. The property gets or sets whether the title of a maximized MDI child window should appear in square brackets after the main Form's title. (TFS:134501)

## C1.Win.C1SpellChecker

### Bug fixes

- NullReferenceException is thrown when no errors are found in the content and 'Show Spelling Errors' button is clicked. (TFS:138811)
- C1SpellCheck.UserDictionary does not work with the dictionary when dictionary created in C1DictionaryEditor. (TFS:12350)
- [C1DictionaryEditor] Discards unsaved changes in words list if words list was renamed. (TFS:13204)

## C1.Win.C1SplitContainer

### Bug fixes

- Child controls don't render correctly on a C1SplitterPanel being resized if its ResizeWhileDragging property is set to True. (TFS:49901)

## C1.Win.C1Themes

### Bug fixes

- C1FontPicker, C1ColorPicker and C1StatusBar does not display correctly for some themes. (TFS:126170)

## C1.Win.C1TrueDBGrid

### Bug fixes

- A Pop-up MessageBox gets displayed each time as project is run when a BindingSource is set as DataSource of TrueDBGrid and there is a change on the form. (TFS:139670)
- Horizontal scrollbar gets hide when a vertical split is added and "SplitDividerSize" property is set. (TFS:94345) (TFS:10658)
- Group aggregate values are not shown when grouped column is different from the aggregate column. (TFS:139676)
- Cell that is edit mode is appeared on caption area when scrolling the scroll bar. (TFS:139790)
- InvalidCast error is thrown when Column with TimeSpan DataType and ShortTime NumberFormat is edited. (TFS:138789).
- Records in a column disappear on rebinding TrueDBGrid using BindingSource.DataSource at runtime. (TFS:68064)
- Aggregate property does not work. (TFS:120550)
- Value assigned to the 'DefaultValue' property of a Column is displayed in the AddNew row. (TFS:138835)
- Item from C1TrueDBDropdown selected by Keyboard is not set to C1TrueDBGrid when user pressed Enter key. (TFS:138790)
- "No printers are installed" error is thrown when C1TrueDBGrid is exported to any format on a machine without any printer installed. (TFS:136774)

## C1.Win.FlexReport

### Bug fixes

- RtfField rendered incorrectly if it contains plain text with line breaks. (TFS:139058)
- RightToLeft property does not affect align of check mark in CheckBoxField. (TFS:140157)
- Update JP localization resources.
- Update KO localization resources.
- Update ZH localization resources.
- [JPN]Incorrect "Tolerance decting text bounds (points)" is shown in the 'Save as XLS' dialog box. (TFS:139614)
- Japanese Vertical text are not properly displayed in Excel and Word export. (TFS:139049)
- [JPN] Japanese text in the RTF field is not properly shown in RTF and Word export. (TFS:139054)
- Line break key 'Ctrl+Enter' in the Text Field , RTF Field and Paragraph Field are not effected in Word export. (TFS:139058)
- RtfField and Field with RTF == true can render text incorrectly if text is not started with "rtf prefix" {\rtf1 but has RTF snippets. (TFS:138997)
- [JPN]Old name 'C1Report' is shown in C1FlexReport Designer application name, About box and some dialog boxes.(TFS: 138901)
- Button Text in import dialog from Access report is incorrect (Jpn version).(TFS: 139007)
- Value of FieldBase.ZOrder property is ignored in some cases. (TFS:137340)
- Added support of ColumnLayout.Accross for subreports. (TFS:134966)
- C1FlexReport.RecordsPerPage property ignored for subreports. (TFS:138158)
- Position of chart axis is not changed when change compass value. (TFS:136393)
- Selected checkstyle for checkbox is not displayed properly on designer until value is not set for it. (TFS:136591)
- Exclamation mark starts displaying inside checkbox control removing its content on designer on changing Check Style from Checkbox to CustomImage. (TFS:136594)
- Image set for the Custom checkmarks overflows outside the boundary of checkbox control. (TFS:136599)
- Standard check mark continues to display for checkbox on designer even after setting CheckStyle to CustomImage. (TFS:136595)
- Check mark does not display in the Fore Color set for Check box control in report preview. (TFS:136650)
- Check Mark is displayed slightly clipped on designer when Font style for check mark is set to BoldOblique. (TFS:136652)
- Difference in behavior is observed in plotting of 3D visualization scatter charts when different number of series values are used while no series group is present. (TFS:136489)
- Deleting Main data source from collection causes an exception when rendering report. (TFS:136869)

### Improvements

- Added support of RightToLeft to text fields of C1FlexReport, added properties:
  bool? FieldBase.RightToLeft { get; set; }, default value is null, in this case C1FlexReport.RightToLeft is used.
  bool? C1FlexReport.RightToLeft { get; set; } specifies default RTL value for the report, default value is null, in this case static C1FlexReport.DefaultRightToLeft property is used.
  static bool C1FlexReport.DefaultRightToLeft { get; set; } specifies default value of RightToLeft property.
- Added C1FlexReport.AvailableHeight property, gets the height of the remaining area available for sections on the current page.

## C1.Win.FlexReport Designer App

### Bug fixes

- In the property grid, for custom fields some property editors were missing. (TFS:140222)
- Updated VBScript Editor elements' sizes to improve resizing behavior. (TFS:139780)
- RtfField drawn in design-time incorrectly when RtfField.Text specified as expression. (TFS:136860)
- If the property grid was in auto-hide mode, clicking the Properties button did not show it. (TFS:137024)
- C1Report's online help opened when clicking on the Help link of the FlexReport Designer App. (TFS:136974)
- Enabled 'Aggregates' menu in the group's SortExpression script editor. (TFS:136876)
- Unlike the C1Chart, irrelevant compass value are shown for AxisX and AxisY. (TFS:136386)
- Warning and Exception is thrown when import some Crystal report file. (TFS:136120)
- Fixed FormatPainter button's tooltip. (TFS:137018)
- Alignment set for RTF field does not get reflected in Designer. (TFS:136860)
- When multiple fields are selected, clicking the "..." button on Border property in the property grid did not bring up the border editing dialog. (TFS:137401)

### Improvements

- Added group keytips to the main form's ribbon. (TFS:120842)
- Added RTL support.
- If the data source name was invalid, it showed as "(none)" in the property grid. Now it shows the specified name with "(unavailable)" qualifier added.
- In the script editor, do not pop up code completion window inside strings or comments.
- Speed up BackgroundEditor opening.
- Support solid color mode in BackgroundEditor.
- Fix problem of cannot add items in ChartData editor (using non-EN culture).
- ChartField designer, catch and show exceptions on getting chart image.

## C1.Win.FlexViewer

### Improvements

- Added the PageRefreshRate property to set the number of pages generated between the viewer refreshes its layout.
- Added support for Right-to-Left layout.
- Added support for DPI-aware apps.

## C1ReportDesigner App

### Bug fixes

- When trying to launch the VBScript editor in the designer app for .NET 2.0, an error occurred. (TFS:138907)

# Release version 4.0.20153.102 - Nov-04-2015

##
2015 v3 Release

## C1.C1Excel

### Bug fixes

- C1Excel incorrect loaded/saved hyperlink ("Cannot open the specified file.") (TFS:136722)
- Cell range is NOT selected when cell range with Frozen row/col is selected in C1Excel book. Regression issue from Silverlight 488 build. (TFS:30427)
- NullReferenceException is thrown when loading an excle file which contains macro with .xlsx/.xls format. (TFS:135360)
- Unable to read all data from Excel file. (TFS:134318)
- Unable to read all data from Excel file. (TFS:134318)
- Format is changed after load and save by C1Excel. (TFS:134884)
- Specified hyperlink issues for complex sheet names. (TFS:134586)

## C1.C1Pdf

### Bug fixes

- Unlike build 74, Japanese text from wmf file used by DrawImage() is not exported to pdf file. (TFS:135754)
- Fixed incorrect drawing of transparent pictures for FlexReport (PdfImage.cs).
- Fixed positioning problem for not PDF/A compatible documents (PdfDocument.cs, PdfLink.cs).
- "NullReferenceException" has occurred when saving the pdf file that has attachment. (TFS:132231)

### Improvements

- Changes for support bookmarks and links for FlexReport. Added new AddBookmark method.

## C1.Win.BarCode

### Bug fixes

- "Incorrect Data Length" error message is shown in DataMatrix. (TFS:132092)

## C1.Win.C1Chart

### Improvements

- Added a new overloads for the Chart.ShowProperties() method. The new overloads allow the specification of the properties dialog location and size and returns the final size and location. The new overloads are described as follows:
  /// <summary>
  /// Raises the chart properties dialog at runtime.
  /// </summary>
  /// <param name="rect">
  /// <para>Specifies a Rectangle reference that provides and returns the properties dialog location in screen coordinates.</para>
  /// Specifying an empty rectangle will center the properties dialog relative to the chart parent window.
  /// </param>
  /// <returns>DialogResult</returns>
  /// <remarks>
  /// <para>The properties dialog allows modification of the chart properties,
  /// including data, at runtime. All available properties are displayed on multiple tabs.</para>
  /// <para>The properties dialog will always be displayed with a minimum size.</para>
  /// </remarks>
  public DialogResult ShowProperties(ref Rectangle rect)
  /// <summary>
  /// Raises the customized chart properties dialog at runtime.
  /// </summary>
  /// <param name="ppf">Specifies PropertyPageFlags combinations that limit available properties.</param>
  /// <param name="rect">
  /// <para>Specifies a Rectangle reference that provides and returns the properties dialog location in screen coordinates.</para>
  /// Specifying an empty rectangle will center the properties dialog relative to the chart parent window.
  /// </param>
  /// <remarks>
  /// <para>The properties dialog allows modification of the chart properties, including data, at runtime.
  /// All available properties are displayed on multiple tabs.</para>
  /// <para>The properties dialog will always be displayed with a minimum size.</para>
  /// </remarks>
  /// <returns>DialogResult</returns>
  public DialogResult ShowProperties(PropertyPageFlags ppf, ref Rectangle rect)
- Added a new overload for the Chart.ShowVisualEffectsEditor() method. The new overload allows the specification of the VisualEffects Editor dialog location and returns the size and final location. The new overload is described below.
  /// <summary>
  /// Raises the VisualEffects Editor dialog at runtime.
  /// </summary>
  /// <param name="rect">
  /// <para>Specifies a Rectangle reference that provides and returns the VisualEffects Editor location
  /// in screen coordinates.</para>
  /// Specifying an empty rectangle will place the editor on the edge of the chart it is editing.
  /// Note that the editor is fixed in size.
  /// </param>
  /// <returns>DialogResult</returns>
  public DialogResult ShowVisualEffectsEditor(ref Rectangle rect)

## C1.Win.C1Chart3D

### Bug fixes

- Corrected issue where Chart3D throws an exception in certain situations restoring
  persisted values if non-default contour methods are selected. (TFS:50408)

### Improvements

- Added a new overload for the Chart.ShowProperties() method. The new overload allows the specification of the properties dialog location and size and returns the final size and location. The new overload is described as follows:
  /// <summary>
  /// Raises the properties dialog at runtime.
  /// </summary>
  /// <param name="rect">
  /// <para>Specifies a Rectangle reference that provides and returns the properties dialog location in screen coordinates.</para>
  /// Specifying an empty rectangle will center the properties dialog relative to the chart parent window.
  /// </param>
  /// <remarks>The properties dialog will always be displayed with a minimum size.</remarks>
  /// <returns>DialogResult</returns>
  /// <seealso cref="C1.Win.C1Chart3D.C1Chart3D"/>
  public DialogResult ShowProperties(ref Rectangle rect)

## C1.Win.C1Command

### Bug fixes

- [C1NavBar] C1NavBarPanels switched incorrectly when child control is not validated (post validation). (TFS:19438)
- [C1DockingTab] The last tab page header is only partially visible when calling ScrollToSelectedTab method in C1DockingTab. (TFS:18231)
- [C1DockingTab] The text editing area is shown incorrectly when it is shown on the left of tab page header. (TFS:50900)
- [C1ToolBar] When is changed theme, color of separator and arrow of button in command button is not changed. (TFS:122442)
- [C1DockingTab] C1DockingTab incorrectly draws C1DockingTabPage when Alignment is 'Left' or 'Right', RightToLeftLayout=True and RightToLeft=Yes. (TFS:32225)
- [DockingTab] Docking Tab's original size is not retained after AutoHiding and then docking again. (TFS:106094)
- [DockingTab] Docking Tab's original size is not retained after AutoHiding and then docking again. (TFS:106094)
- [C1NavBar] C1NavBarSectionHeader is not updated when NavBar visibility is false and a new C1NavBarPanel object is selected at runtime. (TFS:42794)
- [C1ToolBar] Icon images from C1ToolBar are not shown in it's boundary after setting ToolBarStyle=DropDownMenu and RightToLeft=Yes. (TFS:37779)
- [C1NavBar] NavBar incorrectly draws highlighted button after change selected button in runtime. (TFS:57217)
- [C1DockingTab] C1DockingTab incorrectly draws long selected tab header when VisualStyle=Office2007, Alignment=Left, TextDirection=VerticalLeft. (TFS:18512)
- [C1DockingTab] C1DockingTab incorrectly showed EditTextBox when Alignment=Right and Text=empty. (TFS:50941)
- [C1ToolBar] C1ToolBar's cursor is still displayed as a wait cursor although the cursor is set back to default (TFS:15590)
- [C1NavBar] NavBar is displayed incorrectly when CollapseDirection=ToTop, RightToLeft=True and NavBar is collapsed. (TFS:39490)
- Last character of TopicLink's text is not displayed. (TFS:130890)
- On scrolling the C1TopicBar, TopicLinks belonging to Topic pages are not retrieved. (TFS:130890)
- [C1ToolBar] Some controls were not initialized correctly when the customize toolbars dialog is loaded. (TFS:10629)
- [C1OutBar] Scroll buttons were not moved to left side when setting 'RighttoLeft=Yes' at runtime. (TFS:33771)
- RestoreLayout method of C1DockingTab does not load the saved layout properly. (TFS:126315)
- Last character of TopicLink's text is not displayed. (TFS:130890)
- RestoreLayout method of C1DockingTab does not load the saved layout properly. (TFS:126315)

### New features

- [C1ToolBar/C1MainMenu/C1ContextMenu] New property HideFirstDelimiter. Hides the delimiter for the first visible C1CommandLink even the Delimiter property of the C1CommandLink is True. (TFS:132604)
- [C1NavBar] New method GetCollapsedSize returns the Size of the control in the collapsed state. (TFS:100970)
- C1TopicBar - keyboard support. (TFS:116821)
- Support for hiding the 'Customize..' option in the 'Add or Remove Buttons' menu. (TFS:49054)
- New property C1CommandHolder.SkipDisabledMenuItems: gets or sets a value indicating whether the user can give the focus to the CommandLink using keys when the Command is disabled.
- C1TopicBar.LinkStyle - property for setting the style of links on pages. (TFS:116816)

### Other

- [C1DockingTab] Resolved a problem with handled FileNotFoundException at SaveLayout. (TFS:128299)

## C1.Win.C1Document

### Bug fixes

- Read object of sys bool type.

## C1.Win.C1Document.C1DocumentSource and C1SSRSDocumentSource

### Breaking changes

- All OpenXXX methods have been removed:
  -- public void Open(C1DocumentLocation documentLocation);
  -- public IAsyncActionWithProgress<double> OpenAsyncEx(C1DocumentLocation documentLocation);
  -- public IAsyncActionWithProgress<double> OpenAsyncEx();
  -- public void Open();
  -- public Task OpenAsync();
  -- public Task OpenAsync(C1DocumentLocation documentLocation);
  Now C1SSRSDocumentSource.Generate() can be used immediately after defining all necessary properties like DocumentLocation, ConnectionOptions etc.
- All GenerateXXX methods are now accessible only in C1SSRSDocumentSource, in C1DocumentSource they are internal:
  -- public void Generate();
  -- public IAsyncActionWithProgress<double> GenerateAsyncEx();
  -- public Task GenerateAsync();
- All ApplyParameterValuesXXX and CheckParameterValuesXXX methods have been removed:
  -- public List<ParameterValueError> ApplyParameterValues();
  -- public IAsyncOperationWithProgress<List<ParameterValueError>, double> ApplyParameterValuesAsyncEx();
  -- public Task<List<ParameterValueError>> ApplyParameterValuesAsync();
  -- public List<ParameterValueError> CheckParameterValues();
  -- public Task<List<ParameterValueError>> CheckParameterValuesAsync();
  -- public IAsyncOperationWithProgress<List<ParameterValueError>, double> CheckParameterValuesAsyncEx();
  Use C1SSRSDocumentSource.ValidateParameters(...) instead. The values of parameters are applied automatically before generating.
- Methods ExecuteCustomActionXXX, GetPageXXX and GetBookmarkPositionXXX() are now internal and inaccessible:
  -- public IAsyncOperationWithProgress<C1BookmarkPosition, double> ExecuteCustomActionAsyncEx(CustomAction action);
  -- public Task<C1BookmarkPosition> ExecuteCustomActionAsync(CustomAction action);
  -- public C1Page GetPage(int pageIndex);
  -- public Task<C1Page> GetPageAsync(int pageIndex);
  -- public IAsyncOperationWithProgress<C1Page, double> GetPageAsyncEx(int pageIndex);
  -- public virtual C1Page GetLoadedPage(int pageIndex);
  -- public bool IsPageLoading(int pageIndex);
  -- public C1BookmarkPosition GetBookmarkPosition(string bookmark);
  -- public IAsyncOperationWithProgress<C1BookmarkPosition, double> GetBookmarkPositionAsyncEx(string bookmark);
  -- public Task<C1BookmarkPosition> GetBookmarkPositionAsync(string bookmark);
- All functionality related to text searching was moved to the C1FlexViewer, following methods and properties have been removed:
  -- public C1FoundPosition FindTextStart(int startPageIndex, bool wholeDocument, C1FindTextParams findParams);
  -- public IAsyncOperationWithProgress<C1FoundPosition, double> FindTextStartAsyncEx(int startPageIndex, bool wholeDocument, C1FindTextParams findParams);
  -- public Task<C1FoundPosition> FindTextStartAsync(int startPageIndex, bool wholeDocument, C1FindTextParams findParams);
  -- public C1FoundPosition FindTextNext(C1FoundPosition foundPosition);
  -- public IAsyncOperationWithProgress<C1FoundPosition, double> FindTextNextAsyncEx(C1FoundPosition foundPosition);
  -- public Task<C1FoundPosition> FindTextNextAsync(C1FoundPosition foundPosition);
  -- public C1FoundPosition FindTextPrevious(C1FoundPosition foundPosition);
  -- public IAsyncOperationWithProgress<C1FoundPosition, double> FindTextPreviousAsyncEx(C1FoundPosition foundPosition);
  -- public Task<C1FoundPosition> FindTextPreviousAsync(C1FoundPosition foundPosition);
  -- public void FindTextReset();
  -- public C1HighlightAttrs FindMatchHighlight { get; set; }
  -- public C1HighlightAttrs ActiveFindMatchHighlight { get; set; }
  -- public IList<C1FoundPosition> FoundPositions { get; }
  -- public C1FoundPosition ActiveFoundPosition { get; set; }
- The following properties have been removed (text selection functionality has been moved to viewers):
  -- public C1DocumentRange SelectedRange { get; set; }
  -- public C1HighlightAttrs SelectionHighlight { get; set; }
- The property
  -- C1DocumentSourceState C1DocumentSource.State { get; set; }
  and enum C1DocumentSourceState have been removed.
  C1DocumentSource.BusyState should be used instead:
  -- public C1DocumentSourceBusyState BusyState { get; }
  // Summary:
  // Describes the busy state of a C1DocumentSource object.
  public enum C1DocumentSourceBusyState
  {
  // Summary:
  // The document is ready (not busy).
  Ready,
  // Summary:
  // The document is currently generating.
  Generating,
  // Summary:
  // The document is currently exporting.
  Exporting,
  // Summary:
  // The document is currently printing.
  Printing,
  }
  The following properties can be used to determine the current state of the C1DocumentSource:
  // Summary:
  // Gets the value indicating whether the current C1DocumentSource busy.
  public bool IsBusy { get; }
  // Summary:
  // Gets a value indicating whether this C1DocumentSource is disposed and can not be longer used.
  public bool IsDisposed { get; }
- The following events were removed:
  -- event EventHandler<ExecuteCustomActionCompletedEventArgs> ExecuteCustomActionCompleted;
  -- event EventHandler<GetPageCompletedEventArgs> GetPageCompleted;
  -- event EventHandler<GetLinkTargetPositionCompletedEventArgs> GetLinkTargetPositionCompleted;
  -- event EventHandler PagesClear;
- The following events were moved to C1SSRSDocumentSource:
  -- event EventHandler<AsyncCompletedEventArgs> GenerateCompleted;
  -- event EventHandler<ValidateParametersCompletedEventArgs> ValidateParametersCompleted;
  -- event EventHandler<ExportCompletedEventArgs> ExportCompleted;
- The following methods are accessible only from via C1SSRSDocumentSource():
  -- public void Clear();
  -- public void Cancel();
- Methods ValidateParameterXXX were added to replace ApplyParameterValues and CheckParameterValues:
  -- public List<ParameterValidationError> ValidateParameters();
  Async variants:
  -- public new IAsyncOperationWithProgress<List<ParameterValidationError>, double> ValidateParametersAsyncEx();
  -- public Task<List<ParameterValidationError>> ValidateParametersAsync();
  These methods validate the current parameter values and refresh their valid values lists if the values are valid.
  Note that parameter values are now applied automatically when a report generation starts.

## C1.Win.C1FlexGrid

### Bug fixes

- Microsoft Visual Studio crashes when opening form design of existing projects during trial expired or license expired period. (TFS:136588)
- FilterDefinition was not applied correctly if DataType of column was changed before applying. (TFS:136339)
- Columns which contain MultiColumnDictionary as DataMap were not displayed correctly. (TFS:136223)
- Headers of C1FlexGrid were not localized at runtime when setting ColumnInfo property. (TFS:125436)
- Some GDI objects of form with C1FlexGrid were not released when the Column property of Tree is set and the form is closed. (TFS:132121)
- LeaveCell event fired twice when selection range was changed during the event. (TFS:122665)
- Text was displayed incorrect in output Excel file if Excel file with custom numeric format is loaded into C1FlexGrid and C1FlexGrid was saved to Excel file format. (TFS:7696)
- ToolTip of cell was not displayed completely if WordWrap property set to True (TFS:64754)
- C1FlexGrid was freezing if ToolTip is assigned to column header of C1FlexGrid in MouseMove event. (TFS:80260)
- ComboCloseUp event of C1FlexGrid was not fired if ComboBox of C1FlexGrid is closed by keyboard key. (TFS:114520)
- Custom styles of C1FlexGrid were removed if theme containing visual style definition was applied to C1FlexGrid. (TFS:118846)
- 'IndexOutOfRangeException' was thrown in some cases when inserting a new row by clicking last row. (TFS:131715)
- Value of last blank cell cannot be pasted if multiple cells were copied and last cell has empty value. (TFS:133790)
- BindingContextChanged event was fired more than once. (TFS:7900)
- All data were copied even if some data is filtered. (TFS:38912)
- DropDownList was displayed incorrect if MultiColumnDictionary has empty or null data. (TFS:115409)
- C1FlexGrid.ComboBoxEditor.SelectedKey always returned null if DataMap of a column is MultiColumnDictionary. (TFS:129183)
- 'NullReferenceExcepiton' was thrown when filter is applied. (TFS:131580)
- Horizontal Scrollbar in Filter Dialog was not shown when It should be. (TFS:8413)
- Improved the performance of AutoSizeCols method for large number of rows. (TFS:35014)
- All Column headers was highlighted when Theme is applied and ShowThemedHeaders property is set to ShowThemedHeadersEnum.SelectedOnly. (TFS:92763)
- FilterDefinition was loaded incorrectly when columns have non-unique names. (TFS:121254)
- 'IndexOutOfRangeException' was thrown when adding data to new row of C1FlexGrid which uses 'C1DataSource' as its datasource. (TFS:122695)
- Image of "Apply to Fixed Rows" button in the Column Editor indicated wrong state of button. (TFS:127895)

## C1.Win.C1GanttView

### Bug fixes

- With unchecked Start and Finish checkboxes and populated Duration in Task Information form the Duration value was not taken into account. (TFS:131039)
- Updated Japanese datetme formats in list for timescale. (TFS:111357)

### Improvements

- Added Successors property for Task class. (TFS:101909)
- Added indicator for completed tasks. (TFS:129950)
- Added two properties (ChartStartDate and ChartFinishDate) bounding the scrolling area in chart view. (TFS:111358)
  By default these properties contain autmatic values depending on start and finish dates of tasks and project.
  User can assing separately ChartStartDate or ChartFinishDate to bound scrolling area manually from left or from right side, or both togever.
  User also can assign nulls to reset dates to automatic values.
- User now is able to select multiple rows/columns and make changes in selected tasks simultaneously. (TFS:111352)
- User now is able to split a task to parts.
  Added it was add the following classes and Task's properies and methods:
  /// Represents parts of splitted task.
  public class Parts : IEnumerable<double>
  {
  /// Gets or sets the durations of task's parts.
  public double this[int index]
  /// Returns the count of parts.
  public int Count
  }
  /// Represents dates (starts and finishes) of task's parts.
  public class PartDates : IEnumerable<DateTime>
  {
  /// Get dates (starts and finishes) of parts.
  public DateTime this[int index]
  /// Returns the count of dates.
  public int Count
  }
  public class Task : BaseTask, ICustomTypeDescriptor
  {
  /// Gets parts of the task.
  public override Parts Parts
  /// Splits the task.
  public override bool SplitTask(DateTime start, double duration)
  }
- Now user can drag a task to other row. (TFS:111349)

## C1.Win.C1Input

### Bug fixes

- C1ComboBox does not display special character "<" in the DropDown list. (TFS:123717)

### New features

- C1ColorPicker.Color - property to set current color of C1ColorPicker.

## C1.Win.C1InputPanel

### Improvements

- Added the MaxDropDownItems property to InputMenu element to specify the maximum number of items displayed in the drop-down list without scrolling.
- Added the GripHandleVisible property to InputMenu. The property gets or sets whether the drop-down can be resized.

## C1.Win.C1List

### Bug fixes

- With MultipleLine DataView and exporting to xls, throws SystemException in C1.Win.C1List dll. (TFS:40508)

## C1.Win.C1Report

### Bug fixes

- Now values of parameters in the SSRS parameters dialog are refreshed when user selects another value in the combobox, in previous versions values were refreshed only when parameter's control lost an input focus. (TFS:129873)

## C1.Win.C1Ribbon

### Bug fixes

- If the button becomes enabled while the mouse pointer hovers it, it was still impossible to click the button without leaving/entering it with the mouse.
- The hot-key prefix is now ignored in tooltips and there is no need to duplicate the ampersand (&) character.
- Restored the position of input focus after working with TextBox-based elements on C1Ribbon and C1StatusBar.
- Fixed theme templates for C1Ribbon to reflect Font changes in BaseThemeProperties. (TFS:91135)
- C1RibbonForm caption and border blinked when opening a dropdown on C1Ribbon, such as the Application Menu (the issue is fixed for the Custom VisualStyle and for DisableGlassEffects mode of C1RibbonForm).
- ContextMenu was not shown when the right mouse button is clicked on a Button placed in the ConfigToolBar. (TFS:133185)
- NullReference Exception was thrown after closing C1RibbonForm which contains C1FlexViewer. (TFS:133180)
- The Close button of C1RibbonForm was not disabled when setting CS_NOCLOSE flag in the window class style. (TFS:133456)
- Appearance of C1RibbonForm with Aero Glass was corrupted after executing RecreateHandle(). (TFS:133784)
- Key tips appeared after releasing the Alt key if another key was pressed as well, such as PrintScreen.
- Resolved a few small issues with 168 DPI in a DPI-aware application running on Windows 10.
- TitleBar was not rendered properly on Windows 7 if the C1RibbonForm started in maximized state. (TFS:129379)
- The glow window bounds appeared before the C1Ribbonform is restored after minimizing. (TFS:129386)

### Improvements

- Added the CaptureAltKeyInTerminalSession boolean runtime-only property to C1Ribbon. It allows to display KeyTips with Alt key in a terminal session ignoring the possible issues. (TFS:130728)
- Added the HideAppMenuWithTHR boolean property (runtime only) to address the compatibility issues when (in some old builds) the AppMenu button did not appear (but remained visible logically) while the tab header row is hidden. (TFS:130864)
- Added the LauncherEnabled boolean property to RibbonGroup. It sets whether the dialog launcher button is enabled (True by default).
- The size of the Collection Editor forms won't reset to the default size anymore (until closing the Visual Studio).

## C1.Win.C1Schedule

### Breaking changes

- WinXP Visual Styles and some other stuff related to Office 2003 representation have been removed.
  This includes Office 2003 palettes, showing day statuses in the DayView mode as colored bars and appointment borders colored with busy status brush.
  This doesn't include Office 2003 WeekView style.

### Improvements

- System VisualStyle has been updated for more modern appearance.

## C1.Win.C1Sizer

### Bug fixes

- [C1SizerLight] C1OutPages disappeared after resizing the Form with C1SizerLight. (TFS:129810)

## C1.Win.C1SpellChecker

### Bug fixes

- C1SpellChecker changed non-editable content. (TFS:114407)
- Some Catalan words are marked as error. (TFS:121170)

## C1.Win.C1TileControl

### Bug fixes

- Addressed an issue with showing C1TileControl from multiple threads. (TFS:132309)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Special characters cannot be entered in C1TrueDBGrid. (TFS:133270)
- Merged data disappears when the merged column of a bound C1TrueDBGrid is selected and 'Rebind' method is called (TFS: 95560)
- Unhandled exception is thrown when open the C1TrueDBDropdown twice (TFS: 131120)
- String reversed when grid yet RTL = true and arabic culture settings (TFS: 125579)
- RowColChange fires extra time on grid load. (TFS:116382)
- Incorrect behavior is observed when custom editor is used in C1TrueDBGrid (TFS:109626)
- Strange behavior is observed while using C1TrueDBGrid in Hierarchical mode (TFS: 129864)
- Inappropriate behavior of C1TrueDBGrid is observed in Hierarchical mode (TFS: 129865)
- With setting MarqueeStyle as FloatingEditor, the cursor moves to the end of sentence when you input and delete the characters to a cell (TFS: 130014)
- e.OldValue in BeforeColUpdate event returning new value. (TFS:133928)
- BeforeColUpdate and AfterColUpdate events fire twice when focus is shifted to any other cell using Tab key. (TFS:133960)
- BeforeColUpdate and AfterColUpdate events does not fire at all when a cell is edited and another cell is clicked. (TFS:132178)
- Merged data disappears when the merged column of a bound C1TrueDBGrid is selected and 'Rebind' method is called (TFS: 95560)
- Unhandled exception is thrown when open the C1TrueDBDropdown twice (TFS: 131120)
- String reversed when grid yet RTL = true and arabic culture settings (TFS: 125579)
- RowColChange fires extra time on grid load. (TFS:116382)
- Incorrect behavior is observed when custom editor is used in C1TrueDBGrid (TFS:109626)
- Strange behavior is observed while using C1TrueDBGrid in Hierarchical mode (TFS: 129864)
- Inappropriate behavior of C1TrueDBGrid is observed in Hierarchical mode (TFS: 129865)
- With setting MarqueeStyle as FloatingEditor, the cursor moves to the end of sentence when you input and delete the characters to a cell (TFS: 130014)
- Incorrect behavior is observed when custom editor is used in C1TrueDBGrid (TFS: 109626)
- AfterColUpdate is not raised when the cell is edited and cursor cell is changed using mouse (TFS: 129605)
- 'Cannot interpret token ']' at position'error occurs when Decimal column is filtered using FilterBar(TFS: 129367)
- Same value is shown for all rows on hierarchical C1TrueDBGrid when sorting the column with descending order and refresh the grid (TFS: 129299)
- Parent rows are displayed in hierarchical C1TrueDBGrid when open the filter dropdown list after unchecking the "SelectAll' checkbox in it (TFS: 129298)

### Improvements

- Improved performance of assigning new data in unbound mode when use Frame.AddRows(count) method.

### Other changes

- target Framework for .Net 4 build changed to .Net Framework 4 Client Profile.
  It should not affect control or design-time behavior in any way.

## C1.Win.C1Win7Pack

### Improvements

- Added a few methods to C1TaskbarButton class: AddShortcutToStartMenu, RemoveShortcutFromStartMenu, ShortcutExistsInStartMenu.
- Added the method overloads to C1TaskbarButton for registering/unregistering the file associations in HKEY_CURRENT_USER instead of HKEY_CLASSES_ROOT.

## C1.Win.FlexPivot

### Initial release (Beta)

- C1.Win.FlexPivot is a replacement for the C1.Win.Olap control. In addition to the two earlier data options supported in C1.Win.Olap,
  it has a new data option, C1.DataEngine that can handle virtually unlimited volumes of data very fast, millions rows of data in
  a fraction of a second. It also has UI modernizations and improvements.

## C1ReportDesigner App

### Bug fixes

- Better handling of floating tabs in the designer app. (TFS:120942)

## C1Themes Designer App

### Improvements

- Added pressed style for C1TopicLink

# Release version 4.0.20152.74 - Aug-30-2015

##
2015 v2.5 Release

## C1.C1Excel

### Bug fixes

- Specified background pattern for the ConditionalFormatted cells is not saved. (TFS:127975)
- Header and footer image is not displayed when setting header and footer image by using C1Excel. Regression of TFS:121907. (TFS:127155)
- Unlike previous build, NullReference Exception is thrown when loading excel file using Load method of XLBook. (TFS:126143)

### Improvements

- Added support of OpenXMLMacro format (Open XML format with support VBA projects, *.xlsm extension).

## C1.C1Pdf

### Bug fixes

- 'AddTarget' method does not work when AcroField (PDFTextBox) is used in the PDF document. (TFS:115085)

### Improvements

- Common code with C1Pdf for Silverlight(WPF/UWP/WinRT) and many changed for it.
- Added support of PDF/A format (ConformanceLevel property).
- Changes for support bookmarks and links for FlexReport. Added new AddBookmark method.

## C1.Win.BarCode

### Breaking changes

- Added CaptionGrouping property

## C1.Win.C1Chart3D

### Bug fixes

- Corrected issue where Chart2D does not scale the Y2 axis based on the Interaction property/object. This issue was introduced with C1Chart build 4.0.20141.24156 in June of 2014. (TFS:125257)

## C1.Win.C1Command

### Bug fixes

- [C1TopicBar] Setting RightToLeft property to "Yes" does not fire the click events on right. (TFS:6989)
- [C1DockingTab] Incorrect property description is shown for 'ShowTabs' (TFS:50883)
- Style in C1TopicBar was not changed after applying theme using C1ThemeController. (TFS:113186)

## C1.Win.C1Document

### Bug fixes

- In some cases exception occurs when C1DocumentSource.Generate() called and exist active GetPageAsync() requests. From user's point of view this situation occurs when he switches print layout in C1PrintPreviewControl linked with C1SSRSDocumentSource.(TFS:128366)

## C1.Win.C1FlexGrid

### Bug fixes

- Cells was not highlighted if Highlight property is set to HighLightEnum.WithFocus and SelectionMode is set to SelectionModeEnum.Row. (TFS:117314)
- CellLabels didn't display the complete data. (TFS:117409)
- Auto search in the ComboBox cell worked incorrectly. (TFS:121232)
- Structure of outline view was distorted in the Excel file when C1FlexGrid is saved to Excel. (TFS:123363)
- ComboList could not be set in StartEdit event. (TFS:125731)
- Some operators in filter form didn't work correctly when filter is applied on the column having custom DataType. (TFS:126925)
- Theme of C1FlexGrid could not be restored to default value. (TFS:95186)
- Focus of controls was moved in ascending order if Shift+Tab shortcut is pressed several times when cell is in edit state. (TFS:115005)

## C1.Win.C1GanttView

### Bug fixes

- ProjectSummary.IsCollapsed property did not work at design time. (TFS:123742)

### Improvements

- Combo box with Resources list is added to condition grid instead of text box in Advanced Filter Dialog. (TFS:79237)

## C1.Win.C1Input

### Bug fixes

- Setting of "AutoCompleteSource.ListItems" at DesignTime or before DataBinding does not
  effect on C1ComboBox. (TFS:67137)
- C1Label doesn't resize correctly and text is truncated when C1Label is added to FlowLayoutPanel. (TFS:79213)
- C1ComboBox only displays the first value in the table when bound. (TFS:125848)
- TextChanged event for TextBoxBase Input controls fired incorrectly when inputting text with copy/paste operation. (TFS:118643)

## C1.Win.C1InputPanel

### Bug fixes

- C1InputPanel might appear filled with black between calls to the BeginUpdate/EndUpdate methods.

## C1.Win.C1List

### Breaking changes

- Default value for C1ComboBox and C1ListBox CaptionHeight property changed to -1.
  This means that actual height will be determined automatically based on the font size.
  Setting property to 0 will hide the caption. (TFS:126178)
- C1ComboBox.CaptionVisible property is marked as obsolete. To hide list caption set CaptionHeight property to 0.

### Bug fixes

- Default value for C1ComboBox and C1ListBox CaptionHeight property changed to -1.
  This means that actual height will be determined automatically based on the font size.
  Setting property to 0 will hide the caption. (TFS:126178)
- SelChange event is not fired by using up/down key and space bar to select. (TFS:119050)
- SelChange event is not fired when 'ShowHeaderCheckBox' property of the C1List is set to 'true' and the Header CheckBox is Clicked. (TFS:114533)
- HelpRequested event is not raised when ComboStyle property is set to DropdownList (TFS:124234).

## C1.Win.C1Report

### Bug fixes

- An exception occurred on click to the "Print Layout" button in ssrs paginated mode if already generated SSRS report was assigned to the preview control. (TFS:127765)
- Navigation between SSRS reports did not work since build .66.

## C1.Win.C1Ribbon

### Bug fixes

- C1Ribbon might appear filled with black between calls to C1Ribbon's BeginUpdate/EndUpdate methods.
- MDI child window maximized when RibbonTab is selected in the C1RibbonForm.MdiChildActivate event handler. (TFS:127311)
- If some items of Ribbon Application Menu are added to QAT their visiblity was not updated when the Application Menu becomes hidden or visible. (TFS:126045)
- Order of child C1RibbonForms is reverted and focus of current form is lost on switching 'System' theme to 'Classic' on Windows 7. (TFS:87353)
- When the user opens a form with "Visual Basic PowerPack" control and C1Ribbon, Visual Studio shows an error. (TFS:125908)
- Black line appeared along the Ribbon tabs when QAT is shown below the Ribbon. (TFS:125170)
- Click event of RibbonButton that was added to ConfigToolBar did not occur. (TFS:124096)
- C1RibbonForm's re-sizing cursor was not visible easily for MDI child form. (TFS:123794)

### Improvements

- Images of size other than 16x16 can be displayed on RibbonTabs for VisualStyles other than Custom after executing C1RibbonForm.DisableGlassEffects() method. (TFS:108802)
- Added the CaptionAlignment property to C1Ribbon control specifing horizontal alignment of the form caption. (TFS:125485)

## C1.Win.C1RibbonPreview

### Bug fixes

- Page count label was not updated for SSRS reports in print layout mode when the user changes page settings.

### Other changes

- The Portrait/Landscape buttons are available now for paginated SSRS mode. It was impossible to change the page orientation without affecting the page size. (TFS:128250)

## C1.Win.C1Schedule

### Bug fixes

- When switching over from a week view to a month view, a different period is displayed for a moment (TFS:126606).
- control layout is not updated after changing control font size (TFS:10088).

## C1.Win.C1Sizer

### Bug fixes

- Clicking Splitter command from 'C1Sizer Tasks� menu cannot set the Splitter on or off. (TFS:9887)
- Clicking �Fixed Size� command from �C1Sizer Tasks� menu cannot does not work. (TFS:9888).

## C1.Win.C1TileControl

### Bug fixes

- Tiles disappeared when the height of C1TileControl is reduced less than 54 pixels. (TFS:125131)

## C1.Win.C1TouchToolKit

### Bug fixes

- ObjectDisposedException on closing an MDI child form containining C1Zoom. (TFS:127786)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Strange behavior observed when e.value is set to 'null' in the FormatText event of C1TrueDBGrid (TFS: 107677)
- Default value for CheckBox is not set when a new row is added by clicking on the CheckBox of the CheckBox column (TFS: 126359)
- Window form's menu pops up when pressing Alt and then Up arrow key while opening TrueDBDropDown (TFS: 114284)
- The last column of the C1TrueDBGrid is cut on setting the 'ExtendRightColumn' property of the grid to 'true' in a Grouped TrueDBGrid (TFS: 121843)
- Text of first column header disappear when setting 'MultipleLinesFixed' to 'DataView property of TrueDBGrid (TFS: 126913)
- 'DisplayMember' of the rows of 43(with filtered 'DataView' as its 'DataSource') is not displayed correctly if the rows are not in the view (TFS: 126592)
- Sort order of the grouped column not restored when C1TrueDBGrid is loaded using 'LoadLayout' method (TFS: 126394)
- Selection is moved to next cell when press "Enter" key after choosing the item from filter dropdown (TFS: 127180)
- Focus is moved to the cell after adjacent cell when press 'Enter' key in the unbound grid (TFS: 127252)
- Sorting cannot be reset when "AllowSorting=False" (TFS: 127184)
- Inappropriate behavior when Filtering is applied on hierarchical C1TrueDBGrid (TFS: 124540)
- Both Vertical and Horizontal Scroll Bar of C1TrueDBGrid shift to the opposite side of original position when its ‘Dock’ property is not ‘None’,
  C1SizerLight is placed on the form and the form is resized (TFS: 9895)
- C1TrueDBGrid does not show correct ToolTip on PictureHeader when ‘FetchCellTips’ event is used and ToolTip is changed (TFS: 119192)
- Different BorderStyle is displayed for buttons with Aero theme in C1TrueDbGrid (TFS: 75692)
- All the groups in the grid do not render as expanded even if the OutlineMode of GroupInfo is set to StartExpanded (TFS: 114080)
- It is always selected first item when have two items of same string in C1TrueDBDropdown, and then error occurs when click other cell (TFS: 115495)
- Filter list is not changed when the 'Translate' property of the ValueItems collection is set to 'true' and filtering is applied using FilterDropDown (TFS: 119645)
- Column of the child table blank out on scrolling the C1TrueDBGrid when its 'CellTips' is set to 'true' and 'DataView' is set to 'Hierarchical' (TFS: 117331)
- When setting MarqueeStyle to "FloatingEditor", the inputted value to the new row won't be displayed at the Frozen column (TFS: 125214)
- BeforeColUpdate event fires twice before the cell is updated (TFS: 124592)
- Items in the FilterDropDown disappear when filter is applied to hierarchical grid (TFS: 124537)

## C1.Win.C1Win7Pack

### Improvements

- Added a few members to the TaskDialogCommonIcon enumeration to display combined icons, such as "Shield + Error" and others.

## C1.Win.Olap

### Improvements

- Provide the feature for expanding/collapsing all subtotals. (TFS:17440)
  /// Collapse all the columns of subtotal groups.
  public void CollapseAllCols()
  /// Collapse all the rows of subtotal groups.
  public void CollapseAllRows()
  /// Expand all the columns of subtotal groups.
  public void ExpandAllCols()
  /// Expand all the rows of subtotal groups.
  public void ExpandAllRows()

# Release version 4.0.20152.67 - Jul-08-2015

## C1.C1Excel

### Bug fixes

- Postion of Custom Header (Image) is changed when saving an excel file using C1Excel. Really image moved from page header to sheet. (TFS:121907)
- When loaded .xlsx that fixed Column/Row is set and active cell is set into fixed Column/Row, saved .xlsx is incorrect. (TFS:120427)
- In loaded xlsx file, Index of print title cannot get by GetRangeToRepeat method. (TFS:119851)
- When loaded .xlsx that fixed Column/Row is set and active cell is set into fixed Column/Row, saved .xlsx is incorrect. (TFS:120427)
- In loaded xlsx file, Index of print title cannot get by GetRangeToRepeat method. (TFS:119851)

### Improvements

- Added the new constructor with license key (C1XLBook class).

## C1.C1Pdf

### Bug fixes

- Field with font 'Arial, Bold' is not embedded correctly if any other field with font 'Arial, Regular' is rendered before it in C1Report. (TFS:117794)
- ‘FillPath’ method does not draw rounded corners properlyю (TFS:118850)
- Field with font 'Arial, Bold' is not embedded correctly if any other field with font 'Arial, Regular' is rendered before it in C1Report. (TFS:117794)
- "FillPath" method does not draw rounded corners properly. (TFS:118850)

### Improvements

- Added the new constructor with license key (C1PdfDocument class).

## C1.C1Report

### Breaking changes

- Projects using C1.C1Report.CustomFields now must also have references to C1.Win.4 and C1.Win.BarCode.4 assemblies (applies to .NET 4.0 version only).
- Projects using C1Report now must also have references to C1.Win.4 and C1.Win.BarCode.4 assemblies (applies to .NET 4.0 version only).

### Bug fixes

- Exception occurs during exporting report contains barcode fields with zero height or width.(TFS:123643)
- Polar and Radar Chart are shown as black circle and chart lines are not seen in exported RTF file. (TFS:123723)
- Chart image is not shown in 'Design' mode when use 'XDataBoundaries' and 'SemiAutomatic' of 'Histogram' chart type. (TFS:123630)
- Warning or error message is not shown although XMin/YMin value is grater than the XMax/YMaxvalue of chart. (TFS:123636)
- Margins of the fields drawn incorrectly in design-time if C1Report.CreationDevice is Printer and "Use C1Report.CreationGraphics as reference graphics to render fields" option in C1ReportDesigner checked.(TFS:123123)
- If section of report contains subreport field then only this subreport field will be exporter with TextFilter, all other fields are ignored.(TFS:120010)
- In some rare cases RTF fields break between pages incorrectly.(TFS:95379)
- Chart axis labels are not shown clearly when report with custom Chart is loaded in DocumentViewer.(TFS:120126)
- 'NullReferenceException' is thrown when a C1Report containing 'Null' value field with any 'Format' is exported using 'RenderToFile' method.(TFS:120046)
- Polar and Radar Charts show cluttered values in Default view.(TFS:119472)
- 'NullReferenceException' is thrown when a C1Report containing 'Null' value field with any 'Format' is exported using 'RenderToFile' method.(TFS:120046)

### Improvements

- Added the ability to reference paths to special folders specified by the Environment.SpecialFolder enum, in ConnectionString elements in report definition XML files.
  E.g. the following ConnectionString may be used to connect to C1NWind.mdb installed by the C1 Studio installer:
  "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=?(SpecialFolder.MyDocuments)ComponentOne Samples\common\c1nwind.mdb;Persist Security Info=False".
- Add Step, Histogram, Radar and Polar chart type of Chart field in C1Report. (TFS:80631)
- Add C1.WPF.C1Report.CustomFields.4.dll assembly. (TFS:80639)

## C1.Win.BarCode

### Breaking changes

- Added CheckSumEnabled property (TFS: 123501)
- Added InvalidStructureNumberDM message and translation
- Renamed property Code128Options to Ean128Fnc1Options.(TFS:122370)

### Initial release

- C1.Win.Barcode assembly replaces the old C1BarCode and C1QRCode controls with a single C1BarCode control that uses a different codebase.
  It implements more barcode types than the old version.

## C1.Win.C1BarCode

### Breaking changes

- C1BarCode and C1QRCode controls marked as obsolete in .Net 4.0 version. Please use C1BarCode control from the C1.Win.BarCode.4 assembly instead.

## C1.Win.C1Chart3D

### Bug fixes

- Corrected issue where some Chart3D displays were causing an exception during the paint resulting in a failure to draw the results. This is another issue related to .NET 4.5 and higher sorting changes (TFS:120052)
- Improved rounding of automatic axis limits by reducing the significant digits requested within floating point round off error limits. (TFS:123326)

## C1.Win.C1Command

### Bug fixes

- Part of tooltip of C1MainMenu toolbar is not localized. (TFS:121354)
- When set the blank to C1DockingTabPage.Text property, ArgumentOutOfRangeException occurred. (TFS:119673)

## C1.Win.C1Editor

### Bug fixes

- C1Editor LoadXML Method Ignoring AllowAdHocTags Flag (TFS:124117)

## C1.Win.C1FlexGrid

### Bug fixes

- 'ArgumentOutOfRangeException' was thrown in some cases when frozen region boundary was clicked. (TFS: 116278)
- When used WriteXml/ReadXml method, cell style is not written and read. (TFS:118884)
- Multiselection did not work correctly when filter is applied on C1FlexGrid. (TFS: 120681)
- RowColChange event fired twice when selection range was changed during the event. (TFS: 117536)
- ValidateEdit event of C1FlexGrid was raised when clicking a button with CausesValidation property set to false. (TFS: 97607)
- When cut the value in cell of numeric type and move to another cell, the value was restored to state before cutting. (TFS: 120414)
- vbTab symbol was not supported when use it in DataTable class to create new instance of MultiColumnDictionary. (TFS: 115337)

### Other changes

- Added EscPassThrough property for controlling of firing KeyPressEdit and KeyPressUp events if Esc key was pressed.
- Added IC1MultiColumnDictionary2 interface with GetColumnValue method for retrieving data from any column of MultiColumnDictionary.

## C1.Win.C1GanttView

### Breaking changes

- Now it is necessary a reference to C1.Win.C1FlexGrid.
- Now it is necessary a reference to C1.Win.C1Schedule.
- Changed inheritance for classes TaskCollection, CustomCalendarCollection, ResourceCollection from BindingList to C1.C1Schedule.BaseCollection.

### Bug fixes

- Bar Style dialog did not work for a task with empty name. (TFS:120492)
- StackOverflow exception raised if do Zoon In, Undo and Redo after that. (TFS:120346)
- Unhandled exception was thrown when cancel the "Task Information" dialog for the empty C1Ganttview. (TFS:114775)
- Task information tooltip text was trimmed when we zoom C1GanttView and select a bar to drag it. (TFS:118455)
- A bar's long text was trimmed, when we zoom in C1GanttView. (TFS:118454)
- When set "Or" to first filter in "Advanced Filter" dialog, filtering was not applied. (TFS:116085)
- Tasks.ListChanged event handler got null in e.PropertyDescriptor for custom fields. (TFS:76018)
- When font size is greater than rows height in Field Style, the displayed character was cut off. (TFS:115160)

### Improvements

- Task.IsCollapsed and Task.Summary were made public in order to give a user possibilty to expand/collapse summary tasks. (TFS:109540)
- Added data binding feature. Added new C1GanttViewStorage component which handles all data
  operations for the C1GanttView control and contains specific data storages for tasks, resources, calendars and properties
  which are used for binding corresponding collections to the data.
  After you set up required mappings, C1GanttView will be able to synchronize data in both directions without any additional code.

## C1.Win.C1Input

### Breaking changes

- Now it is necessary a reference to C1.Win.C1Command.

### Bug fixes

- ArgumentOutOfRangeException was thrown when typing hex color code in textbox area of C1ColorPicker. (TFS:117712)
- TabStop property of C1RangeSlider did not work. (TFS:110712)
- Previous/next item of C1ColorPicker could not be selected by pressing Up/Down arrow key. (TFS:118503)
- NullReferenceException is thrown on restoring form in which some InputControls are using as RibbonControlHost after pressing Window+D. (TFS:118084)
- Upper/Lower thumb button of C1RangeSlider did not move when clicking on the right/left side of slider track. (TFS:110705)
- Thumb was not shown completely by setting CornerRadius property of C1RangeSlider. (TFS:111505)
- Theme does not get rendered when custom Theme created for C1TextBox ReadOnly
  property is applied. (TFS:106078)

### Improvements

- Editable Japanese era;
  For JapaneseCalendar it is possible to edit Era field in the editor, using numeric era hot keys (1-4), using spin operations and Up and Down keys;
- Ability to set different calendars for Edit and Display mode.
  Example:
  c1DateEdit1.Culture = new System.Globalization.CultureInfo("ja-JP").LCID;
  c1DateEdit1.EditFormat.CalendarType = C1.Win.C1Input.CalendarType.JapaneseCalendar;
  c1DateEdit1.DisplayFormat.CalendarType = C1.Win.C1Input.CalendarType.GregorianCalendar;
  c1DateEdit1.EditFormat.FormatType = C1.Win.C1Input.FormatTypeEnum.CustomFormat;
  c1DateEdit1.DisplayFormat.FormatType = C1.Win.C1Input.FormatTypeEnum.CustomFormat;
  c1DateEdit1.EditFormat.CustomFormat = "ggyy年MM月dd日";
  c1DateEdit1.DisplayFormat.CustomFormat = "yyyy/MM/dd";
- [JPN only] static JapaneseEraHelper.AddJapaneseEra, ClearJapaneseEras methods to add new eras;
  Example:
  JapaneseEraHelper.ClearJapaneseEras();
  JapaneseEraHelper.AddJapaneseEra(1, new DateTime(1868, 9, 8), new DateTime(1912, 7, 30), "明治", "明", "Meiji", "M");
  JapaneseEraHelper.AddJapaneseEra(2, new DateTime(1912, 7, 31), new DateTime(1926, 12, 25), "大正", "大", "Taisho", "T");
  JapaneseEraHelper.AddJapaneseEra(3, new DateTime(1926, 12, 26), new DateTime(1989, 1, 8), "昭和", "昭", "Showa", "S");
  JapaneseEraHelper.AddJapaneseEra(4, new DateTime(1989, 1, 9), new DateTime(2015, 1, 1), "平成", "平", "Heisei", "H");
  JapaneseEraHelper.AddJapaneseEra(5, new DateTime(2015, 1, 2), new DateTime(2088, 1, 1), "新規", "新", "New", "N");

### New features

- C1TextBox.MaskInfo.RegexpEditMask - property to set edit mask in regexp style.
- JPN version only:
  Reading IME output:
  C1TextBox.ImeGetKanaMode
  C1TextBox.ImeSetKanaMode
  C1TextBox.ImeGetReadingStringOutput
  C1TextBox.ImeSetReadingStringOutput
  C1TextBox.ImeResultString
- Added new C1ColorPicker and C1FontPicker controls. Controls support VisualStyles and Theming.

## C1.Win.C1InputPanel

### Improvements

- Added the CueBanner property to InputTextBox and other like elements. It gets or sets the textual cue, or tip, to prompt the user for information.

## C1.Win.C1List

### Bug fixes

- Position of Scrollbars of C1List is changed when resized using C1SizerLight (TFS:122951).
- fixed excel export issue (TFS:119328)
- Unable to click checkbox in C1List when displaying Right to Left and displaying vertical scroll bars (TFS:119561).

## C1.Win.C1Report

### Bug fixes

- The "Report Parameters" dialog displayed with default parameter values when refreshing an SSRS report. (TFS:122743)
- SSRS reports could not be opened after canceling the 'Report parameters' dialog before viewing a report. (TFS:122729)
- Zoom value in C1PreviewPane changed to 100% when switching from "Print Layout" view. (TFS:120726)
- Preview pane of C1PrintPreviewControl appears distorted while SSRS report is generating RPL. (TFS:120670)
- An exception was thrown when a Form with C1PrintPreviewControl or C1PreviewPane displaying RPL content is minimized. (TFS:120151)

## C1.Win.C1Ribbon

### Bug fixes

- ObjectDisposedException was thrown when MessageBox is displayed in the LostFocus event of TextBox when RibbonApplicationMenu is clicked. (TFS:123376)
- 'Cross-thread operation not valid' exception occurred sometimes when opening a drop-down in a multi-threaded app. (TFS:123384)
- If a user adds both the ribbon menu, and one of the items from the menu dropdown to the QAT, then removes the ribbonMenu from the QAT, it removed the other item as well. (TFS:122117)
- Fixed a small misalignment issue in Ribbon Form caption for high DPI modes.
- Shortcut Keys did not work for items of the Ribbon Context Menu.
- Pressing the key of a KeyTip character immediately after pressing the Alt key broke KeyTips consisting of multiple characters. (TFS:119305)
- When Ribbon is minimized and RibbonTab is selected by keytip, which, in its turn, selects other RibbonTab in Select event, then KeyTips were displayed outside of the Form. (TFS:119308)
- Unlike MS Office, KeyTips of RibbonItems disappeared while holding down the Alt key and pressing KeyTip key, then releasing the Alt key. (TFS:119891)

### Improvements

- Added the HasBorder property to RibbonToolBar indicating whether the toolbar buttons should have borders for Office2007/Windows7 styles. (TFS:109897)
- Added the MinusClick and PlusClick events to RibbonTrackBar. They are fired when the user clicks the Minus or Plus buttons.
- Added the CueBanner property to RibbonTextBox and other like elements. It gets or sets the textual cue, or tip, to prompt the user for information.
- Added the TopToolBar property to C1Ribbon. It represents a toolbar beside the window system buttons.
- Added the BottomToolBar property to C1Ribbon. It represents a toolbar that appears below the Ribbon.
- Added the ContextMenuItems property to C1Ribbon. The new ShowContextMenu method displays the items at the specified screen position.
- The Application Menu can be displayed at the top left corner of C1RibbonForm when C1Ribbon.HideTabHeaderRow is set to True.

## C1.Win.C1Schedule

### Bug fixes

- allow to show more than 14 days in TimeLineView (http://our.componentone.com/groups/topic/workdays-in-timelineview).
- repaired C1Calendar's Ctrl+MouseWheel behavior. (TFS:121177).
- correctly propagate font size changes to hot styles at Theme.BaseFont property changes. (TFS:37095).
- scale all fonts in the C1Calendar and C1Schedule controls if Control.Font property has been changed at run-time. (TFS:37143).

### Other changes

- WinXP Visual Styles and some other stuff related to Office 2003 representation have been marked as obsolete. It will be removed in the some future release.
  This includes Office 2003 palettes, showing day statuses in the DayView mode as colored bars and appointment borders colored with busy status brush.
  This doesn't include Office 2003 WeekView style.

## C1.Win.C1Sizer

### Bug fixes

- C1SizerLight does not resize the Font of the controls when 'ResizeFont' property is set to True. (TFS:119174)

## C1.Win.C1SplitContainer

### Improvements

- Added the ShowCloseButton property and CloseButtonClick event to C1SplitterPanel. The developer can hide the panel when the user clicks the Close button.
- Added better support for DPI-aware applications.

## C1.Win.C1SuperTooltip

### Improvements

- Added new GetToolTip(ToolStripItem item) overload. (TFS:92866)

## C1.Win.C1Themes

### Bug fixes

- Now error message will be displayed if standard built-in themes can not be loaded for some reason, typically it occurs because application does not reference C1.C1Zip.X.dll.(TFS:118861)

## C1.Win.C1TouchToolKit

### Bug fixes

- Fixed AutoShowControl property behaviour for composite controls. (TFS:36948)
- Removed ZoomFont overrides from the C1ScheduleZoomPolicy and C1CalendarZoomPolicy policies. This functionality is implemented in the C1Schedule and C1Calendar controls. (TFS:37143)

## C1.Win.C1TrueDBGrid

### Bug fixes

- IC1EmbeddedEditor.GetValue method is never called when using a custom editor (TFS: 47368)
- In combobox by ValueItems, position of scroll box is incorrect when to open dropdown (TFS: 121357)
- When to set C1TrueDBGrid.EditActive property to True, C1TrueDBGrid.Change event is fired (TFS: 122351)
- RTL Column Headers revert to LTR when sorted. (TFS:120486)
- Error message is displayed on filtering a Column with 'Float' DataType using the FilterDropDown(TFS:120486)
- FilterDropDown menu of C1TrueDBGrid does not display all the items of the column when DataView property is set to Hierarchical and nodes are expanded (TFS:116460)
- When MarqueeStyle is FloatingEditor and EditMask is set, it cannot properly be inputted (TFS:117602)
- Several issues with 'Hierarchical' DataView of C1TrueDBGrid (TFS:117779)
- Fixed displaying aggregate values in subgroups (TFS:110146).
- "BeforeRowColChange" event is fired incorrectly in C1TrueDBGrid. (TFS:118449)

### Improvements

- Added "Footer" value for C1DataColumn.GroupInfo.Position, which allows to show the grouped text only in the Footer Row of the group (TFS:110146).
- Added "AggregatesText" property for C1DataColumn.GroupInfo, which allows to set the text data for the aggregates values in groups (like Totals, Average, etc.) (TFS:110146).

## C1ReportDesigner App

### Bug fixes

- Added alphabetically sort for BarCode types. (TFS:123205)
- Recently opened file names were cut off in C1Report Designer Application. (TFS:122759)

### Improvements

- Added keytips to the script editor window. (TFS:120893)
- Added intellisense to the script editor. (TFS:114007).
- Added split window mode to the script editor. (TFS:114216)
- New shortcut keys: F7 - show script editor, Shift+F5 - switch to design mode (from preview).
- Load default custom fields automatically. (TFS:114006)
- Removed the word "Field" from custom fields's names (i.e. "Chart Field" is now "Chart" etc.). (TFS:119474)

# Release version 4.0.20151.49 - May-26-2015

## C1.C1Pdf

### Bug fixes

- Image with transparent background is not drawn correctly in C1Pdf when it is saved as PDF. (TFS:116641)

## C1.C1Report

### Bug fixes

- In some cases Font substitution algrorithm (when UseOldSubstitutionAlgorithm == false) selects invalid fonts, this can occur when text contains control characters like '\n' and characters which are unsupported in selected font.(TFS:118974)
- ArgumentOutOfRange exception can occurs in some rare cases when report contains japan text.(TFS:117446)
- If PrintAtPageBottom == true for group footer then it reprinted on each page even if Repeat == false.(TFS:116949)

## C1.Win.C1Chart

### Bug fixes

- Corrected interactive zooming calculations so that zooming is possible along the Y or Y2 axes. (TFS:101728)
- Corrected interactive zooming with inverted axes and zoom action axis specification. (TFS:115076)
- Corrected interactive rotation of 2D charts with 3D effects with inverted axes and rotate axis specification.

### Improvements

- Improved the paint speed of axis Marker (ValueLabels) during dragging for Windows 8 and Windows 10 which do not process the .NET ControlPaint class efficiently. (TFS:117459)
- Improved handling of improper Axis state when the Max and Min properties are assigned values inappropriate relative to each other. Use of SetMinMax() is still recommended (TFS:116174)

## C1.Win.C1Chart3D

### Bug fixes

- Added workaround for sorting exception due to breaking changes introduced by .NET 4.5 and higher for sorting. (TFS:113735)

## C1.Win.C1Command

### Bug fixes

- Ellipsis was not displayed correctly on C1DockingTabPage Caption when there are many tabs. (TFS:106533)

## C1.Win.C1Document

### Bug fixes

- C1SSRSDocumentSource does not handle 'Multiselect' and 'Cascaded' parameters correctly.(TFS:110807)
- Is some cases C1SSRSDocumentSource processed datetime parameters incorrectly, this linked with invalid converting string to/from datetime.(TFS:118207)

### Improvements:

- Added C1SSRSDocumentSource.Language { get; set; } property. Gets or sets the language used in the SSRS session. The culture specified by this property affects User!Language report identifier. By default this property is null, which means that CultureInfo.CurrentUICulture will be used.

## C1.Win.C1DX

### Bug fixes

- It was impossible to use C1DX in a 32-bit application under Windows 10.
- Accessing disposed shadow pointers caused a weird exception when calling RenderTarget.EndDraw method.

## C1.Win.C1FlexGrid

### Bug fixes

- Inrerited control from C1FlexGrid was not always rendered properly. (TFS:115623)
- Clear method of C1FlexGrid was not clear some columns' properties. (TFS:118287)
- Custom dropdown editor doesn't open dropdown part when use ALT + DOWN shortcut. (TFS:116681)

## C1.Win.C1Input

### Bug fixes

- C1DateEdit threw an exception when invalid date is entered and the drop down button is clicked. (TFS:99583)
- Ellipsis on the Modal button of C1DropDownControl is shifted to the bottom edge of the Button (TFS:113377)

## C1.Win.C1List

### Bug fixes

- autosize C1List and C1Combo item, caption, column caption and column footer height according to the control font size if ItemHeight,
  CaptionHeight, ColumnCaptionHeight and ColumnFooterHeight properties values haven't been set explicitely at design-time or by custom code. (TFS:117248)
- Different position of drop down button in C1Combo when 'RightToLeft' is set for Form at run time and design time. (TFS:98020)

## C1.Win.C1Report

### Bug fixes

- NullReferenceException was thrown when a document being generated is interrupted and the document generation is initiated again. (TFS:115302)
- It was impossible to avoid regeneration of SSRS report after assigning already generated report to the C1PreviewPane.Document property. (TFS:114098)

## C1.Win.C1Ribbon

### Bug fixes

- Avoided a deadlock in C1RibbonForm that occurred in an application showing many C1RibbonForms from multiple threads. (TFS:114802)
- When the current C1RibbonForm is TopMost and there is an opened dropdown, clicking other TopMost form did not bring it on top in a multithreaded application. (TFS:116975)
- The title row of C1Ribbon control appeared in black when the owner C1RibbonForm contains C1Zoom control. (TFS:117249)

## C1.Win.C1TileControl

### Improvements

- Added the SlideIndex property to the Tile object. It returns the index of slide that is being displayed on tile.

## C1.Win.C1TouchToolKit

### Bug fixes

- Tab key needs to pressed twice in order to change the focus from a control if C1ApplicationZoom is used on Form. (TFS:118061)
- C1ZoomAttaching Event is fired multiple times when Message box is shown in C1ZoomAttaching event. (TFS:41669)

## C1.Win.C1TrueDBGrid

### Bug fixes

- "\S" is not printed as it is in the PageHeader when the C1TrueDBGrid is previewed (TFS:118623)
- Character typed in the FilterBar of a column gets cleared on applying customized filtering and setting AllowFilter to False. (TFS:116058)
- Error message is observed after filtering data that contain “Apostrophe” in it (TFS:21339).

# Release version 4.0.20151.46 - Apr-30-2015

## C1.C1Excel

### Bug fixes

- Line Color of Header and Footer image is not retained in output excel file when saving as OpenXML format. (TFS:116520)
- Header and Footer images disappear in output excel file [regression for 43]. (TFS:116260)
- When set neutral culture to CurrentUICulture property, error occurs on code for genarate C1XLBook object. (TFS:115908)
- Though set XLSheet.DefaultRowHeight, it is not applied to excel. (TFS:114648)

## C1.Win.C1Chart3D

### Bug fixes

- Corrected initialization issue where some Chart3D displays were causing an exception during the paint resulting in a failure to draw the results. (TFS:113735)

## C1.Win.C1Editor

### Improvements

- Added property C1Editor.AllowAdHocTags. If true, user can add custom tags on-the-fly, when loading document or in source mode. Those tags are rendered automatically (paragraph or inline), based on their position in document. Also, those tags can have any attributes.

## C1.Win.C1List

### Bug fixes

- restored C1Combo selection behavior at autocompleting (it should be the same regardless of input letter case). (TFS:115585)

## C1.Win.C1Report

### Bug fixes

- C1PreviewPane did not work correctly after setting a new value to the Document property while the control is in busy state. (TFS:115035)

## C1.Win.C1Ribbon

### Bug fixes

- Text in the textbox area of RibbonComboBox disappeared after opening dropdown if this element is located on the QAT and VisualStyle is not Custom. (TFS:116481)
- Alt and F10 keys did not work correctly while scrolling popup menus. (TFS:115912)
- Auto-scrolling observed in some dropdowns after pressing Alt or F10 keys while the dropdown contents is being scrolled. (TFS:116019)
- RibbonItems were not removed from QAT and HOT lists after calling the Dispose method for that item or its Tab or Group. (TFS:116062)
- Ribbon QAT appeared corrupted after resizing C1RibbonForm to minimal size, then restoring it to normal size. (TFS:112324)
- Unhandled ObjectDisposedException was thrown when the QatItemNames property is cleared while processing an event of an item from QAT. (TFS:114734)

## C1.Win.C1Schedule

### Bug fixes

- 'AppointmentChanged' event is not raised when an Appointment is dragged and dropped in the space between two users (TFS:116386).

## C1.Win.C1Sizer

### Bug fixes

- The behavior in designtime is slow when SplitterWidth property is set 0 and used "auto grid" feature. (TFS:114634)

## C1.Win.C1Themes

### Bug fixes

- Exception can occurs during initialization of C1.Win.C1Themes.X.dll when it is used from COM visible library.(TFS:114442)

## C1.Win.C1TileControl

### Bug fixes

- Incorrect layout occurred in right-to-left mode in a PanelElement with child elements stacked horizontally (as in AppsPanel sample).

## C1.Win.C1TrueDBGrid

### Bug fixes

- "System.FormatException" is thrown when 'null' is set in the filter of a DateTime column and the FilterDefinition is saved and loaded again. (TFS:113027)
- Inappropriate behaviour of 'BeforeRowColChange' event in C1TrueDBGrid. (TFS:113376)

## C1ReportDesigner App

### Bug fixes

- Main form of C1ReportDesigner.exe flickers during loading if it maximized.(TFS:116262)

# Release version 4.0.20151.43 - Apr-08-2015

## C1.C1Excel

### Bug fixes

- Request to provide the property similar to ‘Scale with document’ available under Header/Footer tab in PageSetup dialog in MSExcel. (TFS:39819)

### Improvements

- Added advanced header/footer properties for printing the sheet.

## C1.C1Report

### Bug fixes

- Single byte text isn't displayed when setting Japanese font "MS PMincho" [Japanese version] (TFS:112506)
- Text extends outside the field when exported to Pdf with system fonts [Japanese version] (TFS:78659)
- Export to Excel does not show Comma Separators in excel file when regional settings are set to Dutch (Belgium) [TrueDBGrid] (TFS:101241)
- Single byte text isn't displayed when setting Japanese font "MS PMincho" [Japanese version] (TFS:112506)
- Text extends outside the field when exported to Pdf with system fonts [Japanese version] (TFS:78659)
- Export to Excel does not show Comma Separators in excel file when regional settings are set to Dutch (Belgium) [TrueDBGrid] (TFS:101241)

## C1.Win.C1Chart3D

### Bug fixes

- Corrected some Contour shading calculations for Marching Squares contouring. (TFS:75870)

## C1.Win.C1Command

### Bug fixes

- Radial menu: if the form containing a radial menu had a parent form, the menu did not hide when the form was deactivated even if AutoHide was true. (TFS:83505)
- When theme of form which is added GcMdiTabControl is changed by C1ThemeController, exception occurred. (TFS:107902)
- When narrowing width of C1DockingTab having multiple C1DockingTabPage, tab text displayed out of drawing area. (TFS:111703)
- Exception occurred when the layout of the C1DockingTab is restored. (TFS:97405)

## C1.Win.C1FlexGrid

### Bug fixes

- All expanded/collapsed nodes become collapsed/expanded when mouse click was performed under FlexGrid. (TFS:99994)
- When property AllowAddNew is set true and property SelectionMode is set to ListBox, new added row was become selected. (TFS:110067)

## C1.Win.C1GanttView

### Bug fixes

- When more than 1000 tasks were added to C1GanttView using BeginUpdate/EndUpdate methods, then performance issue is observed and it takes lot of time to add tasks in C1GanttView. (TFS:88027)
- Sorting checkbox remained checked in the Sort drop-down menu after LoadXml command. (TFS:106434)

## C1.Win.C1Input

### Bug fixes

- 'UpdateBoldedDates' method no longer exists in C1DateEdit's Calendar object. (TFS:109923)
  Note: UpdateBoldedDates is obsolete now as no need to use this method.

### Improvements

- Enhancements in C1DateEdit drop down layout if TitleFont is changed to a bigger font. (TFS:76700)

## C1.Win.C1InputPanel

### Bug fixes

- Click event of the InputButton fired even if the mouse button released outside the button element. (TFS:113032)

## C1.Win.C1Report

### Bug fixes

- All toolbar buttons in C1PrintPreviewControl stopped working after setting the RightToLeft property to 'Yes'. (TFS:114473)
- Visual Studio stopped working when delete the C1PreviewTextSearchPanel control from the form. (TFS:114441)

## C1.Win.C1Ribbon

### Bug fixes

- Memory was not released after closing C1RibbonForm if the user clicked a button in RibbonMenu or other drop-down. (TFS:114140)

## C1.Win.C1Schedule

### Bug fixes

- Appointments with zero duration are not shown (TFS:114180).

## C1.Win.C1Themes

### Bug fixes

- Context menu of theme tree is not localized in japan version.(TFS:78949)
- Extra blank space added in the font editor dropdown list for Cambria Math font. (TFS:44125)
- Dotted border around selected property of the theme tree drawn incorrectly in some cases when theme tree has horizontal scrollbar. (TFS:61682)

## C1.Win.C1TileControl

### Bug fixes

- After some manipulations with input focus the focused tile became invisible. (TFS:114744)
- Threading exception occurred sometimes in C1TileControl when it is used in a multithreaded application. (TFS:112664)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Filtering did not work on a column with DataType set to DateTime and NumerFormat set to any format. (TFS:114259)
- When selecting cell in which long text than width of cell is set, there were cases where the displayed position of text is different. (TFS:109557)
- Displayed value appears in the excel file on exporting the grid to excel even if the 'Translate' property of ValueItems of C1TrueDBGrid is set to 'False'. (TFS:90838)

## C1ReportDesigner App

### Bug fixes

- State of application main form is not saved in config file when application closed using Exit button of the application menu.(TFS:114166)
- Content of VBScript Editor window was not updated when the selected field was changed in the editor's "Field:" combobox. (TFS:113601)

# Release version 4.0.20151.38 - Mar-13-2015

## C1.Win.C1Ribbon

### Bug fixes

- It was impossible to localize GrapeCity build with languages other than English. (TFS:111515)

## C1ReportDesigner App

### Bug fixes

- Added missing Japanese translations, corrected spelling mistake in the designer UI. (TFS:112416)

# Release version 4.0.20151.37 - Mar-10-2015

## C1.C1Excel

### Bug fixes

- When loading in FlexGrid .xlsx including carriage return code, it is displayed as character of "_x000D_". (TFS:110119)
- When set a style to cell, and then save .xls file, Category of Format Cells is set as ";;". (TFS:110398)

## C1.C1Report

### Bug fixes

- Blank Page is added after 1st Page in output file, while exporting the report to .rtf by using RanderToFile(). Next step. (TFS:67653)
- Crystal Report import: Fields with GroupName({Name}) expression imported incorrectly. (TFS:110603)
- Partly fixed when ParseEmfPlus property is set true and is exported to pdf, shape isn't drawn correctly. (TFS:109670)
- Blank Page is added after 1st Page in output file, while exporting the report to .rtf by using RenderToFile(). (TFS:67653)
- Incorrect format of value at currency format (Export To Excel Formatting Issue). (TFS:35363)
- Last Word of LinkTargetAnchor Text are leaked out while exporting to DOCX file [not regression]. (TFS:83728)
- GridLine of Table are lost in .rtf Export [Regression caused by fix for 72799]. (TFS:86511)
- Superscript/Subscript is concatenated with"u126?" in exported [Regression caused by fix for 93183]. (TFS:106640)
- Import from Crystal Report: fixed SQL query conversion for linked tables.
- Import from Crystal Report: fixed SQL query conversion for sort fields.
- Partly fixed when ParseEmfPlus property is set true and is exported to pdf, shape isn't drawn correctly. (TFS:109670)

### Improvements

- Added 2 new bult-in script functions, Like and In, with functionality similar to SQL operators LIKE and IN:
  Like(str, template) - compares 'str' to 'template', which can contain wildcard '%', returns True or False.
  In(obj, obj1, ... objN) - tests whether 'obj' is among objects 'obj1' - 'objN', returns True or False.
  Both functions are case-sensitive, so "abc" is not the same as "Abc".
  Some examples:
  Like("abc", "%bc") returns True.
  Like("abc", "%bcd") returns False.
  Like("abc", "ab%") returns True.
  Like("abc", "abd%") returns False.
  Like("abc", "%b%") returns True.
  Like("abc", "%d%") returns False.
  Like("abc", "abc") returns True.
  Like("abc", "abcd") returns False.
  Like("Abc", "abc") returns False.
  In(1,1,2,3) returns True
  In(1,2,3) returns False
  In("a", "a", "b", "c") returns True
  In("a", "b", "c") returns False
  In("A", "a", "b", "c") returns False
- Added new property on C1Report:
  string GlobalScripts {get;set;}
  This property allows to specify a global script module, in which functions and subroutines can be defined using the standard VBScript syntax. Those functions and subroutines can then be called from other scripts within the report like standard VBScript functions/subroutines.
  Additionally, local functions and subroutines can be defined in script event handlers (such as OnOpen), and can be called from within the statement in which they are defined.
- Import from Crystal Report: fixed conversion of the datasource path (internal or external) to C1Report.
- Import from Crystal Report: added conversion of Crystal Report's time format to Format property of the calculated field.
- Import from Crystal Report: added conversion of Crystal Report's Percentage Aggregate.
- Import from Crystal Report: added conversion of Crystal Report's date, time and number formats to Format property of the calculated field.
- Import from Crystal Report: improved TextObject conversion by implementing RAS API.

## C1.Win.C1Chart

### Improvements

- Added MovingNumericValue and MovingDateTimeValue properties and the ValueChanging event to the ValueLabel object. (TFS:97401, TFS:97558)
  /// <summary>
  /// Gets the new ValueLabel Numeric value of a moving ValueLabel during a drag operation.
  /// <remarks>
  /// This value differs from the NumericValue property only while the ValueLabel is being
  /// dragged by the mouse making it most useful in the ValueLabel.ValueChanging event.
  /// </remarks>
  /// </summary>
  public double MovingNumericValue
  /// <summary>
  /// Gets the new ValueLabel DateTimeValue of a moving ValueLabel during a drag operation.
  /// <remarks>
  /// This value differs from the DateTimeValue property only while the ValueLabel is being
  /// dragged by the mouse making it is most useful in the ValueLabel.ValueChanging event.
  /// </remarks>
  /// </summary>
  public DateTime MovingDateTimeValue
  /// <summary>
  /// Fires when position of ValueLabel is changing due to the dragging a Movable ValueLabel.
  /// </summary>
  public event EventHandler ValueChanging;

## C1.Win.C1Command

### Bug fixes

- The floating toolbar of submenuItem is shown behind the submenuitem list at design time. (TFS:110241)
- Japanese localization issue. (TFS:108851)
- TabPage inserted in the C1DockingTab slides out and gets hidden when 'AutoHiding' is true.(TFS:97545)
- "NullReferenceException" is thrown when mouse is hovered on C1Toolbar in WPF application. (TFS:108973)

### Improvements

- When a theme is set to a C1CommandMenu the given theme is also applied to the all submenus of the C1CommandMenu.

## C1.Win.C1Document

### Breaking Changes:

- Class C1FindPosition was renamed to C1FoundPosition.
- Removed C1DocumentSource.FindScope property.
- Changed parameters for FindTextStart(...) method.
  Added bool wholeDocument parameter:
  Indicates whether whole document should be loaded during searching or to the first fragment found.
- Changed parameters for FindTextNext(...), FindTextPrevious(...) methods
  Now C1FoundPosition object should be passed as parameter
  defines the position from which the search should be started.

### Bug fixes

- Now borders with styles: Dot, DashDot, DashDotDot rendered correctly. (TFS:110807)
- Sorting is not working in C1SSRSDocumentSource in some scenarios. (TFS:110808)

### Improvements:

- Added C1DocumentSource.GetContextLocation() method. Returns C1DocumentLocation
  object defining current context of the C1DocumentSource this C1DocumentLocation
  can be used to restore state of the C1DocumentSource. For example, C1DocumentSource
  restores applied sorting, drillthrough actions etc.
- Now C1Document can render RPL content on Windows 7/8.0, not just Windows 8.1.
- Added IList<C1FoundPosition> C1DocumentSource.FoundPositions { get; } property
  Gets the list of C1FoundPosition objects representing result of the current search.
- C1FoundPositoon ActiveFoundPosition { get; set; }
  Gets or sets the active found position which is highlighted.

## C1.Win.C1FlexGrid

### Bug fixes

- UseCompatibleTextRendering property of C1FlexGrid was reset to True when C1Theme is applied to it. (TFS:107381)
- Last character was missing in ScrollTip when it contains only 4-character word. (TFS:95157)
- Dotted border lines were drawn not correct after scrolling of C1FlexGrid. (TFS:110725)
- Cell Label is shown in C1FlexGrid in some cases where it shouldn't. (TFS:102289)
- When e.Cancel set to true in BeforeSelChange event, BeforeSelChange occurs two times. (TFS:109484)
- When CellStyle of cells of C1FlexGrid are assigned using the 'SetCellStyle' method in the BeforeEdit event of the grid, the controls placed outside the grid were not rendered properly. (TFS:97604)

## C1.Win.C1GanttView

### Bug fixes

- Some strings in toolbar and settings dialog of Japanese GenttView version were displayed in Chinese (TFS:110857)
- MoveTaskUp and MoveTaskDown toolbar buttons were not disabled while applying Grouping to C1GanttView and caused NullReferenceException on pressing. (TFS:110508)
- While setting of Custom property column as BarText (e.g 'Left:' BarText ) of the specific tasks of C1GanttView at run time through BarStyle Dialog, the applied BarText was not appeared beside the Task Bar sample. (TFS:110588)
- ProjectSummaryTask did disappear if apply Filter that filters off ProjectSummaryTask and clear Filter. (TFS:79616)
- PredecessorTaskID was not updated when ID of predecessor task was updated at run time. (TFS:101904)
- Order of child tasks was swapped when summary task with two or more child tasks was moved from its current position. (TFS:101662)

### Improvements

- Added BeforeAddTsk, BeforeRemoveTask, BeforeEditTask, AfterEditTask events to C1GanttView in order to have the opportunity to cancel changes in Task. (TFS:90078)
  /// Fires before a new task is added by the user.
  public event CancelTaskEventHandler BeforeAddTask;
  /// Fires before a task is removed by the user.
  public event CancelTaskEventHandler BeforeRemoveTask;
  /// Fires before the user has edited the task.
  public event CancelTaskEventHandler BeforeEditTask;
  /// Fires after the user has edited the task.
  public event CancelTaskEventHandler AfterEditTask;

## C1.Win.C1Input

### Bug fixes

- Press color of upper/lower thumb was not changed if 'Office2007Silver' visualstyle was set. (TFS:110636)
- RangeSlider was not diplayed when it was added with paste operation. (TFS:110610)
- Toolbox icon of C1RangeSlider control is not correct. (TFS:110560)
- Themed C1CheckBox was look not correctly in Win 8.1. Note. Applying theme to C1CheckBox sets FlatStyle to Flat. This is by design.
- Themed disabled background color did not apply to C1TextBox.

### New features

- Added new C1RangeSlider control. It creates slider with 2 thumbs for the range selection. Control can be oriented Horizontally or Vertically, supports VisualStyles and Theming.

## C1.Win.C1InputPanel

### Bug fixes

- The mouse wheel events were not marked as Handled by InputComboBox and were sometimes processed by other controls as well.
- In case of using HTML tags in ToolTips word wrapping did not work correctly, for example, a new line could start with comma after </b> tag.
- When an InputMenu contains many items and the user clicks on it the drop-down showed and hid immediately.

### Improvements

- In the tooltip editor <br> shouldn't be added at the end of line when the user presses the Enter key if the last tag in the line was </p>.

## C1.Win.C1Report

### Bug fixes

- Moving back to parent report in RPL mode did not show expanded view of the report. (TFS:110761)
- A different set of assemblies added to project References when the user adds C1PrintPreviewControl to a form before adding C1SSRSDocumentSource or vice versa. (TFS:109832)
- Typing "100%" to zoom text box and pressing the Enter key caused a WinPreviewException in paginated mode.
- Setting C1PreviewPane.ZoomMode property had no effect for C1SSRSDocumentSource in non-paginated mode while the report is not yet generated.

### Improvements

- Added new set of icons to C1PrintPreviewControl: "Flat".
- Added SsrsPaginated boolean property to C1PrintPreviewControl and C1PreviewPane. When it is set to False (by default) and C1SSRSDocumentSource is assigned to C1PrintPreviewControl.Document, the control shows RPL content with various interactive features (.NET 4.0 version only).
- Added TextSearchUIStyle property to C1PrintPreviewControl to specify whether the old C1PreviewTextSearchPanel or the new search toolbar should be used for text search.

## C1.Win.C1Ribbon

### Bug fixes

- Title text of C1RibbonForm overlapped window buttons when resizing form to minimal size. (TFS:111591)
- Appearance of C1RibbonForm's border was incorrect when a form with Custom VisualStyle is displayed as not top level control. (TFS:110863)
- HandleCreated event of a Form that is added to C1RibbonForm by AddOwnedForm method occurred at incorrect timing. (TFS:110858)
- Removed unnecessary redrawing of C1RibbonForm with Custom VisualStyle when the mouse pointer enters/leaves Minimize/Maximize/Close window buttons.
- When the VisualStyle property of a C1RibbonForm is changed from Custom to any Office styles within the Form.Load event, the Form displayed incorrectly. (TFS:110386)
- When the user presses shortcut keys beginning with the Alt key, KeyTips popped up after processing the shortcut.
- When a modal window is shown from RibbonToggleButton.Click event handler, the button stayed in pressed state until the user closes the modal window.
- The standard (thick) form borders were shown for a C1RibbonForm with 'Custom' VisualStyle when the user switches to/from the application.
- When C1RibbonForm.VisualStyle is changed from Office2010Blue to Custom within the Form.Load event handler that caused incorrect form appearance.
- When cloning items and groups to invisible RibbonTabs they did not appear sometimes on visible tabs.
- When a large image is assigned to RibbonTab.Image property it was cropped instead of scaling to the standard size (16x16 for 96 DPI screen). (TFS:108802)
- In case of using HTML tags in ToolTips word wrapping did not work correctly, for example, a new line could start with comma after </b> tag.

### Improvements

- Added SuspendPainting/ResumePainting methods to C1RibbonForm to prevent repainting the Form and its children while applying massive changes.
- In the tooltip editor <br> shouldn't be added at the end of line when the user presses the Enter key if the last tag in the line was </p>.

## C1.Win.C1Schedule

### Bug fixes

- Recurring events are off by an hour when imported from iCal (.ics) file (TFS:108347).

## C1.Win.C1SpellChecker

### Bug fixes

- Obfuscation issue in C1SpellChecker (TFS:110452)

## C1.Win.C1Ssrs

### Breaking changes

- C1.Win.C1Ssrs.4.dll was renamed to C1.Win.ImportServices.4.dll
  C1.Win.C1Ssrs.4.5.dll was renamed to C1.Win.ImportServices.4.5.dll

## C1.Win.C1SuperTooltip

### Bug fixes

- In case of using HTML tags in ToolTips word wrapping did not work correctly, for example, a new line could start with comma after </b> tag.

### Improvements

- In the tooltip editor <br> shouldn't be added at the end of line when the user presses the Enter key if the last tag in the line was </p>.

## C1.Win.C1Themes

### Breaking changes

- Office2013Grey theme renamed to Office2013Gray.
- Added new compressed format to persist C1Theme files - .c1themez, this format uses much less space than *.c1theme. A .c1themez file is simply a zipped up .c1theme file.
  Note that C1.Win.C1Themes.2/4.dll now requires C1.C1Zip.2/4.dll, so existing projects using themes need to have a reference to C1Zip added.

### Bug fixes

- The initialization code of C1ThemeController was optimized, so now forms containing the C1ThemeController loaded faster.(TFS:108317)

### Improvements

- Theme files updated, several minor issues fixed.

## C1.Win.C1TileControl

### Bug fixes

- The AllowDrop property was hidden by mistake in C1TileControl. (TFS:109232)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Processing performance of DisplayColumn.AutoSize method was slow. (TFS:111210)
- All checkboxes were not checked in the filter dropdown when choose "SelectAll" checkbox for "Radio Button" Column. (TFS:105489)
- Filtering did not work on a column with DateTime DataType in some conditions. (TFS:95622)

## C1.Win.Olap

### Improvements

- Added support for Sql Server Analysis Services (see C1OlapPanel.ConnectCube method).
- Added async processing for data update (see C1OlapEngine CancelUpdate method and UpdateCompleted and UpdateProgressChanged events).

## C1ReportDesigner App

### Bug fixes

- C1ReportDesigner app: In style browser/editor form, the property grid showing built-in styles was disabled, which made it impossible to inspect the style. Now the grid shows built-in styles as read-only, but the grid is enabled, and all nodes can be expanded. (TFS:110337)

### Improvements

- Added keytips to report designer ribbon UI. (TFS:110765)
- C1ReportDesigner app: added persisting size and position for the style editor form.
- C1ReportDesigner app: added syntax highlighting and menu support for the new built-in C1Report functions Like() and In().
- C1ReportDesigner app: added go back/forward navigation to the script editor window.
- C1dView: use VS2013Light theme, new icons.
- C1ReportDesigner app: custom fields are now loaded into a separate ribbon group, wiht more detailed tooltips and 32x32 icons.
- New VBScript Editor with a new UI. The new editor allows to switch between statements and expressions, so multiple scripts can be edited without leaving the editor. The editor now can be invoked directly via a button on the main window's ribbon.
- Misc UI improvements (new icons, new ribbon layout, etc.).
- Added support of RAS API when importing from Crystal Reports (improves import of text fields).

## C1Themes Designer App

### Improvements

- Added key tips to designer ribbon items.
- Updated the app's icons for a cleaner look.
- Updated the app's about box.
- Default desginer theme changed to VS2013Light.

# Release version 4.0.20143.23 - Feb-02-2015

## C1.C1Excel

### Bug fixes

- Unlike build 21,C1Excel can’t be shown original name of sheet in output xlsx/xls. (TFS:106325)
- Unlike previous build, Back color of Sheet Tabs in output .xlsx/.xls are 'Black'. (TFS:101917)
- The foreground colour is corrupted. (TFS:105738)
- BackColor of all cells change to black when data from excel sheet are loaded to C1FlexGrid. (TFS:101050)
- Deleteing Column that includes final cell in a merge does not reduce merge. Fixed part 2. (TFS:90131)

## C1.C1Pdf

### Bug fixes

- Color of emf image is dim after exporting to pdf file using DrawImage(). (TFS:100937)
- Rendering of Barcode is overlapped on its text while exporting to .pdf (C1Report, JPN, regression). (TFS:98507)

### Improvements

- Added MaxHeaderBookmarkLevel property to control output of bookmarks when rendering HTML
- Added StartCollapsed property to start outlines in collapsed state

## C1.C1Report

### Bug fixes

- Last Word of LinkTargetAnchor Text are leaked out while exporting to DOCX file [not regression]. (TFS:83728)
- GridLine of Table are lost in .rtf Export [Regression caused by fix for 72799]. (TFS:86511)
- Superscript/Subscript is concatenated with"u126?" in exported [Regression caused by fix for 93183]. (TFS:106640)
- Blank Page is added after 1st Page in output file, while exporting the report to .rtf by using RenderToFile(). (TFS:67653)
- Incorrect format of value at currency format (Export To Excel Formatting Issue). (TFS:35363)
- C1Report.MaxPages property is reset to 4 when report loaded at designtime. Bug occurs only if an exception occurs when report preview rendered at designtime (not available database, etc). (TFS:102290)
- Text extends outside the field when exported to Pdf with system fonts. Only for Japanese version, part 4. (TFS:78659)
- Rendering of Barcode is overlapped on it's text while exporting to .pdf (C1Report, JPN, regression). (TFS:98507)

## C1.Win.C1Command

### Bug fixes

- Argument exception was thrown when Tab Page of one C1DockingTab is tried to be dragged. (TFS:97453)
- Argument exception was thrown, when saved layout of C1DockingTab is restored. (TFS:97432)
- C1DockingTab is shown as blank space when docking at original position once changed. (TFS:99788)
- [C1MainMenu and C1Zoom] focus was changing when switching between menu items with C1Zoom added. (TFS:90303)

## C1.Win.C1Document

### Bug fixes

- Added toolbox icon for C1SSRSDocumentSource (.NET 4.0 version only). (TFS:98390)

## C1.Win.C1FlexGrid

### Bug fixes

- Selection methods and properties did not always work correctly when called recursively. (TFS:94508,107040)
- ValidateEdit event was not fired when data was pasted from Clipboard. (TFS:107100)
- Extra space character was added to text of cell in Excel in some cases when tree view was exported. (TFS:107941)
- When C1FlexGrid that displayed many images was quickly scrolled many times by touch operations, an exception occurred. (TFS:105732)
- Shift key was not recognized in some cases when using Interop.Edit control of InputMan. (TFS:91926)
- When setting data from another thread exception "System.ArgumentOutOfRange" occurred. (TFS:95571)

## C1.Win.C1GanttView

### Bug fixes

- ArgumentOutOfRangeException occured in C1GanttView if invalid ZoomFactor value was set at runtime. (TFS:83099)
- Unhandled exception was occurred when move down the project summary task. Fixed for the context menu. (TFS:99851)
- Unhandled ArgumentOutOfRangeException raised with hidden chart pane on print preview operation. (TFS:83618)
- Improved performance of adding multiple new rows without BeginUpdate - EndUpdate. (TFS:74002)
- Digit incremental of FilterName was inconsistent in "More Filters" Dialog. (TFS:78997)
- Digit incremental of Name was inconsistent in Resources/WorkWeek/Exceptions collection after adding entry. (TFS:79138)
- ArgumentOutOfRangeException was thrown when SummaryTask is added in an empty C1GanttView. (TFS:101548)
- Unhandled exception was occurred when move down the project summary task. Fixed for the buttons in the tool strip. (TFS:99851)
- PropertyGrid of C1GanttView.Tasks Collection Editor was blank when CustomFieldColumn without Caption was added at DesignTime. (TFS:82482)
- Low performanse was observed when more than 1000 tasks were added to C1GanttView using BeginUpdate/EndUpdate methods. (TFS:88027)
- Low performanse was observed when more than 1000 tasks were loaded from xml file. (TFS:94217)
- Performance delay was observed in the build of C1GanttView : 4.0.20142.211 (and 193) as compared to the earlier build 151. (TFS:74002)

## C1.Win.C1Input

### Bug fixes

- Build gets failed when any C1Input control is placed on the Form and application is built in VB. (TFS:96681)
- VisualStyle was not set to 'System' once any other 'VisualStyle' is set for C1Button. (TFS:100158)

## C1.Win.C1InputPanel

### Bug fixes

- The InputComponent.Tag property can now be saved/loaded to/from XML if it contains a string value.
- InputComboBox and other like elements made the beep sound when the user presses the Enter or Escape keys.
- ToolTip Editor did not preview changes to the ToolTipSettings.MaximumWidth property at design-time.

## C1.Win.C1List

### Improvements

- added C1Combo.MatchCompare property. It allows to search by string inside string or by other conditions (TFS:101739).
  Note, for values other than MatchCompareEnum.Equal and MatchCompareEnum.PartiallyEqual, it worth turning off AutoCompletion property:
  c1Combo1.MatchCompare = MatchCompareEnum.IncludeEqual;
  c1Combo1.AutoCompletion = false;
  In this case Text property is not updated by found item until end-user confirms selection either by click on selected item, or by pressing Enter key.

## C1.Win.C1Ribbon

### Bug fixes

- When the user moves C1RibbonForm by clicking in C1Ribbon's tab area and dragging the mouse pointer, the window snap feature did not work. (TFS:106059)
- When an item of disabled RibbonGroup is added/deleted to/from QAT multiple times, it became enabled on QAT. (TFS:106224)
- When C1Ribbon.Minimized property is set to True, and the program adds/removes QAT items in RibbonTab.Select event Ribbon Tab did not open when it is clicked. (TFS:106891)
- Setting the Pressed property of a RibbonSplitButton to True had no effect until the ToggleOnClick property is set to True as well.
- When the Enabled property of the RibbonButtons added to different RibbonGroups is toggled, the buttons got highlighted. (TFS:101932)
- Dropdown list of RibbonComboBox was not shown after changing its owner's Visible to False, setting SelectedIndex property to some value, then changing the owner's Visible to True. (TFS:101559,105866)
- When a modal form is shown from RibbonButton.Click event, after the form is closed, the RibbonButton remained in 'hot' (mouse over) state for Custom VisuaStyle. (TFS:105907)
- A small image assigned to RibbonGalleryItem.LargeImage property always scaled to the standard size (32x32). Now it is possible to use an image of any small size without distortion.
- The Tag property of RibbonItem, RibbonGroup, RibbonTab can now be saved/loaded to/from XML if it contains a string value.
- RibbonTextBox and RibbonComboBox made the beep sound each time when the user presses the Enter or Escape keys.
- ToolTip Editor did not preview changes to the ToolTipSettings.MaximumWidth property at design-time.

### Improvements

- Added the Selected property to RibbonGalleryItem. The property gets or sets whether the item is currently selected in the owner RibbonGallery.

## C1.Win.C1Sizer

### Bug fixes

- In C1SizerLight, VScrollBar/HScrollBar control which Visible property is set false can't be resized. (TFS:106852)
- Honor ambient fonts at resizing (TFS:97777, TFS:97778)

## C1.Win.C1TileControl

### Improvements

- Added support for right-to-left layout to C1TileControl.

## C1.Win.C1TouchToolKit

### Bug fixes

- [99855] C1ApplicationZoom Causes Forms to Zoom Slightly on Load. (TFS:100352)

## C1.Win.C1TrueDBGrid

### Bug fixes

- When binding the Ms-DataSet, Data was not shown in C1TrueDBGrid. (TFS:97988)
- Split was removed if the MinHeight property of the split is set and Split divider is moved to the bottom of the grid. (TFS:101651)
- 'NullReferenceException' thrown when 'PageHeader' or 'PageFooter' property of PrintInfo class was set to 'Nothing' in C1TrueDBGrid. (TFS:100198)
- RowColChangeEventArgs.LastCol did not return correct value in DesignTime data bound C1TrueDBGrid. (TFS:97980)
- Single item is not filtered when ValueItem Collection is applied on a Column. (TFS:94801)

## C1Report Apps (C1ReportDesigner, C1ReportsScheduler, C1dView)

### Bug fixes

- C1dView: Exception occurs when user opens the application menu second time
  after opening c1d file. (TFS:77580)

# Release version 4.0.20143.18 - Dec-18-2014

## C1.C1Excel

### Bug fixes

- C1XLBook.Save performance is decreased in build 14 compare to build 11. (TFS:98333)
- Cell's Border Color is changed when saving excel file. (TFS:84854)
- ArgumentException is thrown when an Excel file is loaded in C1XLBook [Fixed only exception]. (TFS:97861)
- Exception (can't access cross-thread) thrown when loading Excel in a child thread. [SL] (TFS:98145)
- #VALUE! is shown in the cell which has ROUNDDOWN formula as Biff8 format. (TFS:85358)
- Text size gets changes and warning is thrown when a file created in Excel 2003 with formatted text is loaded and saved using C1XLBook and opens in Excel 2010. Fixed for BIFF8 and OpenXML formats. (TFS:96744)
- External sheet hyperlink did not work when the sheet's name contained a space and the sheet was saved with .xlsx extension. (TFS:75800)

## C1.C1Pdf

### Bug fixes

- Text extends outside the field when exported to Pdf with system fonts. Only for Japanese version, part 3. (TFS:78659)
- C1Pdf did not export semi transparent polygons correctly (fixed only for EMF+ mode). (TFS:76526)
- When exporting to a PDF-file, rendered Region clips after 2 inches vertically (fixed only for EMF+ mode). (TFS:93490)

### Improvements

- Added flag UniqueFontsPerPage for pages with various fonts.
- Added support translucency using graphics state.

## C1.C1Report

### Bug fixes

- Text extends outside the field when exported to Pdf with system fonts. Only for Japanese version, part 3. (TFS:78659)
- External sheet hyperlink did not work when the sheet's name contained a space and the sheet was saved with .xlsx extension. (TFS:75800)
- Exception with invalid message occurs when invalid filtering/sorting expression specified for the C1Report data source. (TFS:97548)

### Improvements

- Added AutoPaperSize property for printing C1PrintDocument with the Custom PageSize as defined in code. (TFS:93209)

## C1.Win.C1BarCode

### Improvements

- Added support for GS1-128 barcode.

## C1.Win.C1Chart

### Bug fixes

- Applying a C1Theme to a C1Chart failed with a theme version mismatch warning (.NET 2.0 version only). (TFS:96968)

## C1.Win.C1Editor

### Bug fixes

- Layout of the table distorts when a table is copied from MS Word and pasted in C1Editor containing formatted text (TFS:95524)
- vshost32.exe stop working and Win32Exception shown when cancelling the "Save Print Output" dialog. (TFS:94258)
- Changing Size of flash file is not effected in "Preview" mode". (TFS:94347)

### Translation

- Tooltip of C1EditorToolStripReview items are not localized on Chinese OS. (TFS:79643)

## C1.Win.C1FlexGrid

### Bug fixes

- When using InputMan for WinForms control as editor it wasn't capturing first keystroke correctly when typing very fast. (TFS:93001)
- When several rows are fixed and merged and filtering is enabled the filter button is not shown when hovering the top rows of the merged column header. (TFS:92218)
- When using values in scientific notation AggregateEnum property was not working properly. (TFS:94071)
- When using values in scientific notation exception "Not a Number" occurred. (TFS:95022)
- When the C1FlexGrid is in bound mode and the active row is not the first row, using the Select(Row, Col, RowSel, ColSel) method to select whole grid selects only the first row. (TFS:94508)
- When the ShowCellLabels property of C1FlexGrid is set to true and C1FlexGrid hasn't focus, cell labels are not displayed when hovering the mouse over cells with partially hidden content. (TFS:94805)

### Improvements

- Added Outline property to FileFlags enumeration to support export C1FlexGrid nodes as Excel groups when exporting to Excel. (TFS:95604)

## C1.Win.C1GanttView

### Bug fixes

- Undo Action was not restored to original zoom state while it's called after reseting the Zoom Value. (TFS:82394)
- Undo Action did not work for TaskMode column value. (TFS:83861)
- ZoomFactorChanged event fired thrice while Redo action called after Undo action of resetting zoom of GanttView. (TFS:82398)
- CustomFiled Name was not shown in SortBy dropdown of Sort Dialog, while Tasks are sorted explicitly by using CustomTaskPropertyDescriptor. (TFS:83507)
- Predecessor Links were distroted while applying custom GroupFont at RunTime. (TFS:83957)
- System.OverflowException occurred while adding of resource to the tasks which CustomColumn Field is calcualted by using ListChanged Event. (TFS:82568)
- It was possible to open TimeScale Dialog through Context Menu in ReadOnly mode of GanttView. (TFS:82495)

### Improvements

- Added the SetColumnError() method to the Task object. It sets the error message displayed for a specific column of the task. (TFS:90245)

## C1.Win.C1Input

### Bug fixes

- NullReference exception occurred while opening the dropdown of C1DateEdit/C1NumericEdit/C1ComboBox in Modal Dialog. (TFS:96922)
- C1TextBox.NegativeForeColor does not work as expected. (TFS:96592)
- Focus does not move to next line in 'MultiLine = true' C1TextBox while CharCategory property is applied. (TFS:95470)
- 'C1DateEdit.Calendar.CaptionFormat' does not change the caption's format. (TFS:92280)
  Remarks: Caption format can contain special symbols:
  yyyy or yy - years
  M or MM or MMMM - month
  gg - era
  g. - the era name in alphabet (M, T, S, H). Japanese only.
  g - the first character (DBCS) era. Japanese only.

## C1.Win.C1InputPanel

### Bug fixes

- Unlike MS ComboBox and ToolStrip elements, drop-down portion of input components, such as InputComboBox or InputMenu, did not open after setting Enabled=false and DroppedDown=true. (TFS:97504)
- When the drop down of InputComboBox is displayed the ampersands in the items text were converted to underscores.

### Improvements

- InputComboBox now uses the specialized collection of items with the following new methods: AddText, InsertText, RemoveText, ContainsText, IndexOfText.

## C1.Win.C1Ribbon

### Bug fixes

- Ribbon tooltips don't use the DateTime.Now property anymore. It might cause an ArgumentOutOfRangeException (see http://our.componentone.com/groups/topic/c1-framework-system-argumentoutofrangeexception/).
- The main application form based on C1RibbonForm with VisualStyle set to 'Custom' appeared in minimized state and without glow form borders on the program startup (in VB only).
- An ampersand displayed as underline in RibbonLabel which is an item of drop-down menu if VisualStyle is not equal to Custom. (TFS:97107)
- Ampersands were not displayed for items of C1StatusBar when the user presses the Alt key and VisualStyle is set to Custom.
- Small Images applied to the items of Application Menu were scaled to Large Images and got blurred. (TFS:97288)
- C1RibbonForm with Custom VisualStyle displayed with ShowDialog() method (without the 'owner' parameter) closed immediately.
- Hot state of a RibbonSplitButton was not retained after clicking the button. (TFS:94198)
- Tapping Form's Maximize button with touch or pen device minimized C1RibbonForm if there is a C1StatusBar control on it and there is no C1Ribbon control.
- When the application contains a Tab Group and form size is reduced to the minimum, some Qat items were not displayed in the drop down menu when the 'Show more controls' button is pressed. (TFS:94556)
- RibbonButton added to QAT was not disabled when the Enabled property of the Tab containing it is set to False. (TFS:94557)
- A notification about NullReferenceException added to the Debug Output window when the program tries to display drop-down portion of an element which is currently hidden. (TFS:94631)
- The ChangeCommitted event of RibbonComboBox did not fire when we select an item from the drop-down list using up/down keys and then click it with the mouse. (TFS:78489)
- When the drop down of RibbonComboBox is displayed the ampersands in the items text were not visible if C1Ribbon.VisualStyle is set to Custom.
- A C1RibbonForm displayed with ShowDialog(owner) method closed immediately if its VisualStyle is set to Custom. (TFS:95547)
- Images applied to the items in the Application Menu of C1Ribbon were blurred. (TFS:95594)
- Images applied to the RibbonTab in C1Ribbon got cropped. (TFS:95605)

### Improvements

- Added DisableGlassEffects() static method to C1RibbonForm. To prevent C1RibbonForm from using Aero Glass effects on Windows 7 or better OS you should call this method from app's Program.Main() before the app creates any instances of a C1RibbonForm. (TFS:79279)

## C1.Win.C1Schedule

### Improvements

- added support for RECURRENCE-ID, SEQUENCE and UID in iCal import (TFS:91112). Note, cases when RECURRENCE-ID is a recurring event are not supported.
- improved performance when working with long-lasting appointments (TFS:95610).

## C1.Win.C1SplitContainer

### Bug fixes

- C1SplitterPanel's Width and Height properties returned incorrect values for collapsible panels. (TFS:94234)

## C1.Win.C1Themes

### Improvements

- Background of selected C1FlexGrid column header is changed to make visible difference between non-selected and selected column.(TFS:91144)

## C1.Win.C1TrueDBGrid

### Bug fixes

- RowColChange event did not fired while adding of a row at runtime. (TFS:95345)
- RowColChange event fired twice for the same value, while SetDataBinding() is called after InitializedComponent(). (TFS:95464)
- Single item was not filtered when ValueItem Collection was applied on a Column & ValueMember & DisplayMember were same in column. (TFS:94801)
- "ArgumentOutofRangeException" occurred when clicking the right scroll button of vertical scrollbar in C1TDBDropdown. (TFS:84614)
- Fixe some of the right-to-left grid issues. (TFS:14271)

# Release version 4.0.20143.9 - Nov-11-2014

## All Controls

### Breaking changes

- Added new AboutBox logic and display.
- Implemented new evaluation version logic. The new logic restricts evaluation installs to 30 days.
- All assemblies included in ComponentOne Studio for WinForms now have the same version number which must be kept in sync when using several assemblies in an application.

## C1.C1Excel

### Bug fixes

- Cloned column could not be inserted into other sheet. (TFS:77293)
- Setting FitPageAcross property changed the AutoScale property to true. (TFS:64023)
- Newline character was missing after bold styling. (TFS:85280)
- In some cases styles were not applied in the saved excel book. (TFS:84477)

## C1.C1Pdf

### Bug fixes

- Perhaps fix [Query] An error occurs in azurewebsite when accessing DrawingRtfText and
  rendering Rtf in C1Pdf sample. (TFS:93494)
- Font size was larger and text was cut off when an HTML file was exported to PDF. (TFS:89418)

## C1.C1Report

### Bug fixes

- Text extends outside the field when exported to Pdf with system fonts. (TFS:78659 part 2)
- Export to RTF: MemoryError occurred in the output file if a report with RTF label fields containing Hebrew text was exported to RTF. (TFS:93183)
- Fields with zero height or width used as border lines become hidden in some rare cases. (TFS:89917)

## C1.Win.C1Chart

### Bug fixes

- Improved automatic axis labeling and UnitMajor calculation, making both more stable. (TFS:88594)

## C1.Win.C1Chart3D

### Bug fixes

- Improved ContourMethodEnum=Default calculations involving data holes. (TFS:89056)

### Improvements

- Added ContourMethodEnum.Classic to provide users with a method of obtaining contours with versions prior to 2.0/4.0.20132.23282.
  public enum ContourMethodEnum
  {
  /// <summary>
  /// Default method of contour calculation.
  /// </summary>
  Default,
  /// <summary>
  /// Previous default method of contour calculation prior before recent improvements.
  /// This ContourMethod is provided for compatibility with previous results.
  /// </summary>
  Classic,
  /// <summary>
  /// Method of marching squares that provides an alternate contour calculation.
  /// This method requires an increased number of calculations, but tends to
  /// improve contour symmetry.
  /// </summary>
  MarchingSquares
  }

## C1.Win.C1Command

### Bug fixes

- C1DockingTabPage with CanAutoHide property set to true slided out automatically when its caption was changed. (TFS:47611)

## C1.Win.C1Document

### Bug fixes

- C1DocumentSource.EventsSynchronizationMode was removed, now all synchronization
  with main UI thread should be performed in user code (if needed). (TFS:92830).

### Initial release

- C1.Win.C1Document.C1SSRSDocumentSource generates a document representing an SSRS report (.NET 4.0 version only).

## C1.Win.C1Editor

### Bug fixes

- Table Properties dialog box could not be opened from the context menu. (TFS:92412)
- Exception occurred when clicking OK or Cancel button from the Table Properties dialog box. (TFS:93172)
- XHTML tag did not close when Selection.RemoveTag was used and there was no text to left and right of the caret. (TFS:83772)

## C1.Win.C1FlexGrid

### Bug fixes

- ComboList wasn't capturing first keystroke correctly when typing very fast. (TFS:75983)
- When Enter was pressed in a cell with a combobox, the combobox opened immediately. Now this does not happen, user needs to press F4 to open the combobox. (TFS:92518)
- OwnerDrawCell event was firing in some cases where it shouldn't. (TFS:76245)
- Clicking the top left cell did not always select the whole grid. (TFS:90372)
- ComboCloseUp event was not always firing. (TFS:89815)
- Improved memory handling when loading large XLSX files. (TFS:90264)
- Fixed: when selecting a row by clicking on a cell, the tooltip was shown. (TFS:68985)
- Fixed: C1FlexGrid's tooltip were shown behind the DropDownForm. (TFS:72555)

## C1.Win.C1Input

### Bug fixes

- Duplicate entries "Basa Jawa (Indonesia)" are observed in Culture dropdown in PropertyGrid of C1DateEdit (TFS:91700)
- C1ComboBox is not looped ComboBoxItem on spin action by Up/Down arrow keys when AllowSpinLoop=True (TFS:91567)
- Selection of Date is shown as twice in CalendarDimensions when the number of columns and rows of months is more than one. (TFS:93489)
- C1ComboBox could not select item after delete. (TFS:87255)

### Improvements

- Focus Move
  C1TextBox.ExitOnLastChar - Move focus after input completely, i.e. either Text length reached MaxLength or mask is filled completely.
  C1TextBox.ExitOnLeftRightKey - Move focus by arrow key.
- Length control
  MaxLengthUnit property - Determines the unit for counting for the MaxLength property.
  MaxLineCount - Maximum numbers of lines
- New property CharCategory
  Defines rules to filter keyboard input.
  Example:
  // Allows only numbers in hiragana
  this.c1TextBox1.CharCategory = CharCategory.Hiragana | CharCategory.Numbers;
  // Converts input to single byte.
  this.c1TextBox1.CharCategory = CharCategory.SingleByte | CharCategory.AutoConvert;
- New mask symbols for JPN:
  H All SBCS characters.
  K SBCS Katakana.
  Unicode 0xFF19 DBCS Digit
  Unicode 0xFF2B DBCS Katakana
  Unicode 0xFF2B Hiragana
  Unicode 0xFF3A All DBCS characters.
  N All SBCS big Katakana.
  Unicode 0xFF2E Matches DBCS big Katakana.
  Unicode 0xFF27 Matches DBCS big Hiragana.
  Unicode 0xFF34 Matches surrogate char.
- InvalidInput event - notification for invalid input
- SpinUp and SpinDown
  SpinUp() - Spin up programmatically
  SpinDown() - Spin down programmatically
  AllowSpinLoop - loop items or values on spin action
  Example:
  C1DateEdit1.SpinDown(new TimeSpan(0, 2, 0, 0, 0)); - Spin down by 2 hours.
  c1NumericEdit1.SpinDown(2);- Spin down by 2
- UpDownButtonAlignment - a new property of C1DropDownControl.
  Defines spin alignment. Now can be sidewise.
- Specific JPN formats support in C1DateEdit.
  g. - Display the era name in alphabet (M, T, S, H).
  g - Display the first character (DBCS) era
  gg - Display the full (DBCS) era
  Note1: to display a negro year:
  1. Select Japanese Culture;
  2. Select JapaneseCalendar for CalendarType property;
  3. Use 'y' or 'yy' specifiers to show the negro year number.
  Note2: It is impossible to use both Gregorian and Japanese years in a format.
  I.e. formats like "E, MMMM d, yy" won't work.
- Specific calendars support (JapaneseCalendar, GregorianCalendar, etc.)
  CalendarType property.

## C1.Win.C1List

### Bug fixes

- If C1List's SelectionMode is set to CheckBox, then on clicking checkbox to select, unselect, and select the same item again the RowChange event does not fire. (TFS:70544)

## C1.Win.C1Report

### Improvements

- C1.Win.C1Document.C1SSRSDocumentSource is recognized as a valid C1PrintPreviewControl.Document property value. If dropped on a form, a C1SSRSDocumentSource allows to preview a paginated SSRS report (.NET 4.0 version only).

## C1.Win.C1Ribbon

### Bug fixes

- Maximized C1RibbonForm with Custom visual style was flickering when any drop-down was shown/closed. (TFS:93673)
- Form did not minimize correctly when using Windows+M keys while opening dropdown of some Ribbon component. (TFS:83719)
- While minimizing and restoring C1RibbonForm, a black rectangle area appeared in the top left corner of C1RibbonForm. (TFS:89700)
- RibbonItem was not removed from QAT when parent RibbonGroup was hidden. (TFS:88436)
- ToolTip Editor crashed under some conditions. (TFS:89916)

### Improvements

- Added support for increased system DPI. (TFS:49299)
- Fixed an issue that prevented using ContentAreaHeight theme constant. (TFS:60907)

## C1.Win.C1Sizer

### Bug fixes

- If C1SizerLight was placed and then deleted from a Form, all contained controls were resized proportionally on resizing the form at design time. (TFS:90983)

## C1.Win.C1SpellChecker

### Bug fixes

- C1SpellChecker causing application to freeze when the user types "<<". (TFS:92875)
- NullReferenceException occurs in C1.Win.C1SpellChecker.dll (TFS:93566)

## C1.Win.C1SuperTooltip

### Bug fixes

- SuperLabel's BackColor, ForeColor, Font were not inherited from corresponding properties of parent control. (TFS:46997)

## C1.Win.C1TouchToolKit

### Bug fixes

- If C1Zoom's AllowResizeByZoom is set to true then setting ZoomFactor to some value does not resize form, resize content only. (TFS:89340)

## C1.Win.C1TrueDBGrid

### Bug fixes

- Incorrect behavior of FilterDefinition property of C1TrueDBGrid when the filter is saved and loaded again (TFS:91705)
- CellTip shows incorrect behavior when it contains a long text and 'CellTipWidth' property is set (TFS:88713)
- RadioButton does not align in center properly while using C1.Win.C1TrueDBGrid.AlignHorzEnum.Center (TFS:38114)

## C1.Win.Olap

### Breaking changes

- The .NET 2.0 version assembly name changed to "C1.Win.Olap.2" (was "C1.Win.Olap").

### Improvements

- Added auto scroll bar to C1OlapChart.

## ComponentOne WinForms Basic Library

### Initial release

- ComponentOne WinForms Basic Library provides common types and services used by other C1 Studio for WinForms assemblies.

## Studio for WinForms Apps (Report and Theme Designers etc.)

### Breaking changes

- Starting with the 2014v3 release, all ComponentOne WinForms applications (C1Report and C1Theme designers, C1dView application etc.) are installed together in the same folder (.NET version-specific), and need to be updated together.